 -- RingSlingerPlus
 -- 1-RSP_Global.lua
 -- 12.07.2023
 -- Sirexer
 
rawset(_G, "RSP", {})

RSP.DATA = {}
RSP.DATA.getready = true
RSP.DATA.round_ready = false
RSP.DATA.round_over = false
RSP.DATA.playertable = {}
RSP.DATA.playertablelive = {}
RSP.DATA.readytimer = 0
RSP.DATA.winner = false
RSP.DATA.lose = false
RSP.DATA.headhunt = false
RSP.DATA.hh = false

freeslot(
	"SPR_DMSP", "MT_DMSPAWNPOINT", "S_DMSPAWNPOINT",
	"SPR_PIAM", "MT_PICKUPAMMO", "S_PICKUPAMMO",
	"S_DISABLEOBJECT",
	"MT_RSPIT", "S_RSPIT",
	"MT_RSPHEADHUNT", "S_RSPHEADHUNT",
	"S_RSPGHOST")
	
freeslot("sfx_insshi", "sfx_rspkil", "sfx_rsphtt", "sfx_rspht0", "sfx_rspht1", "sfx_rspht2", "sfx_rspht3")

//Spawnpoint object.
mobjinfo[MT_DMSPAWNPOINT] = {
        doomednum = -1,
        spawnstate = S_DMSPAWNPOINT,
        spawnhealth = 1000,
        reactiontime = 5,
        speed = 0,
        radius = 16*FRACUNIT,
        height = 48*FRACUNIT,
        mass = 1000,
        flags = MF_FLOAT
}

states[S_DMSPAWNPOINT] = {
        sprite = SPR_DMSP,
        frame = FF_FULLBRIGHT|TR_TRANS70|FF_ANIMATE|A,
        tics = -1,
        var1 = 7,
        var2 = 5,
        nextstate = S_DMSPAWNPOINT
}

//Ammo Pack object.
mobjinfo[MT_PICKUPAMMO] = {
		doomednum = -1,
		spawnstate = S_PICKUPAMMO,
		deathstate = S_SPRK1,
		deathsound = sfx_ncitem,
		spawnhealth = 1000,
		reactiontime = 5,
		speed = 8*FRACUNIT,
		radius = 16*FRACUNIT,
		height = 64*FRACUNIT,
		mass = 100,
		damage = 2*TICRATE,
		flags = MF_SPECIAL|MF_NOBLOCKMAP|MF_GRENADEBOUNCE|MF_BOUNCE
}

states[S_PICKUPAMMO] = {
		sprite = SPR_PIAM,
		frame = FF_ANIMATE|A,
		tics = 15*FRACUNIT,
		var1 = 15,
		var2 = 1,
		nextstate = S_NULL
}

mobjinfo[MT_RSPIT] = {
        doomednum = -1,
        spawnstate = S_RSPIT,
        spawnhealth = 1000,
        reactiontime = 5,
        speed = 0,
        radius = 16*FRACUNIT,
        height = 48*FRACUNIT,
        mass = 1000,
        flags = MF_NOGRAVITY|MF_NOCLIP
}

//Invisible objects.
states[S_DISABLEOBJECT] = {
		sprite = SPR_NONE,
		tics = -1,
		var1 = 0,
		var2 = 0,
		nextstate = S_DISABLEOBJECT
}
//Target IT
states[S_RSPIT] = {
		sprite = SPR_TTAG,
		frame = FF_FULLBRIGHT|A,
		tics = -1
}

states[S_RSPGHOST] = {
		sprite = SPR_UNID,
		frame = FF_FULLBRIGHT|A,
		tics = -1,
		nextstate = S_NULL
}
//Target HH
mobjinfo[MT_RSPHEADHUNT] = {
        doomednum = -1,
        spawnstate = S_RSPHEADHUNT,
        spawnhealth = 1000,
        reactiontime = 5,
        speed = 0,
        radius = 16*FRACUNIT,
        height = 48*FRACUNIT,
        mass = 1000,
        flags = MF_NOGRAVITY|MF_NOCLIP
}

states[S_RSPHEADHUNT] = {
		sprite = SPR_LCKN,
		frame = FF_FULLBRIGHT|A,
		tics = -1
}

//Weapon HUD for RSP
RSP.hud = {}

RSP.hud[0] = {
	name = "vanilla",
	curweap = "CURWEAP",
	curshift = "top",
	cur_p = 2*FRACUNIT,
	count_ammo_x = 16,
	count_ammo_y = 8,
	align_ammo = "thin-right",
	gt_message_x = 160,
	gt_message_y = 156,
	duelshift = 0,
	button_x = 260,
	button_y = 40,
	button_flags = V_SNAPTORIGHT|V_SNAPTOBOTTOM,
	v_score = true,
	v_time = true,
	v_rings = true,
	v_lives = true,
	v_teamscores = true,
	v_powerstones = true,
	["weapons"] = {
		-- infinity/ring
		[0] = {
		x = 92*FRACUNIT,
		y = 176*FRACUNIT,
		scale = FRACUNIT,
		patch = "RINGIND",
		extrapatch = "INFNIND",
		flags = V_SNAPTOBOTTOM
		},
		-- autoring
		[1] = {
		x = 112*FRACUNIT,
		y = 176*FRACUNIT,
		scale = FRACUNIT,
		patch = "AUTOIND",
		flags = V_SNAPTOBOTTOM
		},
		-- bounce ring
		[2] = {
		x = 132*FRACUNIT,
		y = 176*FRACUNIT,
		scale = FRACUNIT,
		patch = "BNCEIND",
		flags = V_SNAPTOBOTTOM
		},
		-- statter ring
		[3] = {
		x = 152*FRACUNIT,
		y = 176*FRACUNIT,
		scale = FRACUNIT,
		patch = "SCATIND",
		flags = V_SNAPTOBOTTOM
		},
		-- grenade ring
		[4] = {
		x = 172*FRACUNIT,
		y = 176*FRACUNIT,
		scale = FRACUNIT,
		patch = "GRENIND",
		flags = V_SNAPTOBOTTOM
		},
		-- bomb ring
		[5] = {
		x = 192*FRACUNIT,
		y = 176*FRACUNIT,
		scale = FRACUNIT,
		patch = "BOMBIND",
		flags = V_SNAPTOBOTTOM
		},
		-- rail ring
		[6] = {
		x = 212*FRACUNIT,
		y = 176*FRACUNIT,
		scale = FRACUNIT,
		patch = "RAILIND",
		flags = V_SNAPTOBOTTOM
		}
	}
}

RSP.hud[1] = {
	name = "quake",
	curweap = "RSPCWQ1",
	curshift = "top",
	cur_p = 0,
	count_ammo_x = 23,
	count_ammo_y = 5,
	align_ammo = "thin-center",
	gt_message_x = 160,
	gt_message_y = 136,
	duelshift = 0,
	button_x = 260,
	button_y = 40,
	button_flags = V_SNAPTORIGHT|V_SNAPTOBOTTOM,
	v_score = false,
	v_time = false,
	v_rings = false,
	v_lives = false,
	v_teamscores = false,
	v_powerstones = false,
	["weapons"] = {
		
		[0] = {
		x = 32*FRACUNIT,
		y = 152*FRACUNIT,
		scale = FRACUNIT,
		patch = "RINGIND",
		extrapatch = "INFNIND",
		flags = V_SNAPTOBOTTOM
		},
		
		[1] = {
		x = 64*FRACUNIT,
		y = 152*FRACUNIT,
		scale = FRACUNIT,
		patch = "AUTOIND",
		flags = V_SNAPTOBOTTOM
		},
		
		[2] = {
		x = 96*FRACUNIT,
		y = 152*FRACUNIT,
		scale = FRACUNIT,
		patch = "BNCEIND",
		flags = V_SNAPTOBOTTOM
		},
		
		[3] = {
		x = 128*FRACUNIT,
		y = 152*FRACUNIT,
		scale = FRACUNIT,
		patch = "SCATIND",
		flags = V_SNAPTOBOTTOM
		},
		
		[4] = {
		x = 160*FRACUNIT,
		y = 152*FRACUNIT,
		scale = FRACUNIT,
		patch = "GRENIND",
		flags = V_SNAPTOBOTTOM
		},
		
		[5] = {
		x = 192*FRACUNIT,
		y = 152*FRACUNIT,
		scale = FRACUNIT,
		patch = "BOMBIND",
		flags = V_SNAPTOBOTTOM
		},
		
		[6] = {
		x = 224*FRACUNIT,
		y = 152*FRACUNIT,
		scale = FRACUNIT,
		patch = "RAILIND",
		flags = V_SNAPTOBOTTOM
		}
	},
	
	["emeralds"] = {
	
		[0] = {
		x = 18*FRACUNIT,
		y = 152*FRACUNIT,
		scale = FRACUNIT,
		patch = "TEMER1",
		flags = V_SNAPTOBOTTOM,
		flagname = EMERALD1
		},
		
		[1] = {
		x = 24*FRACUNIT,
		y = 158*FRACUNIT,
		scale = FRACUNIT,
		patch = "TEMER2",
		flags = V_SNAPTOBOTTOM,
		flagname = EMERALD2
		},
		
		[2] = {
		x = 18*FRACUNIT,
		y = 164*FRACUNIT,
		scale = FRACUNIT,
		patch = "TEMER3",
		flags = V_SNAPTOBOTTOM,
		flagname = EMERALD3
		},
		
		[3] = {
		x = 24*FRACUNIT,
		y = 170*FRACUNIT,
		scale = FRACUNIT,
		patch = "TEMER4",
		flags = V_SNAPTOBOTTOM,
		flagname = EMERALD4
		},
		
		[4] = {
		x = 18*FRACUNIT,
		y = 176*FRACUNIT,
		scale = FRACUNIT,
		patch = "TEMER5",
		flags = V_SNAPTOBOTTOM,
		flagname = EMERALD5
		},
		
		[5] = {
		x = 24*FRACUNIT,
		y = 182*FRACUNIT,
		scale = FRACUNIT,
		patch = "TEMER6",
		flags = V_SNAPTOBOTTOM,
		flagname = EMERALD6
		},
		
		[6] = {
		x = 18*FRACUNIT,
		y = 188*FRACUNIT,
		scale = FRACUNIT,
		patch = "TEMER7",
		flags = V_SNAPTOBOTTOM,
		flagname = EMERALD7
		}
	}
}

RSP.hud[2] = {
	name = "slim",
	curweap = "CURWEAP",
	curshift = "left",
	cur_p = 2*FRACUNIT,
	count_ammo_x = 16,
	count_ammo_y = 8,
	align_ammo = "thin-right",
	gt_message_x = 160,
	gt_message_y = 156,
	duelshift = 2,
	button_x = 240,
	button_y = 40,
	button_flags = V_SNAPTORIGHT|V_SNAPTOBOTTOM,
	v_score = false,
	v_time = false,
	v_rings = false,
	v_lives = false,
	v_teamscores = false,
	v_powerstones = false,
	["weapons"] = {
		
		[0] = {
		x = 300*FRACUNIT,
		y = 20*FRACUNIT,
		scale = FRACUNIT,
		patch = "RINGIND",
		extrapatch = "INFNIND",
		flags = V_SNAPTOBOTTOM|V_SNAPTORIGHT
		},
		
		[1] = {
		x = 300*FRACUNIT,
		y = 40*FRACUNIT,
		scale = FRACUNIT,
		patch = "AUTOIND",
		flags = V_SNAPTOBOTTOM|V_SNAPTORIGHT
		},
		
		[2] = {
		x = 300*FRACUNIT,
		y = 60*FRACUNIT,
		scale = FRACUNIT,
		patch = "BNCEIND",
		flags = V_SNAPTOBOTTOM|V_SNAPTORIGHT
		},
		
		[3] = {
		x = 300*FRACUNIT,
		y = 80*FRACUNIT,
		scale = FRACUNIT,
		patch = "SCATIND",
		flags = V_SNAPTOBOTTOM|V_SNAPTORIGHT
		},
		
		[4] = {
		x = 300*FRACUNIT,
		y = 100*FRACUNIT,
		scale = FRACUNIT,
		patch = "GRENIND",
		flags = V_SNAPTOBOTTOM|V_SNAPTORIGHT
		},
		
		[5] = {
		x = 300*FRACUNIT,
		y = 120*FRACUNIT,
		scale = FRACUNIT,
		patch = "BOMBIND",
		flags = V_SNAPTOBOTTOM|V_SNAPTORIGHT
		},
		
		[6] = {
		x = 300*FRACUNIT,
		y = 140*FRACUNIT,
		scale = FRACUNIT,
		patch = "RAILIND",
		flags = V_SNAPTOBOTTOM|V_SNAPTORIGHT
		}
	},
	
	["emeralds"] = {
	
		[0] = {
		x = 0*FRACUNIT,
		y = 144*FRACUNIT,
		scale = FRACUNIT,
		patch = "TEMER1",
		flags = V_SNAPTOBOTTOM|V_SNAPTOLEFT,
		flagname = EMERALD1
		},
		
		[1] = {
		x = 0*FRACUNIT,
		y = 152*FRACUNIT,
		scale = FRACUNIT,
		patch = "TEMER2",
		flags = V_SNAPTOBOTTOM|V_SNAPTOLEFT,
		flagname = EMERALD2
		},
		
		[2] = {
		x = 0*FRACUNIT,
		y = 160*FRACUNIT,
		scale = FRACUNIT,
		patch = "TEMER3",
		flags = V_SNAPTOBOTTOM|V_SNAPTOLEFT,
		flagname = EMERALD3
		},
		
		[3] = {
		x = 0*FRACUNIT,
		y = 168*FRACUNIT,
		scale = FRACUNIT,
		patch = "TEMER4",
		flags = V_SNAPTOBOTTOM|V_SNAPTOLEFT,
		flagname = EMERALD4
		},
		
		[4] = {
		x = 0*FRACUNIT,
		y = 176*FRACUNIT,
		scale = FRACUNIT,
		patch = "TEMER5",
		flags = V_SNAPTOBOTTOM|V_SNAPTOLEFT,
		flagname = EMERALD5
		},
		
		[5] = {
		x = 0*FRACUNIT,
		y = 184*FRACUNIT,
		scale = FRACUNIT,
		patch = "TEMER6",
		flags = V_SNAPTOBOTTOM|V_SNAPTOLEFT,
		flagname = EMERALD6
		},
		
		[6] = {
		x = 0*FRACUNIT,
		y = 192*FRACUNIT,
		scale = FRACUNIT,
		patch = "TEMER7",
		flags = V_SNAPTOBOTTOM|V_SNAPTOLEFT,
		flagname = EMERALD7
		}
	}
}

//Colors for player name
RSP.chatcolors = {}
RSP.chatcolors[0] = "\x80" -- White
RSP.chatcolors[4096] = "\x81" -- Magenta
RSP.chatcolors[8192] = "\x82" -- Yellow
RSP.chatcolors[12288] = "\x83" -- Green
RSP.chatcolors[16384] = "\x84" -- Blue
RSP.chatcolors[20480] = "\x85" -- Red
RSP.chatcolors[24576] = "\x86" -- Grey
RSP.chatcolors[28672] = "\x87" -- Orange
RSP.chatcolors[32768] = "\x88" -- Sky
RSP.chatcolors[36864] = "\x89" -- Purple
RSP.chatcolors[40960] = "\x8A" -- Aqua
RSP.chatcolors[45056] = "\x8B" -- Peridot
RSP.chatcolors[49152] = "\x8C" -- Azure
RSP.chatcolors[53248] = "\x8D" -- Brown
RSP.chatcolors[57344] = "\x8E" -- Rosy
RSP.chatcolors[61440] = "\x8F" -- Inverted

//buttons for RSP.
RSP.buttons = {
	["none"] = {
	button = 0,
	name = " "
	},
	["firenormal"] = {
	button = BT_FIRENORMAL,
	name = "FN",
	fullname = "FIRENORMAL"
	},
	["tossflag"] = {
	button = BT_TOSSFLAG,
	name = "TF",
	fullname = "TOSSFLAG"
	},
	["custom1"] = {
	button = BT_CUSTOM1,
	name = "C1",
	fullname = "CUSTOM1"
	},
	["custom2"] = {
	button = BT_CUSTOM2,
	name = "C2",
	fullname = "CUSTOM2"
	},
	["custom3"] = {
	button = BT_CUSTOM3,
	name = "C3",
	fullname = "CUSTOM3"
	},
	["nextweapon"] = {
	button = BT_WEAPONNEXT,
	name = "WN",
	fullname = "WEAPONNEXT"
	},
	["prevweapon"] = {
	button = BT_WEAPONPREV,
	name = "WP",
	fullname = "WEAPONPREV"
	}
}

RSP.Flags = {
	["blue"] = true,
	["red"] = true
}

//Server commands.
rawset(_G, "ffastarterammo", {value = 1})
rawset(_G, "ffastarterammo", CV_RegisterVar({
	name = "rsp_ammoffa",
	defaultvalue = 1,
	flags = CV_NETVAR|CV_CALL|CV_CHEAT|CV_NOINIT,
	PossibleValue = {MIN = 0, MAX = 10},
	func = function()
		if leveltime >= 1 and multiplayer
			if ffastarterammo.value == 0
				print("\x8F\RSP: \x86\Players\x80\ will not have ammo after respawn.")
			end
			if cv_rspspawnpoint.value >= 1
				print("\x8F\RSP: \x86\Players\x80\ will have\x83\ "..ffastarterammo.value.."\x80\ times more ammo after respawn.")
			end
		end
	end,
}))

rawset(_G, "cv_keepweapons", {value = 0})
rawset(_G, "cv_keepweapons", CV_RegisterVar({
	name = "rsp_keepweapons",
	defaultvalue = "Off",
	flags = CV_NETVAR|CV_CALL|CV_NOINIT,
	PossibleValue = CV_OnOff,
	func = function()
		if leveltime >= 1 and multiplayer
			if cv_keepweapons.value == 0
				print("\x8F\RSP: \x82rsp_keepweapons\x80\ is \x85\disabled.")
			end
			if cv_keepweapons.value == 1
				print("\x8F\RSP: \x82rsp_keepweapons\x80\ is \x83\enabled.")
			end
		end
	end,
}))

rawset(_G, "cv_rbenabled", {value = 1})
rawset(_G, "cv_rbenabled", CV_RegisterVar({
	name = "rsp_railboost",
	defaultvalue = "On",
	flags = CV_NETVAR|CV_CALL|CV_NOINIT,
	PossibleValue = CV_OnOff,
	func = function()
		if leveltime >= 1 and multiplayer
			if cv_rbenabled.value == 0
				print("\x8F\RSP: \x82rsp_railboost\x80\ is \x85\disabled.")
			end
			if cv_rbenabled.value == 1
				print("\x8F\RSP: \x82rsp_railboost\x80\ is \x83\enabled.")
			end
		end
	end,
}))

rawset(_G, "railboost_power", {value = 16})
rawset(_G, "railboost_power", CV_RegisterVar({
	name = "rsp_rbpower",
	defaultvalue = 32,
	flags = CV_NETVAR|CV_CALL|CV_CHEAT|CV_NOINIT,
	PossibleValue = {MIN = 1, MAX = 99},
	func = function()
		if leveltime >= 1 and multiplayer
			if railboost_power.value == 0
				print("\x8F\RSP: \x82rsp_rbpower\x80\ is\x85\ "..railboost_power.value..".")
			end
			if railboost_power.value == 1
				print("\x8F\RSP: \x82rsp_rbpower\x80\ is\x83\ "..railboost_power.value..".")
			end
		end
	end,
}))

rawset(_G, "cv_rjenabled", {value = 1})
rawset(_G, "cv_rjenabled", CV_RegisterVar({
	name = "rsp_rocketjump",
	defaultvalue = "On",
	flags = CV_NETVAR|CV_CALL|CV_NOINIT,
	PossibleValue = CV_OnOff,
	func = function()
		if leveltime >= 1 and multiplayer
			if cv_rjenabled.value == 0
				print("\x8F\RSP: \x82rsp_rocketjump\x80\ is \x85\disabled.")
			end
			if cv_rjenabled.value == 1
				print("\x8F\RSP: \x82rsp_rocketjump\x80\ is \x83\enabled.")
			end
		end
	end,
}))

rawset(_G, "rocketjump_power", {value = 16})
rawset(_G, "rocketjump_power", CV_RegisterVar({
	name = "rsp_rjpower",
	defaultvalue = 16,
	flags = CV_NETVAR|CV_CALL|CV_CHEAT|CV_NOINIT,
	PossibleValue = {MIN = 1, MAX = 99},
	func = function()
		if leveltime >= 1 and multiplayer
			if rocketjump_power.value == 0
				print("\x8F\RSP: \x82rsp_rjpower\x80\ is\x85\ "..rocketjump_power.value..".")
			end
			if rocketjump_power.value != 0
				print("\x8F\RSP: \x82rsp_rjpower\x80\ is\x83\ "..rocketjump_power.value..".")
			end
		end
	end,
}))

rawset(_G, "cv_timerexplosion", {value = 210})
rawset(_G, "cv_timerexplosion", CV_RegisterVar({
	name = "rsp_timerexplosion",
	defaultvalue = 210,
	flags = CV_NETVAR|CV_CALL|CV_CHEAT|CV_NOINIT,
	PossibleValue = {MIN = 0, MAX = 210},
	func = function()
		if leveltime >= 1 and multiplayer
			if cv_timerexplosion.value == 0
				print("\x8F\RSP: \x82rsp_timerexplosion\x80\ is\x85\ "..cv_timerexplosion.value.." in tics.")
			end
			if cv_timerexplosion.value >= 1
				print("\x8F\RSP: \x82rsp_timerexplosion\x80\ is\x83\ "..cv_timerexplosion.value.." in tics. In seconds\x83\ "..(cv_timerexplosion.value/TICRATE)..".")
			end
		end
	end,
}))

rawset(_G, "cv_instagib", {value = 0})
rawset(_G, "cv_instagib", CV_RegisterVar({
	name = "rsp_instagib_mode",
	defaultvalue = "Off",
	flags = CV_NETVAR|CV_CALL|CV_NOINIT,
	PossibleValue = CV_OnOff,
	func = function()
		local serverornil = isdedicatedserver and nil or server
		if leveltime >= 1 and multiplayer
			if cv_instagib.value == 0
				print("\x8F\RSP: \x82rsp_instagib_mode\x80\ is \x85\disabled.")
			end
			if cv_instagib.value == 1
				print("\x8F\RSP: \x82rsp_instagib_mode\x80\ is \x83\enabled.")
			end
			COM_BufInsertText(serverornil, "map "..gamemap.." -silent")
		end
	end,
}))

rawset(_G, "cv_instashield", {value = 1})
rawset(_G, "cv_instashield", CV_RegisterVar({
	name = "rsp_instashield",
	defaultvalue = "On",
	flags = CV_NETVAR|CV_CALL|CV_NOINIT,
	PossibleValue = CV_OnOff,
	func = function()
		if leveltime >= 1 and multiplayer
			if cv_instashield.value == 0
				print("\x8F\RSP: \x82rsp_instashield\x80\ is \x85\disabled.")
			end
			if cv_instashield.value == 1
				print("\x8F\RSP: \x82rsp_instashield\x80\ is \x83\enabled.")
			end
		end
	end,
}))

rawset(_G, "cv_allowshield", {value = 1})
rawset(_G, "cv_allowshield", CV_RegisterVar({
	name = "rsp_allowshield",
	defaultvalue = "On",
	flags = CV_NETVAR|CV_CALL|CV_NOINIT,
	PossibleValue = CV_OnOff,
	func = function()
			if leveltime >= 1 and multiplayer
			if cv_allowshield.value == 0
				print("\x8F\RSP: \x82rsp_allowshield\x80\ is \x85\disabled.")
			end
			if cv_allowshield.value == 1
				print("\x8F\RSP: \x82rsp_allowshield\x80\ is \x83\enabled.")
			end
		end
	end,
}))

rawset(_G, "cv_autojump", {value = 1})
rawset(_G, "cv_autojump", CV_RegisterVar({
	name = "rsp_allowautojump",
	defaultvalue = "On",
	flags = CV_NETVAR|CV_CALL|CV_NOINIT,
	PossibleValue = CV_OnOff,
	func = function()
		if leveltime >= 1 and multiplayer
			if cv_autojump.value == 0
				print("\x8F\RSP: \x82rsp_allowautojump\x80\ is \x85\disabled.")
			end
			if cv_autojump.value == 1
				print("\x8F\RSP: \x82rsp_allowautojump\x80\ is \x83\enabled.")
			end
		end
	end,
}))

rawset(_G, "cv_rspsuddendeath", {value = 0})
rawset(_G, "cv_rspsuddendeath", CV_RegisterVar({
	name = "rsp_suddendeath",
	defaultvalue = "Off",
	flags = CV_NETVAR|CV_CALL|CV_CHEAT|CV_NOINIT,
	PossibleValue = CV_OnOff,
	func = function()
		if leveltime >= 1 and multiplayer
			if cv_rspsuddendeath.value == 0
				print("\x8F\RSP: \x82rsp_suddendeath\x80\ is \x85\disabled.")
			end
			if cv_rspsuddendeath.value == 1
				print("\x8F\RSP: \x82rsp_suddendeath\x80\ is \x83\enabled.")
			end
		end
	end,
}))

rawset(_G, "cv_rsptimelimit", {value = 10})
rawset(_G, "cv_rsptimelimit", CV_RegisterVar({
	name = "rsp_timelimit",
	defaultvalue = 10,
	flags = CV_NETVAR|CV_CALL|CV_NOINIT,
	PossibleValue = {MIN = 0, MAX = 60},
	func = function()
		local serverornil = isdedicatedserver and nil or server
		if leveltime >= 1 and multiplayer
			if cv_rsptimelimit.value == 0
				print("\x8F\RSP: \x82rsp_timelimit\x80\ is\x85\ "..cv_rsptimelimit.value..".")
				if RSP.DATA.round_ready == true
					COM_BufInsertText(serverornil, "timelimit "..cv_rsptimelimit.value)
				end
			end
			if cv_rsptimelimit.value >= 1
				print("\x8F\RSP: \x82rsp_timelimit\x80\ is\x83\ "..cv_rsptimelimit.value..".")
				if RSP.DATA.round_ready == true
					COM_BufInsertText(serverornil, "timelimit "..cv_rsptimelimit.value)
				end
			end
		end
	end,
}))

rawset(_G, "cv_rspgetready", {value = 15})
rawset(_G, "cv_rspgetready", CV_RegisterVar({
	name = "rsp_getreadytimer",
	defaultvalue = 15,
	flags = CV_NETVAR|CV_CALL|CV_NOINIT,
	PossibleValue = {MIN = 0, MAX = 60},
	func = function()
		if leveltime >= 1 and multiplayer
			print("\x8F\RSP: \x82rsp_getreadytimer\x80\ is\x83\ "..cv_rspgetready.value..".")
		end
	end,
}))

rawset(_G, "cv_explodeplayertimer", {value = 15})
rawset(_G, "cv_explodeplayertimer", CV_RegisterVar({
	name = "rsp_killplayertimer",
	defaultvalue = 15,
	flags = CV_NETVAR|CV_CALL|CV_NOINIT,
	PossibleValue = {MIN = 5, MAX = 60},
	func = function()
		if leveltime >= 1 and multiplayer
			print("\x8F\RSP: \x82rsp_killplayertimer\x80\ is\x83\ "..cv_explodeplayertimer.value..".")
		end
	end,
}))

rawset(_G, "cv_rspwfp", {value = 2})
rawset(_G, "cv_rspwfp", CV_RegisterVar({
	name = "rsp_waitforplayers",
	defaultvalue = 2,
	flags = CV_NETVAR|CV_CALL|CV_NOINIT,
	PossibleValue = {MIN = 1, MAX = 32},
	func = function()
		if leveltime >= 1 and multiplayer
			print("\x8F\RSP: \x82rsp_waitforplayers\x80\ is\x83\ "..cv_rspwfp.value..".")
		end
	end,
}))

rawset(_G, "cv_rspdebug", {value = 0})
rawset(_G, "cv_rspdebug", CV_RegisterVar({
	name = "rsp_debug",
	defaultvalue = "Off",
	flags = CV_NETVAR|CV_CALL|CV_CHEAT|CV_NOINIT,
	PossibleValue = CV_OnOff,
	func = function()
		if leveltime >= 1 and multiplayer
			if cv_rspdebug.value == 0
				print("\x8F\RSP: \x82rsp_debug\x80\ is \x85\disabled.")
			end
			if cv_rspdebug.value == 1
				print("\x8F\RSP: \x82rsp_debug\x80\ is \x83\enabled.")
				print("\x8F\RSP:\x85 WARNING!\x80 This mode for developer, to find bugs. the game might crash.")
			end
		end
	end,
}))

rawset(_G, "cv_rsplimitpa", {value = 250})
rawset(_G, "cv_rsplimitpa", CV_RegisterVar({
	name = "rsp_arena_limitpoint",
	defaultvalue = 250,
	flags = CV_NETVAR|CV_CALL|CV_NOINIT,
	PossibleValue = {MIN = 0, MAX = 5000},
	func = function()
		if leveltime >= 1 and multiplayer
			if cv_rsplimitpa.value != 0
				print("\x8F\RSP: \x82rsp_arena_limitpoint\x80\ is\x83\ "..cv_rsplimitpa.value..".")
			end
			if cv_rsplimitpa.value == 0
				print("\x8F\RSP: \x82rsp_arena_limitpoint\x80\ is\x85\ "..cv_rsplimitpa.value..".")
			end
		end
	end,
}))

rawset(_G, "cv_rsplimitta", {value = 2})
rawset(_G, "cv_rsplimitta", CV_RegisterVar({
	name = "rsp_arena_limittime",
	defaultvalue = 2,
	flags = CV_NETVAR|CV_CALL|CV_NOINIT,
	PossibleValue = {MIN = 1, MAX = 20},
	func = function()
		if leveltime >= 1 and multiplayer
			if cv_rsplimitta.value != 0
				print("\x8F\RSP: \x82rsp_arena_limittime\x80\ is\x83\ "..cv_rsplimitta.value..".")
			end
			if cv_rsplimitta.value == 0
				print("\x8F\RSP: \x82rsp_arena_limittime\x80\ is\x85\ "..cv_rsplimitta.value..".")
			end
		end
	end,
}))

rawset(_G, "cv_allowability", {value = 1})
rawset(_G, "cv_allowability", CV_RegisterVar({
	name = "rsp_allowability",
	defaultvalue = 1,
	flags = CV_NETVAR|CV_CALL|CV_CHEAT|CV_NOINIT,
	PossibleValue = CV_OnOff,
	func = function()
		if leveltime >= 1 and multiplayer
			if cv_allowability.value == 1
				print("\x8F\RSP: \x82rsp_allowability\x80\ is\x83\ Enabled.")
				for player in players.iterate do
					player.charability = skins[player.skin].ability
					if not (player.charflags & SF_NOJUMPSPIN)
						player.charflags = $ + SF_NOJUMPSPIN
					end
					if not (player.charflags & SF_NOJUMPDAMAGE)
						player.charflags = $ + SF_NOJUMPDAMAGE
					end
				end
			elseif cv_allowability.value == 0
				print("\x8F\RSP: \x82rsp_allowability\x80\ is\x85\ Disabled.")
			end
		end
	end,
}))

rawset(_G, "cv_allowability2", {value = 1})
rawset(_G, "cv_allowability2", CV_RegisterVar({
	name = "rsp_allowability2",
	defaultvalue = 1,
	flags = CV_NETVAR|CV_CALL|CV_CHEAT|CV_NOINIT,
	PossibleValue = {No = 0, Yes = 1, Dash = 2},
	func = function()
		if leveltime >= 1 and multiplayer
			if cv_allowability2.value == 1
				print("\x8F\RSP: \x82rsp_allowability2\x80\ is\x83\ Enabled.")
				for player in players.iterate do
					player.charability2 = skins[player.skin].ability2
				end
			elseif cv_allowability2.value == 2
				print("\x8F\RSP: \x82rsp_allowability2\x80\ is\x83\ Dash.")
			elseif cv_allowability2.value == 0
				print("\x8F\RSP: \x82rsp_allowability2\x80\ is\x85\ Disabled.")
			end
		end
	end,
}))

rawset(_G, "cv_quickswitching", {value = 1})
rawset(_G, "cv_quickswitching", CV_RegisterVar({
	name = "rsp_quickswitching",
	defaultvalue = 0,
	flags = CV_NETVAR|CV_CALL|CV_NOINIT,
	PossibleValue = CV_OnOff,
	func = function()
		if leveltime >= 1 and multiplayer
			if cv_quickswitching.value != 0
				print("\x8F\RSP: \x82rsp_quickswitching\x80\ is\x83\ Enabled.")
			end
			if cv_quickswitching.value == 0
				print("\x8F\RSP: \x82rsp_quickswitching\x80\ is\x85\ Disabled.")
			end
		end
	end,
}))

rawset(_G, "cv_blowdamage", {value = 10})
rawset(_G, "cv_blowdamage", CV_RegisterVar({
	name = "rsp_blowdamage",
	defaultvalue = 10,
	flags = CV_NETVAR|CV_CALL|CV_NOINIT,
	PossibleValue = {MIN = 0, MAX = 50},
	func = function()
		if leveltime >= 1 and multiplayer
			if cv_blowdamage.value != 0
				print("\x8F\RSP:  \x82rsp_blowdamage\x80\ is\x83\ "..cv_blowdamage.value..".")
			end
			if cv_blowdamage.value == 0
				print("\x8F\RSP:  \x82rsp_blowdamage\x80\ is\x85\ "..cv_blowdamage.value..".")
			end
		end
	end,
}))

rawset(_G, "cv_walljump", {value = 0})
rawset(_G, "cv_walljump", CV_RegisterVar({
	name = "rsp_walljump",
	defaultvalue = 0,
	flags = CV_NETVAR|CV_CALL|CV_NOINIT,
	PossibleValue = CV_OnOff,
	func = function()
		if leveltime >= 1 and multiplayer
			if cv_walljump.value != 0
				print("\x8F\RSP:  \x82rsp_walljump\x80\ is\x83\ Enabled.")
			end
			if cv_walljump.value == 0
				print("\x8F\RSP:  \x82rsp_walljump\x80\ is\x85\ Disabled.")
			end
		end
	end,
}))

rawset(_G, "cv_autofire", {value = 1})
rawset(_G, "cv_autofire", CV_RegisterVar({
	name = "rsp_allowautofire",
	defaultvalue = 1,
	flags = CV_NETVAR|CV_CALL|CV_NOINIT,
	PossibleValue = CV_OnOff,
	func = function()
		if leveltime >= 1 and multiplayer
			if cv_autofire.value != 0
				print("\x8F\RSP:  \x82rsp_allowautofire\x80\ is\x83\ Enabled.")
			end
			if cv_autofire.value == 0
				print("\x8F\RSP:  \x82rsp_allowautofire\x80\ is\x85\ Disabled.")
			end
		end
	end,
}))

rawset(_G, "cv_aarj", {value = 1})
rawset(_G, "cv_aarj", CV_RegisterVar({
	name = "rsp_abilityafterrocketjump",
	defaultvalue = 0,
	flags = CV_NETVAR|CV_CALL|CV_NOINIT,
	PossibleValue = CV_OnOff,
	func = function()
		if leveltime >= 1 and multiplayer
			if cv_aarj.value != 0
				print("\x8F\RSP:  \x82rsp_abilityafterrocketjump\x80\ is\x83\ Enabled.")
			end
			if cv_aarj.value == 0
				print("\x8F\RSP:  \x82rsp_abilityafterrocketjump\x80\ is\x85\ Disabled.")
			end
		end
	end,
}))

//Debug commands.
COM_AddCommand("rsp_ghost", function(player, command)
	if cv_rspdebug.value == 0
		CONS_Printf(player, "This only works in debug mode.")
	else
		if player.rspghostplayer != true
			player.rspghostplayer = true
			CONS_Printf(player, "You're now a ghost!")
		else
			player.rspghostplayer = false
			player.mo.frame = $1 & ~FF_TRANS70
			player.mo.flags = $1 & ~MF_NOCLIPTHING
			player.mo.flags = $1 & ~MF_NOGRAVITY
			player.mo.color = player.skincolor
			player.mo.state = S_PLAY_FALL
			player.mo.colorize = false
			player.mo.shadowscale = FRACUNIT
			player.charability = skins[player.mo.skin].ability
			player.charability2 = skins[player.mo.skin].ability2
			player.jumpfactor = skins[player.mo.skin].jumpfactor
			CONS_Printf(player, "You're no longer a ghost!")
		end
	end
end, 1)

COM_AddCommand("rsp_it", function(player, command)
	if cv_rspdebug.value == 0
		CONS_Printf(player, "This only works in debug mode.")
	else
		if gametype != GT_HOTPOTATO
			CONS_Printf(player, "This only works in HotPotato gametype.")
		else
			if player != player_rspbomb
				player_rspbomb = false
				player_rspbomb = player
			else
				player_rspbomb = false
				if player.warningcolor == true
					player.warningcolor = false
					player.mo.colorized = false
					player.mo.color = player.skincolor
				end
			end
		end
	end
end, 1)

COM_AddCommand("rsp_headhunt", function(player, command)
	if cv_rspdebug.value == 0
		CONS_Printf(player, "This only works in debug mode.")
	else
		if gametype != GT_HEADHUNT
			CONS_Printf(player, "This only works in HeadHunt gametype.")
		else
			if player != RSP.DATA.headhunt
				RSP.DATA.headhunt = false
				RSP.DATA.headhunt = player
			else
				RSP.DATA.headhunt = false
				for mobj in mobjs.iterate()
					if mobj.type == MT_RSPHEADHUNT
						P_RemoveMobj(mobj)
					end
				end
			end
			RSP.DATA.hh = false
		end
	end
end, 1)

//Player commands.
rawset(_G, "cv_rspspawnpoint", {value = 0})
rawset(_G, "cv_rspspawnpoint", CV_RegisterVar({
	name = "rsp_spawnpoint",
	defaultvalue = "Off",
	flags = CV_CALL|CV_NOINIT,
	PossibleValue = CV_OnOff,
	func = function()
		if leveltime >= 1 and multiplayer
			for mobj in mobjs.iterate() do
				if mobj.type == MT_DMSPAWNPOINT
					mobj.state = S_NULL
				end
			end
			for player in players.iterate do
				rsp_viewspawnpoint()
				COM_BufInsertText(player, "rsp_saveplayerconfig")
			end
		end
	end,
}))

rawset(_G, "find_cv_crosshair", CV_FindVar("crosshair"))

COM_AddCommand("rsp_crosshair", function(player, arg)
	if arg == nil
		CONS_Printf(player, "\x82rsp_crosshair\x80 is\x83 \"number\"\x80. Change type of crosshair.")
		if player.rsp_crosshair
			CONS_Printf(player, "\x87rsp_crosshair \x80\is\x83\ "..player.rsp_crosshair)
		end
		return
	end
	if argn == 0
		player.rsp_crosshair = 0
		return
	elseif arg == "a" or arg == "cross"
		player.rsp_crosshair = "a"
		COM_BufInsertText(player, "rsp_saveplayerconfig")
		return
	elseif arg == "b" or arg == "angle"
		player.rsp_crosshair = "b"
		COM_BufInsertText(player, "rsp_saveplayerconfig")
		return
	elseif arg == "c" or arg == "point"
		player.rsp_crosshair = "c"
		COM_BufInsertText(player, "rsp_saveplayerconfig")
		return
	end
	local argn = tonumber(arg)
	if argn
		if (argn >= 0 and argn < 67) or argn == -1
			player.rsp_crosshair = argn
		else
			CONS_Printf(player, "Crosshair "..tostring(argn).." invalid")
		end
		COM_BufInsertText(player, "rsp_saveplayerconfig")
		return
	end
end)

COM_AddCommand("rsp_crosshair_alt", function(player, arg)
	if arg == nil
		CONS_Printf(player, "\rsp_crosshair_alt\x80 is\x83 \"number\"\x80. Change type of crosshair.")
		if player.rsp_crosshair_alt
			CONS_Printf(player, "\rsp_crosshair_alt \x80\is\x83\ "..player.rsp_crosshair_alt)
		end
		return
	end
	if argn == 0
		player.rsp_crosshair_alt = 0
		return
	elseif arg == "a" or arg == "cross"
		player.rsp_crosshair_alt = "a"
		COM_BufInsertText(player, "rsp_saveplayerconfig")
		return
	elseif arg == "b" or arg == "angle"
		player.rsp_crosshair_alt = "b"
		COM_BufInsertText(player, "rsp_saveplayerconfig")
		return
	elseif arg == "c" or arg == "point"
		player.rsp_crosshair_alt = "c"
		COM_BufInsertText(player, "rsp_saveplayerconfig")
		return
	end
	local argn = tonumber(arg)
	if argn
		if (argn >= 0 and argn < 67) or argn == -1
			player.rsp_crosshair_alt = argn
		else
			CONS_Printf(player, "Crosshair "..tostring(argn).." invalid")
		end
		COM_BufInsertText(player, "rsp_saveplayerconfig")
		return
	end
end)

COM_AddCommand("rsp_crosshair_color", function(player, arg)
	if arg == nil
		if player.rsp_crosshair_color == nil or player.rsp_crosshair_color == 0
			CONS_Printf(player, "\x87rsp_crosshair_color \x80\is\x83\ Subtract")
		else
			CONS_Printf(player, "\x87rsp_crosshair_color \x80\is\x83\ "..skincolors[player.rsp_crosshair_color].name)
		end
		return
	end
	local args = arg:lower()
	local argn = tonumber(arg)
	if args == "subtract" or args == "0"
		player.rsp_crosshair_color = 0
		COM_BufInsertText(player, "rsp_saveplayerconfig")
	end
	if argn
		if (argn > 0 and argn < #skincolors) or argn == -1
			player.rsp_crosshair_color = argn
		else
			CONS_Printf(player, "Color "..tostring(argn).." invalid")
		end
		return
	end
	if R_GetColorByName(args)
		player.rsp_crosshair_color = R_GetColorByName(args)
		COM_BufInsertText(player, "rsp_saveplayerconfig")
	end
end)

COM_AddCommand("rsp_crosshair_scale", function(player, arg)
	if arg == nil
		CONS_Printf(player, "\x82rsp_crosshair_scale\x80 is\x83 \"number\"\x80. Change size of crosshair.")
		if player.rsp_crosshair_scale
			CONS_Printf(player, "\x87rsp_crosshair_scale \x80\is\x83\ "..player.rsp_crosshair_scale)
		end
		return
	end
	local argn = tonumber(arg)
	if argn
		if (argn > 0 and argn < 11)
			player.rsp_crosshair_scale = argn
			COM_BufInsertText(player, "rsp_saveplayerconfig")
		else
			CONS_Printf(player, "Crosshair Scale"..tostring(argn).." is too big.")
		end
		return
	end
end)

rawset(_G, "cv_grenadeoptimization", {value = 1})
rawset(_G, "cv_grenadeoptimization", CV_RegisterVar({
	name = "rsp_antilag_grenade",
	defaultvalue = 1,
	flags = CV_NETVAR|CV_CALL|CV_NOINIT,
	PossibleValue = CV_OnOff,
	func = function()
		if leveltime >= 1 and multiplayer
			if cv_grenadeoptimization.value == 0
				print("\x8F\RSP: \x82rsp_antilag_grenade\x80\ is \x85\disabled.")
			end
			if cv_grenadeoptimization.value == 1
				print("\x8F\RSP: \x82rsp_antilag_grenade\x80\ is \x83\enabled.")
			end
		end
	end,
}))

rawset(_G, "rsp_autojump", 1)
COM_AddCommand("rsp_autojump", function(player, arg)
	if arg == nil
		CONS_Printf(player, "\x82rsp_autojump\x80 is\x83 \"on/off\"\x80. Enables auto jump.")
		CONS_Printf(player, "\x87rsp_autojump \x80\is\x83\ "..player.rsp_autojump)
		return
	end
	local args = arg:lower()
	if args == "off" or args == "false"	or args == "no" or args == "0"
		player.rsp_autojump = "0"
		COM_BufInsertText(player, "rsp_saveplayerconfig")
	end
	if args == "on" or args == "true" or args == "yes" or args == "1"
		player.rsp_autojump = "1"
		COM_BufInsertText(player, "rsp_saveplayerconfig")
	end
end)

COM_AddCommand("rsp_instashield_button", function(player, button)
	local buttons = "firenormal, tossflag, custom1, custom2, custom3, nextweapon, prevweapon"
	if button == nil
		print("Buttons: "..buttons)
		return
	end
	if button == "none" or button == "0" or button == "off" or button == "no"
		player.rsp_instashield_button = "none"
	end
	if RSP.buttons[button]
		player.rsp_instashield_button = button
	else
		print("Invalid "..button.." button. Buttons: "..buttons)
	end
end)

COM_AddCommand("rsp_hud", function(player, arg)
	if player == server
		if isdedicatedserver == true
			CONS_Printf(player, "This command does not work in dedicated console!")
		end
	end
	local huds = ""
	local hud_change = false
	for h = 0,#RSP.hud do
		if h != #RSP.hud
			huds = $ + RSP.hud[h].name + ", "
		else
			huds = $ + RSP.hud[h].name
		end
	end
	if arg == nil
		CONS_Printf(player, "\rsp_hud \x80\is\x83\ "..RSP.hud[player.rsp_hud].name)
		CONS_Printf(player, "Available HUDs: "..huds)
		return
	end
	local args = arg:lower()
	local argn = tonumber(arg)
	if argn == 0
		player.rsp_hud = 0
		hud_change = true
	end
	if argn
		if (argn > 0 and argn <= #RSP.hud) 
			player.rsp_hud = argn
			hud_change = true
		else
			CONS_Printf(player, "HUD "..tostring(argn).." invalid")
			CONS_Printf(player, "Available HUDs: "..huds)
			return
		end
	end
	for i = 0, #RSP.hud do
		if args == RSP.hud[i].name
			player.rsp_hud = i
			hud_change = true
		end
	end
	if hud_change == true
		if RSP.hud[player.rsp_hud].v_score == true
			hud.enable("score")
		else
			hud.disable("score")
		end
		if RSP.hud[player.rsp_hud].v_time == true
			hud.enable("time")
		else
			hud.disable("time")
		end
		if RSP.hud[player.rsp_hud].v_rings == true
			hud.enable("rings")
		else
			hud.disable("rings")
		end
		if RSP.hud[player.rsp_hud].v_lives == true
			hud.enable("lives")
		else
			hud.disable("lives")
		end
		if RSP.hud[player.rsp_hud].v_teamscores == true
			hud.enable("teamscores")
		else
			hud.disable("teamscores")
		end
		if RSP.hud[player.rsp_hud].v_powerstones == true
			hud.enable("powerstones")
		else
			hud.disable("powerstones")
		end
		COM_BufInsertText(player, "rsp_saveplayerconfig")
		return
	end
	CONS_Printf(player, "HUD "..tostring(args).." invalid")
	CONS_Printf(player, "Available HUDs: "..huds)
end)

COM_AddCommand("rsp_bghud", function(player, arg)
	if player == server
		if isdedicatedserver == true
			CONS_Printf(player, "This command does not work in dedicated console!")
		end
	end
	if arg == nil
		CONS_Printf(player, "\x82rsp_bghud\x80 is\x83 \"on/off\"\x80. Enables HUD background.")
		CONS_Printf(player, "\x87rsp_bghud \x80\is\x83\ "..player.rsp_bghud)
		return
	end
	local args = arg:lower()
	if args == "off" or args == "false"	or args == "no" or args == "0"
		player.rsp_bghud = 0
		COM_BufInsertText(player, "rsp_saveplayerconfig")
	end
	if args == "on" or args == "true" or args == "yes" or args == "1"
		player.rsp_bghud = 1
		COM_BufInsertText(player, "rsp_saveplayerconfig")
	end
end)

COM_AddCommand("rsp_hud_ammo", function(player, arg)
	if arg
		local argn = tonumber(arg)
		if argn == 0 then player.rsp_hud_ammo = argn return end
		if argn
			if argn >= 0 and argn <= 3 then player.rsp_hud_ammo = argn return end
		end
	end
	
	CONS_Printf(player, "\x87rsp_hud_ammo \x80\is\x83\ "..player.rsp_hud_ammo)
	CONS_Printf(player, "Shows the amount of ammo and rings near the crosshair.")
	CONS_Printf(player, "0 - do not show")
	CONS_Printf(player, "1 - only rings")
	CONS_Printf(player, "2 - only ammo")
	CONS_Printf(player, "3 - rings and ammo")
end)

COM_AddCommand("rsp_hud_speed", function(player, arg)
	if arg
		local argn = tonumber(arg)
		if argn == 0 then player.rsp_hud_speed = argn return end
		if argn
			if argn >= 0 and argn <= 2 then player.rsp_hud_speed = argn return end
		end
	end
	
	CONS_Printf(player, "\x87rsp_hud_speed \x80\is\x83\ "..player.rsp_hud_speed)
	CONS_Printf(player, "Shows player speed on screen.")
	CONS_Printf(player, "0 - do not show")
	CONS_Printf(player, "1 - show on the left of the screen")
	CONS_Printf(player, "2 - show near the crosshair")
end)

COM_AddCommand("rsp_menu_button", function(player, button)
	local buttons = "firenormal, tossflag, custom1, custom2, custom3, nextweapon, prevweapon"
	if button == nil
		print("Buttons: "..buttons)
		return
	end
	if button == "none" or button == "0" or button == "off" or button == "no"
		player.rsp_menu_button = "none"
	end
	if RSP.buttons[button]
		player.rsp_menu_button = button
	else
		print("Invalid "..button.." button. Buttons: "..buttons)
	end
end)

COM_AddCommand("rsp_hud_buttons", function(player, arg)
	if player == server
		if isdedicatedserver == true
			CONS_Printf(player, "This command does not work in dedicated console!")
		end
	end
	if arg == nil
		CONS_Printf(player, "\x82rsp_hud_buttons\x80 is\x83 \"on/off\"\x80. Enables buttons on the screen.")
		CONS_Printf(player, "\x87rsp_hud_buttons \x80\is\x83\ "..player.rsp_hud_buttons)
		return
	end
	local args = arg:lower()
	if args == "off" or args == "false"	or args == "no" or args == "0"
		player.rsp_hud_buttons = 0
		COM_BufInsertText(player, "rsp_saveplayerconfig")
	end
	if args == "on" or args == "true" or args == "yes" or args == "1"
		player.rsp_hud_buttons = 1
		COM_BufInsertText(player, "rsp_saveplayerconfig")
	end
end)

COM_AddCommand("rsp_autofire", function(player, arg)
	if arg == nil
		CONS_Printf(player, "\x82rsp_autofire\x80 is\x83 \"on/off\"\x80. By holding the fire button, you shoot continuously.")
		CONS_Printf(player, "\x87rsp_autofire \x80\is\x83\ "..player.rsp_autofire)
		return
	end
	local args = arg:lower()
	if args == "off" or args == "false"	or args == "no" or args == "0"
		player.rsp_autofire = 0
		COM_BufInsertText(player, "rsp_saveplayerconfig")
	end
	if args == "on" or args == "true" or args == "yes" or args == "1"
		player.rsp_autofire = 1
		COM_BufInsertText(player, "rsp_saveplayerconfig")
	end
end)

//Default config.
rawset(_G, "rsp_defaultconfig", function(player)
	for player in players.iterate do
		if player.dcrestart == true
			if player.rsp_crosshair == nil
				if find_cv_crosshair.value == 0
					player.rsp_crosshair = 66
				//Vanilla crosshairs.
				elseif find_cv_crosshair.value == 1
					player.rsp_crosshair = "a"
				elseif find_cv_crosshair.value == 2
					player.rsp_crosshair = "b"
				elseif find_cv_crosshair.value == 3
					player.rsp_crosshair = "c"
				end
			end
			if player.rsp_crosshair_alt == nil
				player.rsp_crosshair_alt = 0
			end
			if player.rsp_crosshair_scale == nil
				player.rsp_crosshair_scale = 2
			end
			if player.rsp_crosshair_color == nil
				player.rsp_crosshair_color = 0
			end
			if player.rsp_autojump == nil
				player.rsp_autojump = "1"
			end
			if player.rsp_instashield_button == nil
				player.rsp_instashield_button = "custom1"
			end
			if player.rsp_hud == nil
				player.rsp_hud = 0
			end
			if player.rsp_bghud == nil
				player.rsp_bghud = 1
			end
			if player.rsp_hud_ammo == nil
				player.rsp_hud_ammo = 3
			end
			if player.rsp_hud_speed == nil
				player.rsp_hud_speed = 2
			end
			if player.rsp_menu_button == nil
				player.rsp_menu_button = "custom3"
			end
			if player.rsp_hud_buttons == nil
				player.rsp_hud_buttons = 0
			end
			if player.rsp_autofire == nil
				player.rsp_autofire = 1
			end
			COM_BufInsertText(player, "rsp_loadplayerconfig")
			player.dcrestart = nil
		end
	end
end)

//load and save your RSP config.
COM_AddCommand("rsp_loadplayerconfig", function(player)
	local rsp_config = io.openlocal("client/RSP/playerconfig.dat", "r")
	if player.rsp_loadcommands == nil then player.rsp_loadcommands = {} end
	while true do
		local command = rsp_config:read("*l")
		if command == nil then break end
		table.insert(player.rsp_loadcommands, command)
	end
	rsp_config:close()
end, COM_LOCAL)

COM_AddCommand("rsp_saveplayerconfig", function(player, value, arg)
	if player.rsp_crosshair == nil
		player.rsp_crosshair = 66
	end
	if player.rsp_crosshair_alt == nil
		player.rsp_crosshair_alt = 0
	end
	if player.rsp_crosshair_scale == nil
		player.rsp_crosshair_scale = 2
	end
	if player.rsp_crosshair_color == nil
		player.rsp_crosshair_color = 0
	end
	if player.rsp_autojump == nil
		player.rsp_autojump = "1"
	end
	if player.rsp_instashield_button == nil
		player.rsp_instashield_button = "custom1"
	end
	if player.rsp_hud == nil
		player.rsp_hud = 0
	end
	if player.rsp_bghud == nil
		player.rsp_bghud = 1
	end
	if player.rsp_menu_button == nil
		player.rsp_menu_button = "custom3"
	end
	local rsp_playerconfig = io.openlocal("client/RSP/playerconfig.dat", "w")
	rsp_playerconfig:write("rsp_spawnpoint "..cv_rspspawnpoint.value.."\n")
	rsp_playerconfig:write("rsp_crosshair "..player.rsp_crosshair.."\n")
	rsp_playerconfig:write("rsp_crosshair_alt "..player.rsp_crosshair_alt.."\n")
	rsp_playerconfig:write("rsp_crosshair_color "..player.rsp_crosshair_color.."\n")
	rsp_playerconfig:write("rsp_crosshair_scale "..player.rsp_crosshair_scale.."\n")
	rsp_playerconfig:write("rsp_autojump "..player.rsp_autojump.."\n")
	rsp_playerconfig:write("rsp_instashield_button "..player.rsp_instashield_button.."\n")
	rsp_playerconfig:write("rsp_hud "..player.rsp_hud.."\n")
	rsp_playerconfig:write("rsp_bghud "..player.rsp_bghud.."\n")
	rsp_playerconfig:write("rsp_menu_button "..player.rsp_menu_button.."\n")
	rsp_playerconfig:write("rsp_hud_buttons "..player.rsp_hud_buttons.."\n")
	rsp_playerconfig:write("rsp_autofire "..player.rsp_autofire.."\n")
	rsp_playerconfig:close()
end, COM_LOCAL)

//Help command
COM_AddCommand("rsp_help", function(player, command)
	if not command then
		CONS_Printf(player, "\x8A Categories")
		CONS_Printf(player, "\x84 instagib")
		CONS_Printf(player, "\x84\ free_for_all")
		CONS_Printf(player, "\x84 hot_potato")
		CONS_Printf(player, "\x84 duel_arena")
		CONS_Printf(player, "\x89 server_settings")
		CONS_Printf(player, "\x89 player_settings")
		CONS_Printf(player, "\x8B\ all_commands")
		if cv_rspdebug.value == 1
			CONS_Printf(player, "\x8F\ debug_mode")
		end
		CONS_Printf(player, " ")
		CONS_Printf(player, "\x87 rsp_help  <category>\x80: get information about category")
		CONS_Printf(player, "Changes the game conditions in ringslinger's gametypes.")
		CONS_Printf(player, "\x87rsp_help  <command>\x80: get information about command")
	elseif command == "instagib" then
		CONS_Printf(player, "\x84\InstaGib")
		CONS_Printf(player, "\x87rsp_rbpower")
		CONS_Printf(player, "\x87rsp_railboost")
		CONS_Printf(player, "\x87rsp_instashield")
	elseif command == "free_for_all" or command == "ffa" then
		CONS_Printf(player, "\x84\Free For All")
		CONS_Printf(player, "\x87rsp_ammoffa")
	elseif command == "hot_potato" or command == "hotpotato" then
		CONS_Printf(player, "\x84Hot Potato")
		CONS_Printf(player, "\x87rsp_killplayertimer")
	elseif command == "duel_arena" or command == "arena" then
		CONS_Printf(player, "\x84\Duel Arena")
		CONS_Printf(player, "\x87rsp_arena_limitpoint")
		CONS_Printf(player, "\x87rsp_arena_limittime")
	elseif command == "server_settings" or command == "server" then
		CONS_Printf(player, "\x89server_settings")
		CONS_Printf(player, "\x87rsp_rocketjump")
		CONS_Printf(player, "\x87rsp_rjpower")
		CONS_Printf(player, "\x87rsp_suddendeath")
		CONS_Printf(player, "\x87rsp_allowautojump")
		CONS_Printf(player, "\x87rsp_keepweapons")
		CONS_Printf(player, "\x87rsp_allowshield")
		CONS_Printf(player, "\x87rsp_instagib_mode")
		CONS_Printf(player, "\x87rsp_timerexplosion")
		CONS_Printf(player, "\x87rsp_timelimit")
		CONS_Printf(player, "\x87rsp_getreadytimer")
		CONS_Printf(player, "\x87rsp_waitforplayers")
		CONS_Printf(player, "\x87rsp_allowability")
		CONS_Printf(player, "\x87rsp_allowability2")
		CONS_Printf(player, "\x87rsp_antilag_grenade")
		CONS_Printf(player, "\x87rsp_quickswitching")
		CONS_Printf(player, "\x87rsp_explosiondamage")
		CONS_Printf(player, "\x87rsp_walljump")
		CONS_Printf(player, "\x87rsp_autofire")
	elseif command == "player_settings" or command == "player" then
		CONS_Printf(player, "\x89player_settings")
		CONS_Printf(player, "\x87rsp_spawnpoint")
		CONS_Printf(player, "\x87rsp_crosshair")
		CONS_Printf(player, "\x87rsp_crosshair_color")
		CONS_Printf(player, "\x87rsp_crosshair_scale")
		CONS_Printf(player, "\x87rsp_hud")
		CONS_Printf(player, "\x87rsp_bghud")
		CONS_Printf(player, "\x87rsp_hud_speed")
		CONS_Printf(player, "\x87rsp_hud_ammo")
		CONS_Printf(player, "\x87rsp_autojump")
		CONS_Printf(player, "\x87rsp_instashield_button")
		CONS_Printf(player, "\x87rsp_menu_button")
	elseif command == "debug_mode" or command == "debug" then
		CONS_Printf(player, "\x8F\debug_mode")
		CONS_Printf(player, "\x87rsp_ghost")
		CONS_Printf(player, "\x87rsp_it")
		CONS_Printf(player, "\x87rsp_headhunt")
	elseif command == "all" or command == "all_commands" then
		CONS_Printf(player, "\x89server_settings     \x84InstaGib            \x84HotPotato")
		CONS_Printf(player, "\x87rsp_rjpower         \x87rsp_rbpower         \x87rsp_killplayertimer")
		CONS_Printf(player, "\x87rsp_rocketjump      \x87rsp_railboost       ")
		CONS_Printf(player, "\x87rsp_suddendeath     \x87rsp_instashield     \x84\Duel Arena")
		CONS_Printf(player, "\x87rsp_allowautojump                       \x87rsp_arena_limitpoint")
		CONS_Printf(player, "\x87rsp_allowshield    \x84\ Free For All        \x87rsp_arena_limittime")
		CONS_Printf(player, "\x87rsp_keepweapons     \x87rsp_ammoffa")
		CONS_Printf(player, "\x87rsp_timerexplosion ")
		CONS_Printf(player, "\x87rsp_timelimit ")
		CONS_Printf(player, "\x87rsp_getreadytimer ")
		CONS_Printf(player, "\x87rsp_waitforplayers ")
		CONS_Printf(player, "\x87rsp_instagib_mode ")
		CONS_Printf(player, "\x87rsp_allowability ")
		CONS_Printf(player, "\x87rsp_allowability2 ")
		CONS_Printf(player, "\x87rsp_antilag_grenade")
		CONS_Printf(player, "\x87rsp_quickswitching")
		CONS_Printf(player, "\x87rsp_walljump")
		CONS_Printf(player, "\x87rsp_autofire")
		CONS_Printf(player, " ")
		CONS_Printf(player, "\x89player_settings   ")
		CONS_Printf(player, "\x87rsp_spawnpoint")
		CONS_Printf(player, "\x87rsp_crosshair")
		CONS_Printf(player, "\x87rsp_crosshair_color")
		CONS_Printf(player, "\x87rsp_crosshair_scale")
		CONS_Printf(player, "\x87rsp_hud")
		CONS_Printf(player, "\x87rsp_bghud")
		CONS_Printf(player, "\x87rsp_hud_speed")
		CONS_Printf(player, "\x87rsp_hud_ammo")
		CONS_Printf(player, "\x87rsp_autojump")
		CONS_Printf(player, "\x87rsp_instashield_button")
		CONS_Printf(player, "\x87rsp_menu_button")
		CONS_Printf(player, "Changes the game conditions in ringslinger's gametypes.")
		CONS_Printf(player, "\x87rsp_help  <command>\x80: get information about command")
	elseif command == "rsp_rjpower" or command == "rjpower" then
		CONS_Printf(player, "\x87rsp_rjpower \x80\is\x83\ "..rocketjump_power.value)
		CONS_Printf(player, "Changes the force of the push from the explosion.")
	elseif command == "rsp_rocketjump" or command == "rocketjump" then
		CONS_Printf(player, "\x87rsp_rocketjump \x80\is\x83\ "..cv_rjenabled.value)
		CONS_Printf(player, "Enable and disable the ability to fly away from the explosion.")
	elseif command == "rsp_antilag_grenade" or command == "rsp_antilag_grenade" then
		CONS_Printf(player, "\x87rsp_antilag_grenade \x80\is\x83\ "..cv_grenadeoptimization.value)
		CONS_Printf(player, "Replaces the explode from greande with another.")
	elseif command == "rsp_suddendeath" or command == "suddendeath" then
		CONS_Printf(player, "\x87rsp_suddendeath \x80\is\x83\ "..cv_rspsuddendeath.value)
		CONS_Printf(player, "Enable and disable instakill with any weapon.")
	elseif command == "rsp_autojump" or command == "autojump" then
		CONS_Printf(player, "\x87rsp_autojump \x80\is\x83\ "..player.rsp_autojump)
		CONS_Printf(player, "When enabled, the player will automatically jump if player hold the jump.")
	elseif command == "rsp_allowautojump" or command == "allowautojump" then
		CONS_Printf(player, "\x87rsp_allowautojump \x80\is\x83\ "..cv_autojump.value)
		CONS_Printf(player, "Allows the use of autojump on the server.")
	elseif command == "rsp_spawnpoint" or command == "spawnpoint" then
		CONS_Printf(player, "\x87rsp_spawnpoint \x80\is\x83\ "..cv_rspspawnpoint.value)
		CONS_Printf(player, "Shows spawn points of player. You need to restart the map.")
	elseif command == "rsp_keepweapons" or command == "keepweapons" then
		CONS_Printf(player, "\x87rsp_keepweapons \x80\is\x83\ "..cv_keepweapons.value)
		CONS_Printf(player, "The weapons return after taking damage.")
	elseif command == "rsp_instagib_mode" or command == "instagib" then
		CONS_Printf(player, "\x87rsp_instagib_mode \x80\is\x83\ "..cv_instagib.value)
		CONS_Printf(player, "Railring only and instant death, use instashield to be a ducking invincible..")
	elseif command == "rsp_allowshield" or command == "suddendeath" then
		CONS_Printf(player, "\x87rsp_allowshield \x80\is\x83\ "..cv_allowshield.value)
		CONS_Printf(player, "When disabled, the player cannot have a shield.")
	elseif command == "rsp_rbpower" or command == "rbpower" then
		CONS_Printf(player, "\x87rsp_rbpower \x80\is\x83\ "..railboost_power.value)
		CONS_Printf(player, "Changes the acceleration from the railboost. \x82\Works only in Instagib gametypes.")
	elseif command == "rsp_railboost" or command == "railboost" then
		CONS_Printf(player, "\x87rsp_railboost \x80\is\x83\ "..cv_rbenabled.value)
		CONS_Printf(player, "When enabled the player can accelerate from the rail. \x82\Works only in Instagib gametypes.")
	elseif command == "rsp_instashield" or command == "instashield" then
		CONS_Printf(player, "\x87rsp_instashield \x80\is\x83\ "..cv_instashield.value)
		CONS_Printf(player, "If command is enabled, Instashield will appear, can be activated with the "..player.rsp_instashield_button.." button, which will protect you from damage for short time. \x82\Works only in Instagib gametypes.")
	elseif command == "rsp_instashield_button" or command == "instashield_button" then
		CONS_Printf(player, "\x87rsp_instashield_button \x80\is\x83\ "..player.rsp_instashield_button)
		CONS_Printf(player, "Changes the activation button of InstaShield.")	
	elseif command == "rsp_ammoffa" or command == "ammoffa" then
		CONS_Printf(player, "\x87rsp_ammoffa \x80\is\x83\ "..ffastarterammo.value)
		CONS_Printf(player, "Amount of ammo will be given to the player at start. \x82\Works only in Free For All gametypes.")
	elseif command == "rsp_timerexplosion" or command == "timerexplosion" then
		CONS_Printf(player, "\x87rsp_timerexplosion \x80\is\x83\ "..cv_timerexplosion.value)
		CONS_Printf(player, "Setting the grenade timer.")
	elseif command == "rsp_timelimit" or command == "timelimit" then
		CONS_Printf(player, "\x87rsp_timelimit \x80\is\x83\ "..cv_rsptimelimit.value)
		CONS_Printf(player, "Setting the time limit for ringslinger's gametype.")
	elseif command == "rsp_getreadytimer" or command == "getreadytimer" then
		CONS_Printf(player, "\x87rsp_getreadytimer \x80\is\x83\ "..cv_rspgetready.value)
		CONS_Printf(player, "Setting the time for warp-up.")
	elseif command == "rsp_killplayertimer" or command == "getreadytimer" then
		CONS_Printf(player, "\x87rsp_killplayertimer \x80\is\x83\ "..cv_explodeplayertimer.value)
		CONS_Printf(player, "Setting the player's explosion timer.")
	elseif command == "rsp_waitforplayers" or command == "waitforplayers" then
		CONS_Printf(player, "\x87rsp_killplayertimer \x80\is\x83\ "..cv_rspwfp.value)
		CONS_Printf(player, "How many player to wait.")
	elseif command == "rsp_arena_limitpoint" or command == "arena_limitpoint" then
		CONS_Printf(player, "\x87rsp_arena_limitpoint \x80\is\x83\ "..cv_rsplimitpa.value)
		CONS_Printf(player, "Time limit in Duel Arena.")
	elseif command == "rsp_arena_limittime" or command == "arena_limittime" then
		CONS_Printf(player, "\x87rsp_arena_limittime \x80\is\x83\ "..cv_rsplimitta.value)
		CONS_Printf(player, "Point limit in Duel Arena.")
	elseif command == "rsp_crosshair" or command == "crosshair" then
		CONS_Printf(player, "\x87rsp_crosshair \x80\is\x83\ "..player.rsp_crosshair)
		CONS_Printf(player, "Changes the type of crosshair.")
	elseif command == "rsp_crosshair_color" or command == "crosshair_color" then
		if player.rsp_crosshair_color == nil or player.rsp_crosshair_color == 0
			CONS_Printf(player, "\x87rsp_crosshair_color \x80\is\x83\ Subtract")
		else
			CONS_Printf(player, "\x87rsp_crosshair_color \x80\is\x83\ "..R_GetColorByName(player.rsp_crosshair_color))
		end
		CONS_Printf(player, "Changes the color of crosshair.")
	elseif command == "rsp_crosshair_scale" or command == "crosshair_scale" then
		CONS_Printf(player, "\x87rsp_crosshair_scale \x80\is\x83\ ".. player.rsp_crosshair_scale)
		CONS_Printf(player, "Changes the scale of crosshair.")
	elseif command == "rsp_allowability" or command == "allowability" then
		CONS_Printf(player, "\x87rsp_allowability \x80\is\x83\ "..cv_allowability.value)
		CONS_Printf(player, "Turn off/on character ability for jump button.")
	elseif command == "rsp_allowability2" or command == "allowability2" then
		CONS_Printf(player, "\x87rsp_allowability2 \x80\is\x83\ "..cv_allowability2.value)
		CONS_Printf(player, "Turn off/on character ability for spin button.")
	elseif command == "rsp_quickswitching" or command == "quickswitching" then
		CONS_Printf(player, "\x87rsp_quickswitching \x80\is\x83\ "..cv_quickswitching.value)
		CONS_Printf(player, "Each weapon will have its own delay.")
	elseif command == "rsp_explosiondamage" or command == "explosiondamage" then
		CONS_Printf(player, "\x87rsp_explosiondamage \x80\is\x83\ "..cv_quickswitching.value)
		CONS_Printf(player, "Player will lose rings if he detonates his grenades near him.")
	elseif command == "rsp_hud" or command == "hud" then
		CONS_Printf(player, "\x87rsp_hud \x80\is\x83\ "..player.rsp_hud)
		CONS_Printf(player, "Changes the player's HUD.")
	elseif command == "rsp_bghud" or command == "bghud" then
		CONS_Printf(player, "\x87rsp_bghud \x80\is\x83\ "..player.rsp_bghud)
		CONS_Printf(player, "Turns the HUD background on and off (if there is one).")
	elseif command == "rsp_hud_speed" or command == "hud_speed" then
		CONS_Printf(player, "\x87rsp_hud_speed \x80\is\x83\ "..player.rsp_hud_speed)
		CONS_Printf(player, "Shows player speed on screen.")
		CONS_Printf(player, "0 - do not show")
		CONS_Printf(player, "1 - show on the left of the screen")
		CONS_Printf(player, "2 - show near the crosshair")
	elseif command == "rsp_hud_ammo" or command == "hud_ammo" then
		CONS_Printf(player, "\x87rsp_hud_ammo \x80\is\x83\ "..player.rsp_hud_ammo)
		CONS_Printf(player, "Shows the amount of ammo and rings near the crosshair.")
		CONS_Printf(player, "0 - do not show")
		CONS_Printf(player, "1 - only rings")
		CONS_Printf(player, "2 - only ammo")
		CONS_Printf(player, "3 - rings and ammo")
	elseif command == "rsp_menu_button" or command == "hud_button" then
		CONS_Printf(player, "\x87rsp_menu_button \x80\is\x83\ "..player.rsp_menu_button)
		CONS_Printf(player, "Changes the activation button of RSP menu.")
	elseif command == "rsp_walljump" or command == "walljump" then
		CONS_Printf(player, "\x87rsp_walljump \x80\is\x83\ "..cv_walljump.value)
		CONS_Printf(player, "Players can bounce off walls.")
	elseif command == "rsp_allowautofire" or command == "allowautofire" then
		CONS_Printf(player, "\x87rsp_allowautofire \x80\is\x83\ "..cv_autofire.value)
		CONS_Printf(player, "Players can continuously shoot by holding the fire button.")
	elseif command == "rsp_autofire" or command == "autofire" then
		CONS_Printf(player, "\x87rsp_autofire \x80\is\x83\ "..player.rsp_autofire)
		CONS_Printf(player, "By holding the fire button, you shoot continuously.")
	elseif command == "rsp_hud_buttons" or command == "hud_buttons" then
		CONS_Printf(player, "\x87rsp_hud_buttons \x80\is\x83\ "..player.rsp_hud_buttons)
		CONS_Printf(player, "\x82rsp_hud_buttons\x80 is\x83 \"on/off\"\x80. Enables buttons on the screen.")
	elseif command == "rsp_abilityafterrocketjump" or command == "abilityafterrocketjump" then
		CONS_Printf(player, "\x87rsp_abilityafterrocketjump \x80\is\x83\ "..cv_aarj.value)
		CONS_Printf(player, "\x82rsp_abilityafterrocketjump\x80 is\x83 \"on/off\"\x80. Enables character ability after rocketjump.")
	elseif command == "rsp_blowdamage" or command == "blowdamage" then
		CONS_Printf(player, "\x87rsp_blowdamage \x80\is\x83\ "..cv_blowdamage.value)
		CONS_Printf(player, "\x82rsp_blowdamage\x80 is\x83 \"0-50\"\x80. Adjusts rocketkump damage.")
	end
end)

//Information about mod.
addHook("PlayerThink", function(player)
	if player.info_rsp_mod != true
		chatprintf(player, "\x8f\---Ringslinger Plus---")
		chatprintf(player, "\x87\Version:\x80 V1.1\x86 12.07.23")
		chatprintf(player, "\x89\Discord\x80 - sirexer\x80.")
		if player.rsp_menu_button != "none"
			chatprintf(player, "\x83\Press\x87 "..RSP.buttons[player.rsp_menu_button].fullname.." \x80to open menu.")
		else
			chatprintf(player, "\x83\Type\x87 \"rsp_menu\" \x80to the console.")
		end
		CONS_Printf(player, "Loading RSP settings...")
		player.info_rsp_mod = true
	end
	if player.rsp_loadcommands != nil
		if player.rsp_loadcommands[1] != nil
			COM_BufInsertText(player, player.rsp_loadcommands[1])
			table.remove(player.rsp_loadcommands, 1)
		end
	end
end)

COM_AddCommand("rsp_menu", function(player, command)
	if gamestate == GS_LEVEL
		if player.rsp_menu != true
			player.rsp_menu = true
		else
			player.rsp_menu = nil
			player.rsp_mcam = nil
			player.rsp_navmenu = nil
		end
	end
end)

//Table for synchronization.
addHook("NetVars", function(net)
	RSP.DATA = net($)
end)