 -- RingSlingerPlus
 -- 3-RSP_Game.lua
 -- 12.07.2023
 -- Sirexer

//Table of players in the game.
local function PlayersOnServer(var)
	RSP.DATA.playertable = {}
	local yayplayer = #players-1
		for i = 0, yayplayer
			if players[i]
			and players[i].valid
				if not players[i].spectator
				table.insert(RSP.DATA.playertable, players[i].mo)
			end
		end
	end
end
//Table of live players in the game.
local function PlayersOnServerLive(var)
	RSP.DATA.playertablelive = {}
	local yayliveplayer = #players-1
		for i = 0, yayliveplayer do
			if players[i]
			and players[i].valid
				if not players[i].spectator
				and players[i].mo
				and players[i].mo.valid
				and players[i].rsp_live
				and not players[i].rspghostplayer
				table.insert(RSP.DATA.playertablelive, players[i].mo)
			end
		end
	end
end
//Countdown to the start of the match.
local function GetReadyToFight(player)
	if RSP.DATA.round_ready == false
		if (#RSP.DATA.playertable >= cv_rspwfp.value) and RSP.DATA.round_ready == false and not G_Is1v1Gametype()
			if RSP.DATA.readytimer != 0
				RSP.DATA.readytimer = $ - 1
			end
		end
		if (#RSP.DATA.playertable == 2) and RSP.DATA.round_ready == false and G_Is1v1Gametype()
			if RSP.DATA.readytimer != 0
				RSP.DATA.readytimer = $ - 1
			end
		end
		if (#RSP.DATA.playertable < cv_rspwfp.value) and not G_Is1v1Gametype()
			RSP.DATA.readytimer = cv_rspgetready.value*TICRATE
		end
		if (#RSP.DATA.playertable < 2) and G_Is1v1Gametype()
			RSP.DATA.readytimer = cv_rspgetready.value*TICRATE
		end
	end
end
//Turning a player into a ghost.
local function RSP_Player_Is_Ghost(player)
	for player in players.iterate
		if player.mo
		and player.mo.valid
			if player.rspghostplayer == true
				player.mo.frame = $ | FF_TRANS70
				player.mo.flags = $ | MF_NOCLIPTHING|MF_NOGRAVITY
				player.mo.color = SKINCOLOR_GREY
				player.mo.colorize = true
				player.mo.shadowscale = 0
				player.powers[pw_underwater] = 20*TICRATE
				player.powers[pw_spacetime] = 20*TICRATE
				player.charability = 0
				player.charability2 = 0
				player.jumpfactor = 0
				if player.mo.state != S_RSPGHOST
					player.mo.state = S_RSPGHOST
				end
			end
		end
	end
end
local function RSP_RemoveExitPlayers()
	if RSP.DATA.winner != false
	and not RSP.DATA.winner.valid
		RSP.DATA.winner = false
	end
	if RSP.DATA.lose != false
	and not RSP.DATA.lose.valid
		RSP.DATA.lose = false
	end
end

//Starting weapons
rawset(_G, "RSP_StartingWeapons", function(player)
	if cv_instagib.value == 0 or G_IsNoInstaGametype()
		if (mapheaderinfo[gamemap].rsp_infinity != nil)
			player.powers[pw_infinityring] = (mapheaderinfo[gamemap].rsp_infinity)
		end
		if (mapheaderinfo[gamemap].rsp_automatic != nil)
			if player.ringweapons != 0
				player.ringweapons = $ + 1
			else
				player.ringweapons = 1
			end
			player.powers[pw_automaticring] = (mapheaderinfo[gamemap].rsp_automatic)
		end
		if (mapheaderinfo[gamemap].rsp_bounce != nil)
			if player.ringweapons != 0
				player.ringweapons = $ + 2
			else
				player.ringweapons = 2
			end
			player.powers[pw_bouncering] = (mapheaderinfo[gamemap].rsp_bounce)
		end
		if (mapheaderinfo[gamemap].rsp_scatter != nil)
			if player.ringweapons != 0
				player.ringweapons = $ + 4
			else
				player.ringweapons = 4
			end
			player.powers[pw_scatterring] = (mapheaderinfo[gamemap].rsp_scatter)
		end
		if (mapheaderinfo[gamemap].rsp_grenade != nil)
			if player.ringweapons != 0
				player.ringweapons = $ + 8
			else
				player.ringweapons = 8
			end
			player.powers[pw_grenadering] = (mapheaderinfo[gamemap].rsp_grenade)
		end
		if (mapheaderinfo[gamemap].rsp_bomb != nil)
			if player.ringweapons != 0
				player.ringweapons = $ + 16
			else
				player.ringweapons = 16
			end
		player.powers[pw_explosionring] = (mapheaderinfo[gamemap].rsp_bomb)
		end
		if (mapheaderinfo[gamemap].rsp_rail != nil)
			if player.ringweapons != 0
				player.ringweapons = $ + 32
			else
				player.ringweapons = 32
			end
			player.powers[pw_railring] = (mapheaderinfo[gamemap].rsp_rail)
		end
	end
end)

addHook("PlayerSpawn", RSP_StartingWeapons, MT_PLAYER)

//The players can't hurt.
addHook("MobjDamage", function(target, inflictor, source, mo, player)
	if G_RingSlingerGametype()
		if RSP.DATA.round_ready == false
			P_DoPlayerPain(target.player)
			S_StartSound(target.player.mo, sfx_altdi1)
			return true
		end
	end
end, MT_PLAYER)

addHook("ThinkFrame", function()
	if multiplayer
		PlayersOnServer()
		PlayersOnServerLive()
	end
	if gametype == GT_CTF
		if P_IsFlagAtBase(MT_BLUEFLAG)
			RSP.Flags["blue"] = true
		else
			RSP.Flags["blue"] = false
		end
		if P_IsFlagAtBase(MT_REDFLAG)
			RSP.Flags["red"] = true
		else
			RSP.Flags["red"] = false
		end
	end
	if G_RingSlingerGametype()
		RSP_RemoveExitPlayers()
		if cv_grenadeoptimization.value == 1
			if mobjinfo[MT_NIGHTSPARKLE] != {spawnstate = S_NULL}
				mobjinfo[MT_NIGHTSPARKLE] = {spawnstate = S_NULL}
			end
		elseif cv_grenadeoptimization.value == 0
			if mobjinfo[MT_NIGHTSPARKLE] != {spawnstate = S_NIGHTSPARKLE1}
				mobjinfo[MT_NIGHTSPARKLE] = {spawnstate = S_NIGHTSPARKLE1, flags = MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY}
			end
		end
	end
	if G_RingSlingerGametype()
		if cv_rspdebug.value == 1
			if RSP.DATA.round_ready == false or RSP.DATA.getready == false
				RSP.DATA.round_ready = true
				RSP.DATA.getready = true
			end
		end
		local serverornil = isdedicatedserver and nil or server
		GetReadyToFight(player)
		//Checking, if players is ready for fight.
		if (leveltime <= 4) and cv_rspdebug.value == 0 and not G_Is1v1Gametype()
			if (#RSP.DATA.playertable >= cv_rspwfp.value)
			and RSP.DATA.getready == false
				RSP.DATA.round_ready = true
			end
			if (#RSP.DATA.playertable < cv_rspwfp.value)
				RSP.DATA.round_ready = false
			end
		end
		if (leveltime <= 4) and cv_rspdebug.value == 0 and G_Is1v1Gametype()
			if (#RSP.DATA.playertable == 2)
			and RSP.DATA.getready == false
				RSP.DATA.round_ready = true
			end
			if (#RSP.DATA.playertable < 2)
				RSP.DATA.round_ready = false
			end
		end
		if (leveltime >= 5)
		and cv_rspdebug.value == 0
			//Start a many if, the round starts.
			if (#RSP.DATA.playertable >= cv_rspwfp.value) and RSP.DATA.round_ready == false and RSP.DATA.readytimer == 0 and not G_Is1v1Gametype()
				RSP.DATA.round_ready = true
				RSP.DATA.getready = false
				COM_BufInsertText(serverornil, "map "..gamemap.." -silent")
				print("Restarting Level!")
			end
			if (#RSP.DATA.playertable == 2) and RSP.DATA.round_ready == false and RSP.DATA.readytimer == 0 and G_Is1v1Gametype()
				RSP.DATA.round_ready = true
				RSP.DATA.getready = false
				COM_BufInsertText(serverornil, "map "..gamemap.." -silent")
				print("Restarting Level!")
			end
			//If there are few player, the match is over
			if (#RSP.DATA.playertable < cv_rspwfp.value)
			and RSP.DATA.round_ready == true
			and cv_rspdebug.value == 0
			and rspduelqueue01 == false
				G_ExitLevel()
			end
		end
		//Timelimit for Ringslinger's gametypes.
		if (leveltime == 6)
			if RSP.DATA.round_ready == true and gametype != GT_HOTPOTATO and gametype != GT_DUELARENA or G_IsHASGametype()
				COM_BufInsertText(serverornil, "timelimit "..cv_rsptimelimit.value.." -silent")
			end
			if RSP.DATA.round_ready == false and gametype != GT_HOTPOTATO and gametype != GT_DUELARENA and not G_IsHASGametype()
				COM_BufInsertText(serverornil, "timelimit 0 -silent")
			end
		end
	end
end)

//Returning weapons and ammo to the player.
local function KeepWeapons_rsp(player)
	if cv_instagib.value != 1
		if player.powers[pw_flashing] >= 3*TICRATE and player.weaponkeepped == nil
			player.weaponkeepped = true
			player.currentweapon = player.keepcurrentweapon
			player.ringweapons = player.keepweapons
			player.powers[pw_infinityring] = player.infinitykeepweapons
			player.powers[pw_automaticring] = player.automatickeepweapons
			player.powers[pw_bouncering] = player.bouncekeepweapons
			player.powers[pw_scatterring] = player.scatterkeepweapons
			player.powers[pw_grenadering] = player.grenadekeepweapons
			player.powers[pw_explosionring] = player.explosionkeepweapons
			player.powers[pw_railring] = player.railkeepweapons
		end
		if player.powers[pw_flashing] == 0
			player.weaponkeepped = nil
			player.keepcurrentweapon = player.currentweapon
			player.keepweapons = player.ringweapons
			player.infinitykeepweapons = player.powers[pw_infinityring]  
			player.automatickeepweapons = player.powers[pw_automaticring]
			player.bouncekeepweapons = player.powers[pw_bouncering]
			player.scatterkeepweapons = player.powers[pw_scatterring]
			player.grenadekeepweapons = player.powers[pw_grenadering]
			player.explosionkeepweapons = player.powers[pw_explosionring]
			player.railkeepweapons = player.powers[pw_railring]
		end
	end
end

//And remove the lost panels and ammo.
local function rsp_RemLostPanels(mo)
    if cv_keepweapons.value == 1 and cv_instagib.value != 1 or (mapheaderinfo[gamemap].rsp_mapkeepweapons) and cv_instagib.value != 1 or G_IsFFAGametype()
		if (mo.fuse > 0)
			P_RemoveMobj(mo)
		end
    end
end

//Panels and ammo
addHook("MobjThinker", rsp_RemLostPanels, MT_INFINITYRING)
addHook("MobjThinker", rsp_RemLostPanels, MT_AUTOPICKUP)
addHook("MobjThinker", rsp_RemLostPanels, MT_BOUNCEPICKUP)
addHook("MobjThinker", rsp_RemLostPanels, MT_SCATTERPICKUP)
addHook("MobjThinker", rsp_RemLostPanels, MT_GRENADEPICKUP)
addHook("MobjThinker", rsp_RemLostPanels, MT_EXPLODEPICKUP)
addHook("MobjThinker", rsp_RemLostPanels, MT_RAILPICKUP)
addHook("MobjThinker", rsp_RemLostPanels, MT_AUTOMATICRING)
addHook("MobjThinker", rsp_RemLostPanels, MT_BOUNCERING)
addHook("MobjThinker", rsp_RemLostPanels, MT_SCATTERRING)
addHook("MobjThinker", rsp_RemLostPanels, MT_GRENADERING)
addHook("MobjThinker", rsp_RemLostPanels, MT_EXPLOSIONRING)
addHook("MobjThinker", rsp_RemLostPanels, MT_RAILRING)

//QuickSwitching!
local function RSP_QuickSwitching(player)
	if cv_instagib.value == 1 and not G_IsNoInstaGametype() then return end
	if player and player.valid
	and player.mo and player.mo.valid
		if not player.mo.qs
			player.mo.qs = {} 
			player.mo.qs[0] = 0
			player.mo.qs[1] = 0
			player.mo.qs[2] = 0
			player.mo.qs[3] = 0
			player.mo.qs[4] = 0
			player.mo.qs[5] = 0
			player.mo.qs[6] = 0
			player.mo.qs.cw = 0
		end
		if player.currentweapon != player.mo.qs.cw
			player.weapondelay = player.mo.qs[player.currentweapon]
			player.mo.qs.cw = player.currentweapon
		end
		if player.currentweapon == player.mo.qs.cw
			player.mo.qs[player.currentweapon] = player.weapondelay
		end
		for i = 0,6 do
			if player.currentweapon == i then continue end
			if player.mo.qs[i] != 0 then player.mo.qs[i] = $ - 1 end
		end
	end
end

addHook("MobjMoveBlocked", function(mo, thing, line)
	if cv_walljump.value == 0 then return end
	if P_IsObjectOnGround(mo) then return end
	//if (mo.player.pflags & PF_THOKKED) then return end
	if not line then return end
	if mo.player.powers[pw_nocontrol] != 0 then return end
	if mo.player.gotflag != 0 then return end
	local jumpangle = FixedAngle(180*FRACUNIT) + R_PointToAngle2(mo.x, mo.y, P_ClosestPointOnLine(mo.x,mo.y, line))
	local slideangle = R_PointToAngle2(mo.x, mo.y, P_ClosestPointOnLine(mo.x,mo.y, line))
	local defaultspeed = 15*mo.scale
	local realspeed = R_PointToDist2(0, 0, mo.momx, mo.momy)
	local savespeed = realspeed+(realspeed/96)
	if (mo.player.cmd.buttons & BT_SPIN)
		if mo.dashdelay == 0
			S_StartSound(mo, sfx_s1bb)
			P_BounceMove(mo)
			local moveangle = R_PointToAngle2(0, 0, mo.momx, mo.momy)
			if mo.momz > 32*FRACUNIT
				mo.momz = mo.momz + (mo.momz/8)
			elseif mo.momz <= 32*FRACUNIT
				mo.momz = 10*FRACUNIT
			end
			if mo.player.speed >= 15*FRACUNIT
				P_Thrust(mo, moveangle, savespeed)
			else
				P_Thrust(mo, jumpangle, defaultspeed)
			end
			mo.dashdelay = 35
			return
		end
	end
	/*
	if mo.angle > slideangle
		P_Thrust(mo, slideangle+ANGLE_90, savespeed/64)
	elseif mo.angle < slideangle
		P_Thrust(mo, slideangle-ANGLE_90, savespeed/64)
	end
	*/
end, MT_PLAYER)

addHook("PreThinkFrame", function(player)
	for player in players.iterate do
		if not player then return end
		if not player.valid then return end
		if not player.mo then return end
		if not player.mo.valid then return end
		if player.mo
			if cv_autofire.value == 1
			and player.rsp_autofire == 1
				if (leveltime % 8) == 4
					if (player.cmd.buttons & BT_ATTACK)
						player.cmd.buttons = $ - BT_ATTACK
					end
					if (player.cmd.buttons & BT_FIRENORMAL)
						player.cmd.buttons = $ - BT_FIRENORMAL
					end
				end
			end
			if not player.mo.dashdelay
				player.mo.dashdelay = 0
			else
				if P_IsObjectOnGround(player.mo)
					player.mo.dashdelay = 0
				end
				if player.mo.dashdelay != 0
					player.mo.dashdelay = $ - 1
				end
			end
			if cv_allowability.value != 1
				if player.charability != 0
					player.charability = 0
					if (player.charflags & SF_NOJUMPSPIN)
						player.charflags = $ - SF_NOJUMPSPIN
					end
					if (player.charflags & SF_NOJUMPDAMAGE)
						player.charflags = $ - SF_NOJUMPDAMAGE
					end
				end
			end
			if cv_allowability2.value != 1
				if player.charability2 != 0
					player.charability2 = 0
				end
			end
			if cv_allowability2.value == 2
				if player.dashdelay2 == nil then player.dashdelay2 = 0 end
				if player.dashdelay2 != 0 then player.dashdelay2 = $ - 1 end
				if player.dashpressed == nil then player.dashpressed = false end
				if (player.cmd.buttons & BT_SPIN) and not (player.cmd.buttons & BT_JUMP) and player.powers[pw_nocontrol] == 0 and player.rsp_menu == nil and player.dashdelay2 == 0 and player.gotflag == 0
					if player.dashpressed == false
						if not P_IsObjectOnGround(player.mo) then return end
						P_DoJump(player, false)
						local realspeed = R_PointToDist2(0, 0, player.mo.momx, player.mo.momy)
						local savespeed = realspeed+(realspeed/96)
						local defaultspeed = 36*player.mo.scale
						local moveangle = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy)
						if realspeed >= 36*FRACUNIT
							P_InstaThrust(player.mo, player.mo.angle, savespeed)
						//elseif player.cmd.forwardmove != 0 or player.cmd.sidemove != 0
							//local dash_by_button = R_PointToAngle2(0, 0, player.cmd.forwardmove, player.cmd.sidemove)
							//P_InstaThrust(player.mo, AngleFixed(player.mo.angle)+AngleFixed(dash_by_button), defaultspeed)
						else
							P_InstaThrust(player.mo, player.mo.angle, defaultspeed)
						end
						S_StartSound(player.mo, sfx_s1bb)
						P_SetObjectMomZ(player.mo, player.mo.scale*8)
						player.panim = PA_JUMP
						player.mo.state = S_PLAY_JUMP
						player.dashpressed = true
						player.dashdelay2 = 35
						player.pflags = $ + PF_THOKKED
					end
				else
					if player.dashpressed == true
						player.dashpressed = false
					end
				end
			end
		end
		//Deleting shield
		if cv_allowshield.value != 1
			player.powers[pw_shield] = SH_NONE
		end
	end
end)

//Works in almost all gametypes.
addHook("PlayerThink", function(player)
	if player.mo
	and player.mo.valid
	and player.playerstate == PST_LIVE
		//Hold jump button to jump
		if cv_autojump.value == 1 and player.rsp_autojump != "0"
		and (gametype != GT_HIDEANDSEEK)
		and player.rsp_menu == nil
			if (player.cmd.buttons & BT_JUMP)
			and P_IsObjectOnGround(player.mo)
			and player.powers[pw_nocontrol] == 0
				P_DoJump(player)
			end
		end
		if G_RingSlingerGametype()
		or G_IsHASGametype()
			if not (player.mo.flags2 & MF2_BOUNCERING)
				player.mo.flags2 = $ + MF2_BOUNCERING
			end
			if not player.countdown_rj
				player.countdown_rj = 0
				player.count_rj = 0
			else
				if player.countdown_rj != 0
					player.countdown_rj = $ - 1
				else
					if player.count_rj != 0 then player.count_rj = 0 end
				end
			end
			if player.mo.pst != 1
				player.mo.pst = 1
				player.rsp_live = true
				player.rsp_dead = nil
			end
			RSP_Player_Is_Ghost(player)
			//Resurrect the dead.
			if leveltime <= 1
				player.mo.frame = $1 & ~FF_TRANS70
				player.mo.flags = $1 & ~MF_NOCLIPTHING
				player.mo.flags = $1 & ~MF_NOGRAVITY
				player.mo.color = player.skincolor
				player.mo.colorize = false
				player.mo.shadowscale = FRACUNIT
				player.charability = skins[player.mo.skin].ability
				player.charability2 = skins[player.mo.skin].ability2
				player.jumpfactor = skins[player.mo.skin].jumpfactor
				player.normalspeed = skins[player.mo.skin].normalspeed
				player.actionspd = skins[player.mo.skin].actionspd
			end
			//Timer before round. and clean the score.
			if RSP.DATA.round_ready == false
			and not G_IsHASGametype()
				player.realtime = RSP.DATA.readytimer
				player.score = 0
			end
			//Return weapons and ammo
			if cv_keepweapons.value == 1 or (mapheaderinfo[gamemap].rsp_mapkeepweapons) or G_IsFFAGametype()
				KeepWeapons_rsp(player, mo)
			end
			//Moveset for Ghost players
			if player.rspghostplayer == true
				if (player.cmd.buttons & BT_JUMP)
					player.mo.z = $ + 16*FRACUNIT
				end
				if (player.cmd.buttons & BT_SPIN)
					player.mo.z = $ - 16*FRACUNIT
				end
				if P_IsObjectOnGround(player.mo)
					player.mo.z = $ + 4*FRACUNIT
				end
			end
		end
		if player.mo
		and player.mo.valid
		and player.playerstate == PST_DEAD
			if player.mo.pst != 0
				player.mo.pst = 0
				player.rsp_live = nil
				player.rsp_dead = true
			end
		end
	end
end, MT_PLAYER)

//Show spawnpoints in ringlinger modes.
rawset(_G, "rsp_viewspawnpoint", function(mapthing, sector)
	if cv_rspspawnpoint.value == 1
		if G_RingSlingerGametype() or G_IsHASGametype()
			for mapthing in mapthings.iterate do
				if mapthing
				and mapthing.valid
					if mapthing.type == 0
					local mapthing_z
					local sector = R_PointInSubsector(mapthing.x*FRACUNIT, mapthing.y*FRACUNIT).sector
						if sector
						and sector.valid
							if (mapthing.options & MTF_OBJECTFLIP)
							mapthing_z = sector.ceilingheight-(mapthing.z*FRACUNIT)
							else
							mapthing_z = sector.floorheight+(mapthing.z*FRACUNIT)
							end
						end
					P_SpawnMobj(mapthing.x*FRACUNIT, mapthing.y*FRACUNIT, mapthing_z, MT_DMSPAWNPOINT)
					end
				end
			end
		end
    end
end)
addHook("MapLoad", rsp_viewspawnpoint)

addHook("MobjMoveBlocked", function(ring)
	if ring
	and ring.valid
		if cv_grenadeoptimization.value == 1
			local nolexplode = P_SpawnMobj(ring.x, ring.y, ring.z, MT_NIGHTSPARKLE)
			nolexplode.state = S_FBOMB_EXPL1
			P_KillMobj(ring)
		end
	end
end, MT_THROWNEXPLOSION)

//Killing explosion ring.
local function rsp_RocketJump(ring)
	if G_RingSlingerGametype() or G_IsHASGametype()
		if ring
		and ring.valid
			if cv_rjenabled.value == 1
				if ring.state == S_RINGEXPLODE
					P_KillMobj(ring)
					if cv_grenadeoptimization.value == 1
						local nolexplode = P_SpawnMobj(ring.x, ring.y, ring.z, MT_NIGHTSPARKLE)
						nolexplode.state = S_FBOMB_EXPL1
					end
				end
			end
		end
	end
end
addHook("MobjThinker", rsp_RocketJump, MT_THROWNEXPLOSION)

//RocketJump.
local function rsp_DoRocketJump(ring)
	if G_RingSlingerGametype() or G_IsHASGametype()
		if ring
		and ring.valid
			if cv_rjenabled.value == 1
				for player in players.iterate do
					if player.mo
					and player.mo.valid
					and player.playerstate == PST_LIVE
					local dist = R_PointToDist2(ring.x, ring.y, player.mo.x, player.mo.y)
					local dist2 = P_AproxDistance(0, player.mo.z-ring.z)
					local angle = R_PointToAngle2(ring.x, ring.y, player.mo.x, player.mo.y)
						if dist < 152*FRACUNIT
						and dist2 < 152*FRACUNIT
							if cv_aarj.value == 0
								if not (player.pflags & PF_THOKKED) then player.pflags = $ + PF_THOKKED end
							end
							if cv_blowdamage.value != 0
								if player.mo == ring.target
									if player.rings >= cv_blowdamage.value
										//P_PlayerRingBurst(player, 9)
										player.rings = $ - cv_blowdamage.value
										player.countdown_rj = 35
										player.count_rj = $ + cv_blowdamage.value
										if player.powers[pw_flashing] == 0
											player.powers[pw_flashing] = 35
										end
									else
										if player.powers[pw_invulnerability] == 0 and player.powers[pw_flashing] == 0 and player.powers[pw_super] == 0
											if player.rings != 0 or player.powers[pw_shield] != 0
												P_DoPlayerPain(player, player.mo, ring)
												if player.powers[pw_shield] != 0
													if player.powers[pw_shield] == 257
														player.powers[pw_shield] = 256
													else
														player.powers[pw_shield] = 0
													end
												else
													P_PlayerRingBurst(player, player.rings)
													//P_PlayerWeaponPanelOrAmmoBurst(player)
													P_PlayerEmeraldBurst(player)
													P_PlayerFlagBurst(player)
													P_PlayRinglossSound(player.mo, player)
													player.rings = 0
												end
												print(player.name.." got pain from the explosion.")
											else
												P_PlayerFlagBurst(player)
												P_KillMobj(player.mo, ring, player.mo)
												print(player.name.." was killed by the explosion, mistreated the weapon.")
											end
										end
									end
								end
							end
							local horizontalAngle = R_PointToAngle2(ring.x, ring.y, player.mo.x, player.mo.y)
							local verticalAngle = R_PointToAngle2(FixedHypot(ring.x, ring.y), ring.z+(ring.height/2),FixedHypot(player.mo.x, player.mo.y), player.mo.z+(player.mo.height/2))
							P_SetObjectMomZ(player.mo, rocketjump_power.value*sin(verticalAngle), true)
							P_Thrust(player.mo, horizontalAngle, rocketjump_power.value*abs(cos(verticalAngle)))
						end
					end
				end
			end
		end
	end
end
addHook("MobjDeath", rsp_DoRocketJump, MT_THROWNEXPLOSION)

//Change the functions of the grenade.
local function rsp_GrenadeJump(ring)
	if G_RingSlingerGametype() or G_IsHASGametype()
		if ring
		and ring.valid
		and ring.health
			//When to detonate a grenade?
			if ring.timerexplosion == nil
				ring.timerexplosion = cv_timerexplosion.value
			end
			if ring.timerexplosion != 0
				ring.timerexplosion = $ - 1
			end
			//Detonate a grenade if it stops bouncing.
			if (ring.momz == 0 and ring.explosionpersec == nil)
				ring.explosionpersec = 45
			end
			if ring.explosionpersec != nil
				ring.explosionpersec = $ -1
			end
			//Do not let the grenade explode in your hands.
			if ring.saveyourhands == nil
				ring.saveyourhands = 20
			end
			if ring.saveyourhands != 0
				ring.saveyourhands = $ - 1
			end
			//When to detonade it?
			if ring.timerexplosion == 0 or ring.explosionpersec == 0
				if cv_grenadeoptimization.value == 1
					local nolexplode = P_SpawnMobj(ring.x, ring.y, ring.z, MT_NIGHTSPARKLE)
					nolexplode.state = S_FBOMB_EXPL1
				end
				if ring.state != ring.info.deathstate
					ring.state = ring.info.deathstate
					P_KillMobj(ring)
				end
			end
			for player in players.iterate do
				if player.mo
				and player.mo.valid
				and player.playerstate == PST_LIVE
					local dist = R_PointToDist2(ring.x, ring.y, player.mo.x, player.mo.y)
					local dist2 = P_AproxDistance(0, player.mo.z-ring.z)
					if cv_rjenabled.value == 1
						if (dist <56*FRACUNIT and dist2 < 56*FRACUNIT)
							if player.mo == ring.target
							and ring.saveyourhands != 0
								return
							end
							if cv_grenadeoptimization.value == 1
								local nolexplode = P_SpawnMobj(ring.x, ring.y, ring.z, MT_NIGHTSPARKLE)
								nolexplode.state = S_FBOMB_EXPL1
							end
							if ring.state != ring.info.deathstate
								ring.state = ring.info.deathstate
								P_KillMobj(ring)
							end
						end
					end
				end
			end
		end
	end
end
addHook("MobjThinker", rsp_GrenadeJump, MT_THROWNGRENADE)

//And GrenadeJump.
local function rsp_DoGrenadeJump(ring)
	if G_RingSlingerGametype() or G_IsHASGametype()
		if ring
		and ring.valid
			if cv_rjenabled.value == 1
				for player in players.iterate do
					if player.mo
					and player.mo.valid
					and player.playerstate == PST_LIVE
					local dist = R_PointToDist2(ring.x, ring.y, player.mo.x, player.mo.y)
					local dist2 = P_AproxDistance(0, player.mo.z-ring.z)
					local angle = R_PointToAngle2(ring.x, ring.y, player.mo.x, player.mo.y)
						if dist < 152*FRACUNIT
						and dist2 < 152*FRACUNIT
							if cv_aarj.value == 0
								if not (player.pflags & PF_THOKKED) then player.pflags = $ + PF_THOKKED end
							end
							if cv_blowdamage.value != 0
								if player.mo == ring.target
									if player.rings >= cv_blowdamage.value
										//P_PlayerRingBurst(player, 9)
										player.rings = $ - cv_blowdamage.value
										player.countdown_rj = 35
										player.count_rj = $ + cv_blowdamage.value
										if player.powers[pw_flashing] == 0
											player.powers[pw_flashing] = 35
										end
									else
										if player.powers[pw_invulnerability] == 0 and player.powers[pw_flashing] == 0 and player.powers[pw_super] == 0
											if player.rings != 0 or player.powers[pw_shield] != 0
												P_DoPlayerPain(player, player.mo, ring)
												if player.powers[pw_shield] != 0
													if player.powers[pw_shield] == 257
														player.powers[pw_shield] = 256
													else
														player.powers[pw_shield] = 0
													end
												else
													P_PlayerRingBurst(player, player.rings)
													//P_PlayerWeaponPanelOrAmmoBurst(player)
													P_PlayerEmeraldBurst(player)
													P_PlayerFlagBurst(player)
													P_PlayRinglossSound(player.mo, player)
													player.rings = 0
												end
												print(player.name.." got pain from the explosion.")
											else
												P_PlayerFlagBurst(player)
												P_KillMobj(player.mo, ring, player.mo)
												print(player.name.." was killed by the explosion, mistreated the weapon.")
											end
										end
									end
								end
							end
							local grenadeforce = rocketjump_power.value
							local horizontalAngle = R_PointToAngle2(ring.x, ring.y, player.mo.x, player.mo.y)
							local verticalAngle = R_PointToAngle2(FixedHypot(ring.x, ring.y), ring.z+(ring.height/2),FixedHypot(player.mo.x, player.mo.y), player.mo.z+(player.mo.height/2))
							P_SetObjectMomZ(player.mo, grenadeforce*sin(verticalAngle), true)
							P_Thrust(player.mo, horizontalAngle, grenadeforce*abs(cos(verticalAngle)))
						end
					end
				end
			end
		end
	end
end
addHook("MobjDeath", rsp_DoGrenadeJump, MT_THROWNGRENADE)

addHook("IntermissionThinker", function()
	if RSP.DATA.getready == false
		RSP.DATA.getready = true
	end
end)

addHook("PreThinkFrame", function()
	for player in players.iterate do
		if G_RingSlingerGametype()
		or G_IsHASGametype()
			//Return delay from ringweapon
			if cv_quickswitching.value == 1
				RSP_QuickSwitching(player)
			end
		end
	end
end)

addHook("MapLoad", function(player)
	RSP.DATA.playertable = {}
	RSP.DATA.playertablelive = {}
	RSP.DATA.round_ready = false
	RSP.DATA.readytimer = cv_rspgetready.value*TICRATE
	RSP.DATA.winner = false
	RSP.DATA.round_over = false
	RSP.DATA.lose = false
	if mobjinfo[MT_NIGHTSPARKLE] != {spawnstate = 2397}
		mobjinfo[MT_NIGHTSPARKLE] = {spawnstate = 2397, flags = MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY}
	end
	for player in players.iterate
		player.rsp_menu = nil
		player.rsp_mcam = nil
		player.rsp_navmenu = nil
		hud.enable("textspectator")
		if player.rspghostplayer == true
			player.rspghostplayer = false
		end
	end
end)	
