 -- RingSlingerPlus
 -- 4-RSP_Misc.lua
 -- 12.07.2023
 -- Sirexer

RSP.Sounds = {}

RSP.Sounds.Hits = {}
RSP.Sounds.Hits[0] = sfx_rspht0
RSP.Sounds.Hits[1] = sfx_rspht1
RSP.Sounds.Hits[2] = sfx_rspht2
RSP.Sounds.Hits[3] = sfx_rspht3

RSP.Hits = {}


RSP.Framerings = {
	ring = 0,
	weapon = 0
}

addHook("ViewpointSwitch", function(player, viewplayer, forced)
	if RSP.hud[viewplayer.rsp_hud].v_score == true
		hud.enable("score")
	else
		hud.disable("score")
	end
	if RSP.hud[viewplayer.rsp_hud].v_time == true
		hud.enable("time")
	else
		hud.disable("time")
	end
	if RSP.hud[viewplayer.rsp_hud].v_rings == true
		hud.enable("rings")
	else
		hud.disable("rings")
	end
	if RSP.hud[viewplayer.rsp_hud].v_lives == true
		hud.enable("lives")
	else
		hud.disable("lives")
	end
	if RSP.hud[viewplayer.rsp_hud].v_teamscores == true
		hud.enable("teamscores")
	else
		hud.disable("teamscores")
	end
	if RSP.hud[viewplayer.rsp_hud].v_powerstones == true
		hud.enable("powerstones")
	else
		hud.disable("powerstones")
	end
end)

addHook("ThinkFrame", do
	if leveltime == 0
		hud.enable("textspectator")
		hud.enable("rankings")
		hud.enable("intermissiontally")
	end
	if hud.enabled("weaponrings") then hud.disable("weaponrings") end
	if RSP.Framerings.ring < 23 then RSP.Framerings.ring = $ + 1
	elseif RSP.Framerings.ring >= 23 then RSP.Framerings.ring = 0 end
	if RSP.Framerings.weapon < 34 then RSP.Framerings.weapon = $ + 1
	elseif RSP.Framerings.weapon >= 34 then RSP.Framerings.weapon = 0 end
	if RSP.Hits[1] != nil
		for i = 1, #RSP.Hits do
			if RSP.Hits[i]
				if RSP.Hits[i].countdown != 0
					RSP.Hits[i].countdown = $ - 1
				else
					table.remove(RSP.Hits, i)
				end
			end
		end
	end
end)

local function SetHitTable(target, inflictor, source, killed)
	if gamestate != GS_LEVEL
		return
	end
	local weaponspr
	local t
	if source.player != nil
		if inflictor == "nuke"
			weaponspr = "TVARICON"
		elseif inflictor == "fire"
			weaponspr = "RSPFIRED"
		elseif inflictor.type == 530
			if (inflictor.flags2 & MF2_RAILRING)
				weaponspr = "RAILIND"
			else
				weaponspr = "RINGIND"
			end
		elseif inflictor.type == 545
			weaponspr = "INFNIND"
		elseif inflictor.type == 546
			weaponspr = "AUTOIND"
		elseif inflictor.type == 544
			weaponspr = "BNCEIND"
		elseif inflictor.type == 547
			weaponspr = "SCATIND"
		elseif inflictor.type == 549
			weaponspr = "GRENIND"
		elseif inflictor.type == 548
			weaponspr = "BOMBIND"
		else
			weaponspr = "RINGIND"
		end
		t = {
		target = target.player.name,
		t_color = RSP.chatcolors[skincolors[target.color].chatcolor],
		weapon = weaponspr,
		source = source.player.name,
		s_color = RSP.chatcolors[skincolors[source.color].chatcolor],
		killed = killed,
		countdown = 175
		}
	else
		if source == "water"
			weaponspr = "RSPWATER"
		elseif source == "fire"
			weaponspr = "RSPFIRED"
		elseif source == "electric"
			weaponspr = "RSPSPARK"
		elseif source == "spike"
			weaponspr = "RSPSPIKE"
		elseif source == "drown"
			weaponspr = "RSPDROWN"
		elseif source == "death"
			weaponspr = "RSPDEAD"
		end
		t = {
		target = target.player.name,
		t_color = RSP.chatcolors[skincolors[target.color].chatcolor],
		weapon = weaponspr,
		source = "hazard",
		killed = true,
		countdown = 175
		}
	end
	table.insert(RSP.Hits, t)
end

addHook("MobjDamage", function(target, inflictor, source, damage, damagetype)
	if G_RingSlingerGametype()
		if target and source
			if source.player
				if target.valid and source.valid
					if damagetype == 2 then inflictor = "fire"
					elseif damagetype == 5 then inflictor = "nuke" end
					if target.player.rings == 0 and target.player.powers[pw_shield] == 0
						S_StartSound(nil, sfx_rspkil, source.player)
						SetHitTable(target, inflictor, source, true)
					elseif target.player.rings != 0 or target.player.powers[pw_shield] != 0
						local soundhit = P_RandomKey(#RSP.Sounds.Hits+1)
						S_StartSound(nil, RSP.Sounds.Hits[soundhit], source.player)
						SetHitTable(target, inflictor, source, false)
					end
				end
			end
		end
	end
end, MT_PLAYER)

addHook("MobjDeath", function(target, inflictor, source, damagetype)
	if G_RingSlingerGametype()
		if source
			if source.player then return end
		end
		if damagetype == 1
			SetHitTable(target, inflictor, "water", true)
		elseif damagetype == 2
			SetHitTable(target, inflictor, "fire", true)
		elseif damagetype == 3
			SetHitTable(target, inflictor, "electric", true)
		elseif damagetype == 4
			SetHitTable(target, inflictor, "spike", true)
		elseif damagetype == 129
			SetHitTable(target, inflictor, "drown", true)
		elseif damagetype == 130
			SetHitTable(target, inflictor, "drown", true)
		elseif damagetype == 131
			SetHitTable(target, inflictor, "death", true)
		elseif damagetype == 132
			SetHitTable(target, inflictor, "death", true)
		else
			SetHitTable(target, inflictor, "death", true)
		end
	end
end, MT_PLAYER)

//HUD Hit Feed
local HUDHITS = function(v, player, mo, cam)
	if not G_RingSlingerGametype() then return end
	local x = 320
	local y = 4
	local quantity = 0
	if RSP.Hits[1] != nil
		for i = 1, #RSP.Hits do
			if RSP.Hits[i].source != "hazard"
				if RSP.Hits[i].source and RSP.Hits[i].target
					local patch = v.cachePatch(RSP.Hits[i].weapon)
					local namelen = (string.len(RSP.Hits[i].target)*5)*FRACUNIT
					local s_col = RSP.Hits[i].s_color
					local t_col = RSP.Hits[i].t_color
					local comp = 2
					if RSP.Hits[i].weapon == "TVARICON" then comp = 4 
					elseif RSP.Hits[i].weapon == "RSPFIRED" then comp = 2 end
					v.drawString(x, y+(10*quantity), (s_col..RSP.Hits[i].source.."  "..t_col..RSP.Hits[i].target), V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP|V_MONOSPACE, "thin-right")
					v.drawScaled(((x*FRACUNIT)-namelen), (y*FRACUNIT)+((10*quantity)*FRACUNIT)-FRACUNIT, FRACUNIT/comp, patch, V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP|V_MONOSPACE, nil)
					if RSP.Hits[i].killed == true
						v.drawScaled(((x*FRACUNIT)-(namelen)-(FRACUNIT*8)), (y*FRACUNIT)+((10*quantity)*FRACUNIT)+(FRACUNIT*3), FRACUNIT/8, v.cachePatch("M_FNOPE"), V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP|V_MONOSPACE, nil)
					end
					quantity = $ + 1
				end
			elseif RSP.Hits[i].source == "hazard"
				if RSP.Hits[i].target
					local patch = v.cachePatch(RSP.Hits[i].weapon)
					local namelen = (string.len(RSP.Hits[i].target)*5)*FRACUNIT
					local t_col = RSP.Hits[i].t_color
					local comp = 2
					if RSP.Hits[i].weapon == "RSPWATER" then comp = 2 
					elseif RSP.Hits[i].weapon == "RSPFIRED" then comp = 2
					elseif RSP.Hits[i].weapon == "RSPSPARK" then comp = 2 
					elseif RSP.Hits[i].weapon == "RSPSPIKE" then comp = 4 
					elseif RSP.Hits[i].weapon == "RSPDROWN" then comp = 4 
					elseif RSP.Hits[i].weapon == "RSPDEAD" then comp = 4 end
					v.drawString(x, y+(10*quantity), (t_col..RSP.Hits[i].target), V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP|V_MONOSPACE, "thin-right")
					v.drawScaled(((x*FRACUNIT)-namelen), (y*FRACUNIT)+((10*quantity)*FRACUNIT)-FRACUNIT, FRACUNIT/comp, patch, V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP|V_MONOSPACE, col)
					quantity = $ + 1
				end
			end
		end
	end
end
hud.add(HUDHITS)

local function RSPCROSSHAIR(v) local player = displayplayer
	local cv_chasecam = CV_FindVar("Chasecam")
	if player.mo
	and player.mo.valid
	and player.playerstate == PST_LIVE
		if player.rsp_crosshair and player.rsp_crosshair_scale
			if player.rsp_crosshair != 0 and player.rsp_crosshair != "a" and player.rsp_crosshair != "b" and player.rsp_crosshair != "c"
				if cv_chasecam.value == 0 
					if player.rsp_crosshair_color == 0 or player.rsp_crosshair_color == nil
						v.drawScaled((160*FRACUNIT)-32768, 101*FRACUNIT, (player.rsp_crosshair_scale*8192), v.cachePatch("RSPCSH"..player.rsp_crosshair), V_SUBTRACT, v.getColormap(nil, SKINCOLOR_WHITE))
					else
						v.drawScaled((160*FRACUNIT)-32768, 101*FRACUNIT, (player.rsp_crosshair_scale*8192), v.cachePatch("RSPCSH"..player.rsp_crosshair), 0, v.getColormap(nil, player.rsp_crosshair_color))
					end
				end
			elseif player.rsp_crosshair == "a" or player.rsp_crosshair == "b" or player.rsp_crosshair == "c"
				if cv_chasecam.value == 0 
					v.drawScaled((160*FRACUNIT)-32768, 101*FRACUNIT, FRACUNIT, v.cachePatch("SRBVHAI"..player.rsp_crosshair), V_30TRANS, v.getColormap(nil, SKINCOLOR_GREEN))
				end
			end
		end
		if player.rsp_crosshair_alt and player.rsp_crosshair_scale
			if player.rsp_crosshair_alt != 0 and player.rsp_crosshair_alt != "a" and player.rsp_crosshair_alt != "b" and player.rsp_crosshair_alt != "c"
				if cv_chasecam.value == 0 
					if player.rsp_crosshair_color == 0 or player.rsp_crosshair_color == nil
						v.drawScaled((160*FRACUNIT)-32768, 101*FRACUNIT, (player.rsp_crosshair_scale*8192), v.cachePatch("RSPCSH"..player.rsp_crosshair_alt), V_SUBTRACT, v.getColormap(nil, SKINCOLOR_WHITE))
					else
						v.drawScaled((160*FRACUNIT)-32768, 101*FRACUNIT, (player.rsp_crosshair_scale*8192), v.cachePatch("RSPCSH"..player.rsp_crosshair_alt), 0, v.getColormap(nil, player.rsp_crosshair_color))
					end
				end
			elseif player.rsp_crosshair_alt == "a" or player.rsp_crosshair_alt == "b" or player.rsp_crosshair_alt == "c"
				if cv_chasecam.value == 0 
					v.drawScaled((160*FRACUNIT)-32768, 101*FRACUNIT, FRACUNIT, v.cachePatch("SRBVHAI"..player.rsp_crosshair_alt), V_30TRANS, v.getColormap(nil, SKINCOLOR_GREEN))
				end
			end
		end
	end
end
hud.add(RSPCROSSHAIR)

//Show your character holding the ring in firstperson. From RSNEO
local holdingring = function(v, player, mo, cam)
	if not G_RingSlingerGametype() then return end
	if player.rsp_hud == 1 and player.rsp_bghud == 1 then return end
	if camera.chase == true
		return
	end
	if player.spectator == true then return end
	if player.playerstate != PST_LIVE then return end
	if not player.mo then return end
	if not player.mo.valid then return end
	local col = nil
	local patch
	if player.currentweapon == 0
		if player.powers[pw_infinityring] != 0 then patch = v.cachePatch("RNGID0")
		elseif player.rings != 0 then patch = v.cachePatch("TRNGD0V0")
		elseif player.rings == 0 then patch = v.cachePatch("EMPT") end
		col = v.getColormap(TC_DEFAULT, SKINCOLOR_RED)
	elseif player.currentweapon == 1
		if player.powers[pw_automaticring] != 0 then patch = v.cachePatch("RNGAD0")
		else patch = v.cachePatch("EMPT") end
	elseif player.currentweapon == 2
		if player.powers[pw_bouncering] != 0 then patch = v.cachePatch("RNGBD0")
		else patch = v.cachePatch("EMPT") end
	elseif player.currentweapon == 3
		if player.powers[pw_scatterring] != 0 then patch = v.cachePatch("RNGSD0")
		else patch = v.cachePatch("EMPT") end
	elseif player.currentweapon == 4
		if player.powers[pw_grenadering] != 0 then patch = v.cachePatch("RNGGD0")
		else patch = v.cachePatch("EMPT") end
	elseif player.currentweapon == 5
		if player.powers[pw_explosionring] != 0 then patch = v.cachePatch("RNGED0")
		else patch = v.cachePatch("EMPT") end
	elseif player.currentweapon == 6
		if player.powers[pw_railring] != 0 then patch = v.cachePatch("RNGRD0")
		else patch = v.cachePatch("EMPT") end
	elseif player.currentweapon == 7
		patch = v.cachePatch("EMPT")
	end
	local scale = (FRACUNIT) * 12/5
	local x, y
	x = 230*FRACUNIT - player.weapondelay*FRACUNIT
	y = 220*FRACUNIT + player.weapondelay*FRACUNIT
	
	if not splitscreen
		v.drawScaled(x, y, scale, patch, V_SNAPTOBOTTOM | V_SNAPTORIGHT | V_PERPLAYER, col)
	end
end
hud.add(holdingring)

//HUD for Ringslinger's gametypes.
local function RSPHUD(v) local player = displayplayer
	local flag_j = V_70TRANS
	local flag_u = V_70TRANS
	local flag_d = V_70TRANS
	local flag_s = V_70TRANS
	local flag_f = V_70TRANS
	local flag_l = V_70TRANS
	local flag_n = V_70TRANS
	local flag_r = V_70TRANS
	if player.rsp_hud_buttons == 1
		/*
		if (player.cmd.buttons & BT_JUMP) then flag_j = V_10TRANS end
		if player.cmd.forwardmove >= 15 then flag_u = V_10TRANS end
		if player.cmd.forwardmove <= -15 then flag_d = V_10TRANS end
		if (player.cmd.buttons & BT_SPIN) then flag_s = V_10TRANS end
		if (player.cmd.buttons & BT_ATTACK) then flag_f = V_10TRANS end
		if player.cmd.sidemove <= -15 then flag_l = V_10TRANS end
		if (player.cmd.buttons & BT_FIRENORMAL) then flag_n = V_10TRANS end
		if player.cmd.sidemove >= 15 then flag_r = V_10TRANS end
		*/
		
		if input.gameControlDown(GC_JUMP) then flag_j = V_10TRANS end
		if input.gameControlDown(GC_FORWARD) then flag_u = V_10TRANS end
		if input.gameControlDown(GC_BACKWARD) then flag_d = V_10TRANS end
		if input.gameControlDown(GC_SPIN) then flag_s = V_10TRANS end
		if input.gameControlDown(GC_FIRE) then flag_f = V_10TRANS end
		if input.gameControlDown(GC_STRAFELEFT) then flag_l = V_10TRANS end
		if input.gameControlDown(GC_FIRENORMAL) then flag_n = V_10TRANS end
		if input.gameControlDown(GC_STRAFERIGHT) then flag_r = V_10TRANS end
		
		v.drawScaled((RSP.hud[player.rsp_hud].button_x+17)*FRACUNIT, (RSP.hud[player.rsp_hud].button_y+0)*FRACUNIT, FRACUNIT/2, v.cachePatch("RSPBJUMP"), RSP.hud[player.rsp_hud].button_flags + flag_j)
		v.drawScaled((RSP.hud[player.rsp_hud].button_x+17)*FRACUNIT, (RSP.hud[player.rsp_hud].button_y+17)*FRACUNIT, FRACUNIT/2, v.cachePatch("RSPBUP"), RSP.hud[player.rsp_hud].button_flags + flag_u)
		v.drawScaled((RSP.hud[player.rsp_hud].button_x+17)*FRACUNIT, (RSP.hud[player.rsp_hud].button_y+34)*FRACUNIT, FRACUNIT/2, v.cachePatch("RSPBDOWN"), RSP.hud[player.rsp_hud].button_flags + flag_d)
		v.drawScaled((RSP.hud[player.rsp_hud].button_x+17)*FRACUNIT, (RSP.hud[player.rsp_hud].button_y+51)*FRACUNIT, FRACUNIT/2, v.cachePatch("RSPBSPIN"), RSP.hud[player.rsp_hud].button_flags + flag_s)
		
		v.drawScaled((RSP.hud[player.rsp_hud].button_x+0)*FRACUNIT, (RSP.hud[player.rsp_hud].button_y+17)*FRACUNIT, FRACUNIT/2, v.cachePatch("RSPBFIRE"), RSP.hud[player.rsp_hud].button_flags + flag_f)
		v.drawScaled((RSP.hud[player.rsp_hud].button_x+0)*FRACUNIT, (RSP.hud[player.rsp_hud].button_y+34)*FRACUNIT, FRACUNIT/2, v.cachePatch("RSPBLEFT"), RSP.hud[player.rsp_hud].button_flags + flag_l)
		
		v.drawScaled((RSP.hud[player.rsp_hud].button_x+34)*FRACUNIT, (RSP.hud[player.rsp_hud].button_y+17)*FRACUNIT, FRACUNIT/2, v.cachePatch("RSPBNFRE"), RSP.hud[player.rsp_hud].button_flags + flag_n)
		v.drawScaled((RSP.hud[player.rsp_hud].button_x+34)*FRACUNIT, (RSP.hud[player.rsp_hud].button_y+34)*FRACUNIT, FRACUNIT/2, v.cachePatch("RSPBRIGT"), RSP.hud[player.rsp_hud].button_flags + flag_r)
	end
	local cv_hidetime = CV_FindVar("hidetime")
	local hidetimer = cv_hidetime.value*TICRATE - leveltime
	local hud_centiseconds
	local hud_seconds
	local hud_minutes
	if cv_rsptimelimit.value == 0
		hud_centiseconds = G_TicsToCentiseconds(player.realtime)
		hud_seconds = G_TicsToSeconds(player.realtime)
		hud_minutes = G_TicsToMinutes(player.realtime, true)
	else
		hud_centiseconds = G_TicsToCentiseconds((cv_rsptimelimit.value*TICRATE*60) - leveltime)
		hud_seconds = G_TicsToSeconds((cv_rsptimelimit.value*TICRATE*60) - leveltime)
		hud_minutes = G_TicsToMinutes((cv_rsptimelimit.value*TICRATE*60) - leveltime, true)
	end
	if G_TagGametype()
		if leveltime <= cv_hidetime.value*TICRATE
			hud_centiseconds = G_TicsToCentiseconds(hidetimer)
			hud_seconds = G_TicsToSeconds(hidetimer)
			hud_minutes = G_TicsToMinutes(hidetimer, true)
		else
			if cv_rsptimelimit.value == 0
				hud_centiseconds = G_TicsToCentiseconds(leveltime-(cv_hidetime.value*TICRATE))
				hud_seconds = G_TicsToSeconds(leveltime-(cv_hidetime.value*TICRATE))
				hud_minutes = G_TicsToMinutes(leveltime-(cv_hidetime.value*TICRATE), true)
			else
				hud_centiseconds = G_TicsToCentiseconds((cv_rsptimelimit.value*TICRATE*60) - leveltime)
				hud_seconds = G_TicsToSeconds((cv_rsptimelimit.value*TICRATE*60) - leveltime +(cv_hidetime.value*TICRATE))
				hud_minutes = G_TicsToMinutes((cv_rsptimelimit.value*TICRATE*60) - leveltime +(cv_hidetime.value*TICRATE), true)
			end
		end
	end
	if string.len(hud_seconds) == 1 then hud_seconds = "0"..tostring(hud_seconds) end
	if string.len(hud_centiseconds) == 1 then hud_centiseconds = "0"..tostring(hud_centiseconds) end
	local hud_time = hud_minutes..":"..hud_seconds.."."..hud_centiseconds
	local p_r_flags = V_SNAPTOBOTTOM|V_HUDTRANS
	local h_ring_color = SKINCOLOR_WHITE
	if player.rings == 0 and (G_TicsToSeconds(leveltime) % 2) != 1 then h_ring_color = SKINCOLOR_RED end
	if RSP.Framerings.ring < 13 then p_r_flags = V_SNAPTOBOTTOM|V_HUDTRANS
	elseif RSP.Framerings.ring >= 13 then p_r_flags = V_SNAPTOBOTTOM|V_HUDTRANS|V_FLIP end
	//QUAKE HUD
	if player.rsp_hud == 1
		if player.rsp_bghud == 1
			v.drawScaled(32*FRACUNIT, 168*FRACUNIT, FRACUNIT/2, v.cachePatch("THZWALLF"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(64*FRACUNIT, 168*FRACUNIT, FRACUNIT/2, v.cachePatch("THZWALLF"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(96*FRACUNIT, 168*FRACUNIT, FRACUNIT/2, v.cachePatch("THZWALLF"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(128*FRACUNIT, 168*FRACUNIT, FRACUNIT/2, v.cachePatch("THZWALLF"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(160*FRACUNIT, 168*FRACUNIT, FRACUNIT/2, v.cachePatch("THZWALLF"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(192*FRACUNIT, 168*FRACUNIT, FRACUNIT/2, v.cachePatch("THZWALLF"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(224*FRACUNIT, 168*FRACUNIT, FRACUNIT/2, v.cachePatch("THZWALLF"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(256*FRACUNIT, 168*FRACUNIT, FRACUNIT/2, v.cachePatch("THZWALLF"), V_SNAPTOBOTTOM|V_HUDTRANS)
			
			v.drawScaled(32*FRACUNIT, 152*FRACUNIT, FRACUNIT/4, v.cachePatch("THZWAL07"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(48*FRACUNIT, 152*FRACUNIT, FRACUNIT/4, v.cachePatch("THZWAL07"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(64*FRACUNIT, 152*FRACUNIT, FRACUNIT/4, v.cachePatch("THZWAL07"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(80*FRACUNIT, 152*FRACUNIT, FRACUNIT/4, v.cachePatch("THZWAL07"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(96*FRACUNIT, 152*FRACUNIT, FRACUNIT/4, v.cachePatch("THZWAL07"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(112*FRACUNIT, 152*FRACUNIT, FRACUNIT/4, v.cachePatch("THZWAL07"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(128*FRACUNIT, 152*FRACUNIT, FRACUNIT/4, v.cachePatch("THZWAL07"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(144*FRACUNIT, 152*FRACUNIT, FRACUNIT/4, v.cachePatch("THZWAL07"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(160*FRACUNIT, 152*FRACUNIT, FRACUNIT/4, v.cachePatch("THZWAL07"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(176*FRACUNIT, 152*FRACUNIT, FRACUNIT/4, v.cachePatch("THZWAL07"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(192*FRACUNIT, 152*FRACUNIT, FRACUNIT/4, v.cachePatch("THZWAL07"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(208*FRACUNIT, 152*FRACUNIT, FRACUNIT/4, v.cachePatch("THZWAL07"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(224*FRACUNIT, 152*FRACUNIT, FRACUNIT/4, v.cachePatch("THZWAL07"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(240*FRACUNIT, 152*FRACUNIT, FRACUNIT/4, v.cachePatch("THZWAL07"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(256*FRACUNIT, 152*FRACUNIT, FRACUNIT/4, v.cachePatch("THZWAL07"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(272*FRACUNIT, 152*FRACUNIT, FRACUNIT/4, v.cachePatch("THZWAL07"), V_SNAPTOBOTTOM|V_HUDTRANS)
			
			v.drawScaled(32*FRACUNIT, 168*FRACUNIT, FRACUNIT, v.cachePatch("RSPQUAKC"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(96*FRACUNIT, 168*FRACUNIT, FRACUNIT, v.cachePatch("RSPQUAKC"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(160*FRACUNIT, 168*FRACUNIT, FRACUNIT, v.cachePatch("RSPQUAKC"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(224*FRACUNIT, 168*FRACUNIT, FRACUNIT, v.cachePatch("RSPQUAKC"), V_SNAPTOBOTTOM|V_HUDTRANS)
			
			/*
			v.drawScaled(32*FRACUNIT, 152*FRACUNIT, FRACUNIT, v.cachePatch("RSPQUAKS"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(64*FRACUNIT, 152*FRACUNIT, FRACUNIT, v.cachePatch("RSPQUAKS"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(96*FRACUNIT, 152*FRACUNIT, FRACUNIT, v.cachePatch("RSPQUAKS"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(128*FRACUNIT, 152*FRACUNIT, FRACUNIT, v.cachePatch("RSPQUAKS"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(160*FRACUNIT, 152*FRACUNIT, FRACUNIT, v.cachePatch("RSPQUAKS"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(192*FRACUNIT, 152*FRACUNIT, FRACUNIT, v.cachePatch("RSPQUAKS"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(224*FRACUNIT, 152*FRACUNIT, FRACUNIT, v.cachePatch("RSPQUAKS"), V_SNAPTOBOTTOM|V_HUDTRANS)
			v.drawScaled(256*FRACUNIT, 152*FRACUNIT, FRACUNIT, v.cachePatch("RSPQUAKS"), V_SNAPTOBOTTOM|V_HUDTRANS)
			*/
		end
		v.drawString(288, 144, hud_time, V_SNAPTOBOTTOM|V_HUDTRANS, "right")
		v.drawString(32, 144, player.score, V_SNAPTOBOTTOM|V_HUDTRANS, "left")
		if G_GametypeHasTeams()
			v.drawString(160, 144, " - ", V_SNAPTOBOTTOM|V_HUDTRANS, "center")
			v.drawString(156, 144, "\x84"..bluescore, V_SNAPTOBOTTOM|V_HUDTRANS, "right")
			v.drawString(164, 144, "\x85"..redscore, V_SNAPTOBOTTOM|V_HUDTRANS, "left")
			if gametype == GT_CTF
				v.drawScaled(126*FRACUNIT, 128*FRACUNIT, FRACUNIT/2, v.cachePatch("BFLAGICO"), V_SNAPTOBOTTOM|V_HUDTRANS)
				v.drawScaled(170*FRACUNIT, 128*FRACUNIT, FRACUNIT/2, v.cachePatch("RFLAGICO"), V_SNAPTOBOTTOM|V_HUDTRANS)
				if RSP.Flags["blue"] == false
					v.drawScaled(126*FRACUNIT, 118*FRACUNIT, FRACUNIT, v.cachePatch("NONICON"), V_SNAPTOBOTTOM|V_HUDTRANS)
				end
				if RSP.Flags["red"] == false
					v.drawScaled(170*FRACUNIT, 118*FRACUNIT, FRACUNIT, v.cachePatch("NONICON2"), V_SNAPTOBOTTOM|V_HUDTRANS)
				end
			end
			if player.ctfteam == 2
				v.drawString(252, 156, "\x84".." BLUE", V_SNAPTOBOTTOM|V_HUDTRANS, "left")
			elseif player.ctfteam == 1
				v.drawString(252, 156, "\x85".." RED", V_SNAPTOBOTTOM|V_HUDTRANS, "left")
			end
		elseif (player.pflags & PF_TAGIT)
			v.drawString(252, 156, "\x80".." IT", V_SNAPTOBOTTOM|V_HUDTRANS, "left")
		elseif player == player_rspheadhunt
			v.drawString(252, 156, "\x80".." HH", V_SNAPTOBOTTOM|V_HUDTRANS, "left")
		elseif player == player_rspbomb
			v.drawString(252, 156, "\x80".." BOMB", V_SNAPTOBOTTOM|V_HUDTRANS, "left")
		end
		
		if gametype == GT_HOTPOTATO
			v.drawScaled(249*FRACUNIT, 174*FRACUNIT, FRACUNIT, v.cachePatch("COCKEXPL"), V_SNAPTOBOTTOM|V_ALLOWLOWERCASE|V_HUDTRANS)
			v.drawScaledNameTag(270*FRACUNIT, 174*FRACUNIT, (tostring(killerqueentime/TICRATE)), V_ALLOWLOWERCASE|V_SNAPTOBOTTOM|V_HUDTRANS, FRACUNIT, SKINCOLOR_WHITE, SKINCOLOR_BLACK)
		elseif cv_instagib.value == 1
			v.drawScaled(249*FRACUNIT, 174*FRACUNIT, FRACUNIT, v.cachePatch("INSTASHI"), V_SNAPTOBOTTOM|V_ALLOWLOWERCASE|V_HUDTRANS, v.getColormap(nil, SKINCOLOR_GREY))
			v.drawString(272, 190, (tostring(RSP.buttons[player.rsp_instashield_button].name)), V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "left")
			if player.insta_count != 100 and player.insta_count != nil
				v.drawScaledNameTag(270*FRACUNIT, 174*FRACUNIT, (tostring(player.insta_count)), V_ALLOWLOWERCASE|V_SNAPTOBOTTOM|V_HUDTRANS, FRACUNIT, SKINCOLOR_WHITE, SKINCOLOR_BLACK)
			elseif player.insta_count != nil
				v.drawScaledNameTag(271*FRACUNIT, 177*FRACUNIT, (tostring(player.insta_count)), V_ALLOWLOWERCASE|V_SNAPTOBOTTOM|V_HUDTRANS, FRACUNIT-16384, SKINCOLOR_WHITE, SKINCOLOR_BLACK)
			end
		else
			v.drawScaledNameTag(270*FRACUNIT, 174*FRACUNIT, 0, V_ALLOWLOWERCASE|V_SNAPTOBOTTOM|V_HUDTRANS, FRACUNIT, SKINCOLOR_WHITE, SKINCOLOR_BLACK)
			v.drawScaled(249*FRACUNIT, 174*FRACUNIT, FRACUNIT, v.cachePatch("INSTASHI"), V_SNAPTOBOTTOM|V_ALLOWLOWERCASE|V_HUDTRANS, v.getColormap(nil, SKINCOLOR_GREY))
		end
		v.drawScaled(48*FRACUNIT, 195*FRACUNIT, FRACUNIT-16384, v.getSpritePatch(SPR_RING, RSP.Framerings.ring), p_r_flags)
		if player.rings < 1000 and player.rings >= 100
			v.drawScaledNameTag(78*FRACUNIT, 177*FRACUNIT, player.rings, V_ALLOWLOWERCASE|V_SNAPTOBOTTOM|V_HUDTRANS, FRACUNIT-16384, h_ring_color, SKINCOLOR_BLACK)
		elseif player.rings >= 1000
			v.drawScaledNameTag(79*FRACUNIT, 180*FRACUNIT, player.rings, V_ALLOWLOWERCASE|V_SNAPTOBOTTOM|V_HUDTRANS, FRACUNIT/2, h_ring_color, SKINCOLOR_BLACK)
		else
			v.drawScaledNameTag(78*FRACUNIT, 174*FRACUNIT, player.rings, V_ALLOWLOWERCASE|V_SNAPTOBOTTOM|V_HUDTRANS, FRACUNIT, h_ring_color, SKINCOLOR_BLACK)
		end
	
		if player.currentweapon != 7
			local patch
			local ammo
			if player.currentweapon == 0
				if player.powers[pw_infinityring] == 0
					patch = v.getSpritePatch(SPR_TRNG, RSP.Framerings.ring)
					v.drawScaled(112*FRACUNIT, 195*FRACUNIT, FRACUNIT-16384, patch, p_r_flags)
					ammo = player.rings
				else
					patch = v.getSpritePatch(SPR_RNGI, RSP.Framerings.weapon)
					v.drawScaled(112*FRACUNIT, 188*FRACUNIT, FRACUNIT/2, patch, V_SNAPTOBOTTOM|V_HUDTRANS)
					ammo = player.powers[pw_infinityring]
				end
			elseif player.currentweapon == 1
				patch = v.getSpritePatch(SPR_RNGA, RSP.Framerings.weapon)
				v.drawScaled(112*FRACUNIT, 195*FRACUNIT, FRACUNIT-16384, patch, V_SNAPTOBOTTOM|V_HUDTRANS)
				ammo = player.powers[pw_automaticring]
			elseif player.currentweapon == 2
				patch = v.getSpritePatch(SPR_RNGB, RSP.Framerings.weapon)
				v.drawScaled(112*FRACUNIT, 195*FRACUNIT, FRACUNIT-16384, patch, V_SNAPTOBOTTOM|V_HUDTRANS)
				ammo = player.powers[pw_bouncering]
			elseif player.currentweapon == 3
				patch = v.getSpritePatch(SPR_RNGS, RSP.Framerings.weapon)
				v.drawScaled(112*FRACUNIT, 195*FRACUNIT, FRACUNIT-16384, patch, V_SNAPTOBOTTOM|V_HUDTRANS)
				ammo = player.powers[pw_scatterring]
			elseif player.currentweapon == 4
				patch = v.getSpritePatch(SPR_RNGG, RSP.Framerings.weapon)
				v.drawScaled(112*FRACUNIT, 195*FRACUNIT, FRACUNIT-16384, patch, V_SNAPTOBOTTOM|V_HUDTRANS)
				ammo = player.powers[pw_grenadering]
			elseif player.currentweapon == 5
				patch = v.getSpritePatch(SPR_RNGE, RSP.Framerings.weapon)
				v.drawScaled(112*FRACUNIT, 195*FRACUNIT, FRACUNIT-16384, patch, V_SNAPTOBOTTOM|V_HUDTRANS)
				ammo = player.powers[pw_explosionring]
			elseif player.currentweapon == 6
				patch = v.getSpritePatch(SPR_RNGR, RSP.Framerings.weapon)
				v.drawScaled(112*FRACUNIT, 195*FRACUNIT, FRACUNIT-16384, patch, V_SNAPTOBOTTOM|V_HUDTRANS)
				ammo = player.powers[pw_railring]
			end
			if ammo < 1000 and ammo >= 100
				v.drawScaledNameTag(142*FRACUNIT, 177*FRACUNIT, ammo, V_ALLOWLOWERCASE|V_SNAPTOBOTTOM|V_HUDTRANS, FRACUNIT-16384, SKINCOLOR_WHITE, SKINCOLOR_BLACK)
			elseif ammo >= 1000
				v.drawScaledNameTag(143*FRACUNIT, 180*FRACUNIT, ammo, V_ALLOWLOWERCASE|V_SNAPTOBOTTOM|V_HUDTRANS, FRACUNIT/2, SKINCOLOR_WHITE, SKINCOLOR_BLACK)
			else
				v.drawScaledNameTag(142*FRACUNIT, 174*FRACUNIT, ammo, V_ALLOWLOWERCASE|V_SNAPTOBOTTOM|V_HUDTRANS, FRACUNIT, SKINCOLOR_WHITE, SKINCOLOR_BLACK)
			end
		end
		v.drawScaled(174*FRACUNIT, 194*FRACUNIT, FRACUNIT, (v.getSprite2Patch(player.skin, SPR2_XTRA, false, C)), V_SNAPTOBOTTOM|V_HUDTRANS, v.getColormap(nil, player.skincolor))
		v.drawScaledNameTag(188*FRACUNIT, 180*FRACUNIT, "x", V_ALLOWLOWERCASE|V_SNAPTOBOTTOM|V_HUDTRANS, FRACUNIT/2, SKINCOLOR_WHITE, SKINCOLOR_BLACK)
		v.drawScaledNameTag(206*FRACUNIT, 174*FRACUNIT, player.lives, V_ALLOWLOWERCASE|V_SNAPTOBOTTOM|V_HUDTRANS, FRACUNIT, SKINCOLOR_WHITE, SKINCOLOR_BLACK)
	elseif player.rsp_hud == 2
	
		if player.rsp_bghud == 1
			v.drawScaled(-40*FRACUNIT, 190*FRACUNIT, FRACUNIT*256, v.cachePatch("~031"), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_40TRANS)
		end
		
		v.drawScaled(18*FRACUNIT, 194*FRACUNIT, FRACUNIT, (v.getSprite2Patch(player.skin, SPR2_XTRA, false, C)), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_HUDTRANS, v.getColormap(nil, player.skincolor))
		
		if G_GametypeUsesLives()
			v.drawString(32, 190, "x", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_HUDTRANS, "left")
			v.drawString(48, 190, player.lives, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_HUDTRANS, "left")
		end
		
		v.drawString(32, 180, "\x82"..skins[player.skin].name, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_HUDTRANS, "left")
		
		v.drawScaled(96*FRACUNIT, 197*FRACUNIT, FRACUNIT/2, v.getSpritePatch(SPR_RING, RSP.Framerings.ring), p_r_flags + V_SNAPTOLEFT)
		v.drawString(104, 190, " "..player.rings, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_HUDTRANS, "left")
		v.drawScaled(206*FRACUNIT, 186*FRACUNIT, FRACUNIT-(FRACUNIT/4), v.cachePatch("GOTITF"), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, v.getColormap(nil, player.skincolor))
		v.drawString(208, 190, " "..player.score, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_HUDTRANS, "left")
		
		if G_GametypeHasTeams()
			if gametype == GT_CTF
				v.drawScaled(126*FRACUNIT, 10*FRACUNIT, FRACUNIT/2, v.cachePatch("BFLAGICO"), V_SNAPTOTOP|V_HUDTRANS)
				v.drawScaled(170*FRACUNIT, 10*FRACUNIT, FRACUNIT/2, v.cachePatch("RFLAGICO"), V_SNAPTOTOP|V_HUDTRANS)
				if RSP.Flags["blue"] == false
					v.drawScaled(126*FRACUNIT, 10*FRACUNIT, FRACUNIT, v.cachePatch("NONICON"), V_SNAPTOTOP|V_HUDTRANS)
				end
				if RSP.Flags["red"] == false
					v.drawScaled(170*FRACUNIT, 10*FRACUNIT, FRACUNIT, v.cachePatch("NONICON2"), V_SNAPTOTOP|V_HUDTRANS)
				end
			end
			v.drawString(160, 20, " - ", V_SNAPTOTOP|V_HUDTRANS, "center")
			v.drawString(156, 20, "\x84"..bluescore, V_SNAPTOTOP|V_HUDTRANS, "right")
			v.drawString(164, 20, "\x85"..redscore, V_SNAPTOTOP|V_HUDTRANS, "left")
			if player.ctfteam == 2
				v.drawString(8, 160, "\x84".." BLUE", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_HUDTRANS, "left")
			elseif player.ctfteam == 1
				v.drawString(8, 160, "\x85".." RED", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_HUDTRANS, "left")
			end
		elseif (player.pflags & PF_TAGIT)
			v.drawString(8, 160, "IT", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_HUDTRANS, "left")
		elseif player == player_rspheadhunt
			v.drawString(8, 160, "HH", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_HUDTRANS, "left")
		elseif player == player_rspbomb
			v.drawString(8, 160, "BOMB", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_HUDTRANS, "left")
		end
		
		if gametype == GT_HOTPOTATO
			v.drawScaled(152*FRACUNIT, 184*FRACUNIT, FRACUNIT-(FRACUNIT/3), v.cachePatch("COCKEXPL"), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS)
			v.drawString(152, 190, " "..(tostring(killerqueentime/TICRATE)), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_HUDTRANS, "left")
		elseif cv_instagib.value == 1
			v.drawScaled(150*FRACUNIT, 184*FRACUNIT, FRACUNIT-(FRACUNIT/3), v.cachePatch("INSTASHI"), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, v.getColormap(nil, SKINCOLOR_GREY))
			if player.insta_count != nil
				v.drawString(152, 190, " "..player.insta_count, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_HUDTRANS, "left")
			end
		//else
			//v.drawString(152, 190, " 0", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_HUDTRANS, "left")
			//v.drawScaled(150*FRACUNIT, 184*FRACUNIT, FRACUNIT-(FRACUNIT/3), v.cachePatch("INSTASHI"), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, v.getColormap(nil, SKINCOLOR_GREY))
		end
		
		v.drawString(160, 0, hud_time, V_SNAPTOTOP|V_HUDTRANS, "center")
		
	end
	if G_RingSlingerGametype()
		if RSP.hud[player.rsp_hud].v_powerstones == false
			if RSP.hud[player.rsp_hud]["emeralds"]
				for i = 0,6 do
					if not (player.powers[pw_emeralds] & RSP.hud[player.rsp_hud]["emeralds"][i].flagname)
						continue
					end
					local x = RSP.hud[player.rsp_hud]["emeralds"][i].x
					local y = RSP.hud[player.rsp_hud]["emeralds"][i].y
					local scale = RSP.hud[player.rsp_hud]["emeralds"][i].scale
					local patch = v.cachePatch(RSP.hud[player.rsp_hud]["emeralds"][i].patch)
					local flags = RSP.hud[player.rsp_hud]["emeralds"][i].flags
					v.drawScaled(x, y, scale, patch, flags)
				end
			end
		end
		local curweap = v.cachePatch(RSP.hud[player.rsp_hud].curweap)
		local selweap = player.currentweapon
		local curx = RSP.hud[player.rsp_hud]["weapons"][selweap].x
		local cury = RSP.hud[player.rsp_hud]["weapons"][selweap].y
		local curp = RSP.hud[player.rsp_hud].cur_p
		local curscale = RSP.hud[player.rsp_hud]["weapons"][selweap].scale
		local curflags = RSP.hud[player.rsp_hud]["weapons"][selweap].flags
		local currentammo
		for i = 0,6 do
			local x = RSP.hud[player.rsp_hud]["weapons"][i].x
			local y = RSP.hud[player.rsp_hud]["weapons"][i].y
			local scale = RSP.hud[player.rsp_hud]["weapons"][i].scale
			local patch = v.cachePatch(RSP.hud[player.rsp_hud]["weapons"][i].patch)
			local flags = RSP.hud[player.rsp_hud]["weapons"][i].flags
			local ammocount
			local weaponvalue
			if i == 0 then ammocount = player.powers[pw_infinityring]
				if player.powers[pw_infinityring] != 0
					ammocount = player.powers[pw_infinityring]
					if player.powers[pw_infinityring] >= 400 then ammocount = "\x82"..ammocount end
					patch = v.cachePatch(RSP.hud[player.rsp_hud]["weapons"][i].extrapatch)
				else
					if player.rings == 0 then flags = flags + V_70TRANS end
					ammocount = ""
				end
			elseif i == 1
				ammocount = player.powers[pw_automaticring]
				if (player.ringweapons & 1)
					if ammocount == 0 then flags = flags + V_50TRANS ammocount = "" end
					if player.powers[pw_automaticring] >= 400 then ammocount = "\x82"..player.powers[pw_automaticring] end
				else
					if ammocount != 0 then flags = flags + V_70TRANS
					else
						patch = v.cachePatch("EMPT")
						ammocount = ""
					end
				end
			elseif i == 2
				ammocount = player.powers[pw_bouncering]
				if (player.ringweapons & 2)
					if ammocount == 0 then flags = flags + V_50TRANS ammocount = "" end
					if player.powers[pw_bouncering] >= 100 then ammocount = "\x82"..player.powers[pw_bouncering] end
				else
					if ammocount != 0 then flags = flags + V_70TRANS
					else
						patch = v.cachePatch("EMPT")
						ammocount = ""
					end
				end
			elseif i == 3
				ammocount = player.powers[pw_scatterring]
				if (player.ringweapons & 4)
					if ammocount == 0 then flags = flags + V_50TRANS ammocount = "" end
					if player.powers[pw_scatterring] >= 50 then ammocount = "\x82"..player.powers[pw_scatterring] end
				else
					if ammocount != 0 then flags = flags + V_70TRANS
					else
						patch = v.cachePatch("EMPT")
						ammocount = ""
					end
				end
			elseif i == 4
				ammocount = player.powers[pw_grenadering]
				if (player.ringweapons & 8)
					if ammocount == 0 then flags = flags + V_50TRANS ammocount = "" end
					if player.powers[pw_grenadering] >= 100 then ammocount = "\x82"..player.powers[pw_grenadering] end
				else
					if ammocount != 0 then flags = flags + V_70TRANS
					else
						patch = v.cachePatch("EMPT")
						ammocount = ""
					end
				end
			elseif i == 5
				ammocount = player.powers[pw_explosionring]
				if (player.ringweapons & 16)
					if ammocount == 0 then flags = flags + V_50TRANS ammocount = "" end
					if player.powers[pw_explosionring] >= 50 then ammocount = "\x82"..player.powers[pw_explosionring] end
				else
					if ammocount != 0 then flags = flags + V_70TRANS
					else
						patch = v.cachePatch("EMPT")
						ammocount = ""
					end
				end
			elseif i == 6
				ammocount = player.powers[pw_railring]
				if (player.ringweapons & 32)
					if ammocount == 0 then flags = flags + V_50TRANS ammocount = "" end
					if player.powers[pw_railring] >= 50 then ammocount = "\x82"..player.powers[pw_railring] end
				else
					if ammocount != 0 then flags = flags + V_70TRANS
					else
						patch = v.cachePatch("EMPT")
						ammocount = ""
					end
				end
			end
			if cv_instagib.value == 1 and not G_IsFFAGametype()
				ammocount = ""
			end
			if not splitscreen
				v.drawScaled(x, y, scale, patch, flags, nil)
				v.drawString((x/FRACUNIT)+RSP.hud[player.rsp_hud].count_ammo_x , (y/FRACUNIT)+RSP.hud[player.rsp_hud].count_ammo_y, (tostring(ammocount)), flags, RSP.hud[player.rsp_hud].align_ammo)
				if RSP.hud[player.rsp_hud].curshift == "top"
					v.drawScaled(curx-curp, cury-curp-player.weapondelay*(FRACUNIT/3), curscale, curweap, flags, nil)
				elseif RSP.hud[player.rsp_hud].curshift == "bottom"
					v.drawScaled(curx-curp, cury-curp+player.weapondelay*(FRACUNIT/3), curscale, curweap, flags, nil)
				elseif RSP.hud[player.rsp_hud].curshift == "left"
					v.drawScaled(curx-curp-player.weapondelay*(FRACUNIT/3), cury-curp, curscale, curweap, flags, nil)
				elseif RSP.hud[player.rsp_hud].curshift == "right"
					v.drawScaled(curx-curp+player.weapondelay*(FRACUNIT/3), cury-curp, curscale, curweap, flags, nil)
				end
			end
		end
		if player.ammoremovalweapon != 0
			local x = RSP.hud[player.rsp_hud]["weapons"][player.ammoremovalweapon].x
			local y = RSP.hud[player.rsp_hud]["weapons"][player.ammoremovalweapon].y
			local flags = RSP.hud[player.rsp_hud]["weapons"][player.ammoremovalweapon].flags
			if (player.ammoremovaltimer % 4) != 2 and player.ammoremovaltimer != 0
				v.drawString((x/FRACUNIT)+16 , (y/FRACUNIT), (tostring("-"..player.ammoremoval)), flags + V_REDMAP, "right")
			end
		end
		if camera.chase == false
			if selweap == 0
				if player.powers[pw_infinityring] != 0
					if player.powers[pw_infinityring] > 15
						currentammo = player.powers[pw_infinityring]
					else
						currentammo = "\x85"..player.powers[pw_infinityring]
					end
				else
					if player.rings > 15
						currentammo = player.rings
					else
						currentammo = "\x85"..player.rings
					end
				end
			elseif selweap == 1
				if player.powers[pw_automaticring] != 0
					if player.powers[pw_automaticring] > 40
						currentammo = player.powers[pw_automaticring]
					else
						currentammo = "\x85"..player.powers[pw_automaticring]
					end
				end
			elseif selweap == 2
				if player.powers[pw_bouncering] != 0
					if player.powers[pw_bouncering] > 10
						currentammo = player.powers[pw_bouncering]
					else
						currentammo = "\x85"..player.powers[pw_bouncering]
					end
				end
			elseif selweap == 3
				if player.powers[pw_scatterring] != 0
					if player.powers[pw_scatterring] > 5
						currentammo = player.powers[pw_scatterring]
					else
						currentammo = "\x85"..player.powers[pw_scatterring]
					end
				end
			elseif selweap == 4
				if player.powers[pw_grenadering] != 0
					if player.powers[pw_grenadering] > 5
						currentammo = player.powers[pw_grenadering]
					else
						currentammo = "\x85"..player.powers[pw_grenadering]
					end
				end
			elseif selweap == 5
				if player.powers[pw_explosionring] != 0
					if player.powers[pw_explosionring] > 5
						currentammo = player.powers[pw_explosionring]
					else
						currentammo = "\x85"..player.powers[pw_explosionring]
					end
				end
			elseif selweap == 6
				if player.powers[pw_railring] != 0
					if player.powers[pw_railring] > 5
						currentammo = player.powers[pw_railring]
					else
						currentammo = "\x85"..player.powers[pw_railring]
					end
				end
			end
			if selweap != 7 and currentammo != nil and cv_instagib.value == 0
				if player.rsp_hud_ammo == 2 or player.rsp_hud_ammo == 3
					v.drawString(174 , 110, (tostring("A:"..currentammo)), nil, "small")
				end
				if player.rsp_hud_ammo == 1 or player.rsp_hud_ammo == 3
					if (selweap == 0 and player.powers[pw_infinityring] != 0) or selweap != 0 or player.rsp_hud_ammo != 3
						if player.rings > 15
							v.drawString(174 , 114, (tostring("R:"..player.rings)), nil, "small")
						else
							v.drawString(174 , 114, (tostring("R:".."\x85"..player.rings)), nil, "small")
						end
					end
				end
			end
			local realspeed
			if player.mo
				realspeed = R_PointToDist2(0, 0, player.mo.momx, player.mo.momy)
			else
				realspeed = player.speed
			end
			if player.rsp_hud_speed == 1
				v.drawString(36, 68, (tostring(realspeed / (FRACUNIT/10))), V_SNAPTOLEFT|V_ALLOWLOWERCASE, "left")
				v.drawScaled(32*FRACUNIT, 64*FRACUNIT, FRACUNIT, v.cachePatch("SPEEDICO"), V_SNAPTOLEFT|V_ALLOWLOWERCASE, v.getColormap(nil, player.skincolor))
			elseif player.rsp_hud_speed == 2
				v.drawString(134, 110, (tostring("S:"..realspeed / (FRACUNIT/10))), nil, "small")
			end
		end
	end
	if player.mo
	and player.mo.valid
	and player.playerstate == PST_LIVE
		if player.rspghostplayer == true
			v.drawString(16, 58, ("\x86\GHOST MODE:"), V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS, "thin")
			v.drawString(16, 66, ("\x82\JUMP:\x80 RISE"), V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS, "thin")
			v.drawString(16, 74, ("\x82\SPIN:\x80 LOWER"), V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS, "thin")
			v.drawString(RSP.hud[player.rsp_hud].gt_message_x, RSP.hud[player.rsp_hud].gt_message_y, "YOU ARE DEAD, NOT BIG SURPRISE!", V_GRAYMAP|V_20TRANS|V_ALLOWLOWERCASE, "thin-center")
			v.drawString(RSP.hud[player.rsp_hud].gt_message_x, RSP.hud[player.rsp_hud].gt_message_y+8, "Wait for the next round", V_GRAYMAP|V_20TRANS|V_ALLOWLOWERCASE|V_HUDTRANS, "thin-center")
		end
		if G_RingSlingerGametype() and player.rspghostplayer != true
		or (gametype == GT_TAG) and player.rspghostplayer != true
			if player.countdown_rj != 0
				if (leveltime % 4) != 2
					v.drawString(104, 32, (tostring("-"..player.count_rj)), V_REDMAP|V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_SNAPTOBOTTOM, "center")
				end
			end
			if RSP.DATA.round_ready == false and not G_IsHASGametype() and not G_Is1v1Gametype()
				if (#RSP.DATA.playertable < cv_rspwfp.value)
					v.drawString(156, 64, (tostring("Waiting For "..(cv_rspwfp.value - #RSP.DATA.playertable).." Players...")), V_GRAYMAP|V_30TRANS|V_ALLOWLOWERCASE, "center")
				end
				if (#RSP.DATA.playertable >= cv_rspwfp.value)
					v.drawString(156, 64, (tostring("Get Ready!")), V_GRAYMAP|V_30TRANS|V_ALLOWLOWERCASE, "center")
				end
			end
			if RSP.DATA.round_ready == false and G_Is1v1Gametype()
				if (#RSP.DATA.playertable < 2)
					v.drawString(156, 64, (tostring("Waiting For opponent.")), V_GRAYMAP|V_30TRANS|V_ALLOWLOWERCASE, "center")
				end
				if (#RSP.DATA.playertable == 2)
					v.drawString(156, 64, (tostring("Get Ready!")), V_GRAYMAP|V_30TRANS|V_ALLOWLOWERCASE, "center")
				end
			end
		else return
		end
		if cv_instagib.value == 1 and not G_IsNoInstaGametype()
		and player.rspghostplayer != true
		and player.rsp_hud == 0
			if cv_instashield.value == 1
				v.drawString(36, 92, (tostring(player.insta_count)), V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "left")
				v.drawScaled(32*FRACUNIT, 88*FRACUNIT, FRACUNIT, v.cachePatch("INSTASHI"), V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS)
				v.drawString(15, 92, (tostring(RSP.buttons[player.rsp_instashield_button].name)), V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "left")
			else return
			end
		end
		if gametype == GT_HOTPOTATO
		and player.rspghostplayer != true
		and player.rsp_hud == 0
			v.drawString(36, 92, (tostring(killerqueentime/TICRATE)), V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "left")
			v.drawScaled(32*FRACUNIT, 88*FRACUNIT, FRACUNIT, v.cachePatch("COCKEXPL"), V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS)
		else return
		end
	end
	if player.spectator == true
		if G_RingSlingerGametype()
			
			if cv_allowability
				if cv_allowability.value == 0
					v.drawString(16, 100, (tostring("Allow ability: \x85\Disabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
				else
					v.drawString(16, 100, (tostring("Allow ability: \x83\Enabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
				end
			end
			
			if cv_allowability2
				if cv_allowability2.value == 0
					v.drawString(16, 104, (tostring("Allow ability2: \x85\Disabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
				elseif cv_allowability2.value == 1
					v.drawString(16, 104, (tostring("Allow ability2: \x83\Enabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
				elseif cv_allowability2.value == 2
					v.drawString(16, 104, (tostring("Allow ability2: \x83\Dash")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
				end
			end
			
			if cv_allowshield
				if cv_allowshield.value == 0
					v.drawString(16, 108, (tostring("Allow shield: \x85\Disabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
				else
					v.drawString(16, 108, (tostring("Allow shield: \x83\Enabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
				end
			end
			
			if cv_autojump
				if cv_autojump.value == 0
					v.drawString(16, 112, (tostring("Allow autojump: \x85\Disabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
				else
					v.drawString(16, 112, (tostring("Allow autojump: \x83\Enabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
				end
			end
			
			if cv_autofire
				if cv_autofire.value == 0
					v.drawString(16, 116, (tostring("Allow autofire: \x85\Disabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
				else
					v.drawString(16, 116, (tostring("Allow autofire: \x83\Enabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
				end
			end
			
			if cv_aarj
				if cv_aarj.value == 0
					v.drawString(16, 120, (tostring("Allow ability after rocketjump: \x85\Disabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
				else
					v.drawString(16, 120, (tostring("Allow ability after rocketjump: \x83\Enabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
				end
			end
			
			if cv_blowdamage
				if cv_blowdamage.value == 0
					v.drawString(16, 124, (tostring("Blow damage:\x85\ "..cv_blowdamage.value)), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
				else
					v.drawString(16, 124, (tostring("Blow damage:\x83\ "..cv_blowdamage.value)), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
				end
			end
			
			if cv_walljump
				if cv_walljump.value == 0
					v.drawString(16, 128, (tostring("Wall jump: \x85\Disabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
				else
					v.drawString(16, 128, (tostring("Wall jump: \x83\Enabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
				end
			end
			
			if cv_instagib.value == 1
				if cv_rbenabled
					if cv_rbenabled.value == 0
						v.drawString(16, 132, (tostring("Rail Boost: \x85\Disabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
					else
						v.drawString(16, 132, (tostring("Rail Boost: \x83\Enabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
					end
				end
				
				if railboost_power
					if railboost_power.value != 32
						v.drawString(16, 136, (tostring("Rail Boost Power:\x85\ "..railboost_power.value)), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
					else
						v.drawString(16, 136, (tostring("Rail Boost Power:\x83\ "..railboost_power.value)), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
					end
				end
				
				if cv_instashield
					if cv_instashield.value == 0
						v.drawString(16, 140, (tostring("InstaShield: \x85\Disabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
					else
						v.drawString(16, 140, (tostring("InstaShield: \x83\Enabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
					end
				end
			else
			
				if cv_rjenabled
					if cv_rjenabled.value == 0
						v.drawString(16, 132, (tostring("Rocket Jump: \x85\Disabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
					else
						v.drawString(16, 132, (tostring("Rocket Jump: \x83\Enabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
					end
				end
				
				if rocketjump_power
					if rocketjump_power.value != 16
						v.drawString(16, 136, (tostring("Rocket Jump Power:\x85\ "..rocketjump_power.value)), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
					else
						v.drawString(16, 136, (tostring("Rocket Jump Power:\x83\ "..rocketjump_power.value)), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
					end
				end
				
				if cv_keepweapons
					if cv_keepweapons.value == 0
						v.drawString(16, 140, (tostring("keep weapons: \x85\Disabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
					else
						v.drawString(16, 140, (tostring("keep weapons: \x83\Enabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
					end
				end
				
				if cv_rspsuddendeath
					if cv_rspsuddendeath.value == 0
						v.drawString(16, 144, (tostring("Sudden Death: \x85\Disabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
					else
						v.drawString(16, 144, (tostring("Sudden Death: \x83\Enabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
					end
				end
				
				if cv_timerexplosion
					if cv_timerexplosion.value != 210
						v.drawString(16, 148, (tostring("Grenade Timer:\x85\ "..cv_timerexplosion.value/TICRATE)), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
					else
						v.drawString(16, 148, (tostring("Grenade Timer:\x83\ "..cv_timerexplosion.value/TICRATE)), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
					end
				end
				
				if cv_quickswitching
					if cv_quickswitching.value == 0
						v.drawString(16, 152, (tostring("Quick Switching: \x85\Disabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
					else
						v.drawString(16, 152, (tostring("Quick Switching: \x83\Enabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
					end
				end
				if cv_rjdamage
					if cv_rjdamage.value == 0
						v.drawString(16, 156, (tostring("Explosion Damage: \x85\Disabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
					else
						v.drawString(16, 156, (tostring("Explosion Damage: \x83\Enabled")), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_HUDTRANS, "small")
					end
				end
			end
			
		end
	end
end
hud.add(RSPHUD)

local function RSPDEBUGHUD(v) local player = displayplayer
	if G_RingSlingerGametype() or G_IsHASGametype()
		if cv_rspdebug.value == 1
			v.drawString(320, 0, (tostring("Debug mode is enabled!")), V_REDMAP|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small-right")
			v.drawString(320, 4, (tostring("Players: "..#RSP.DATA.playertable)), V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small-right")
			v.drawString(320, 8, (tostring("Live Players: "..#RSP.DATA.playertablelive)), V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small-right")
			if player.mo
			and player.mo.valid
			and player.playerstate == PST_LIVE
				v.drawString(320, 12, (tostring("X: "..player.mo.x / FRACUNIT)), V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small-right")
				v.drawString(320, 16, (tostring("Y: "..player.mo.y / FRACUNIT)), V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small-right")
				v.drawString(320, 20, (tostring("Z: "..player.mo.z / FRACUNIT)), V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small-right")
				v.drawString(320, 24, (tostring("Weapon delay: "..player.weapondelay)), V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small-right")
			end
		end
	else return
	end
end
hud.add(RSPDEBUGHUD)

addHook("PreThinkFrame", function(player)
	for player in players.iterate
		if not player then return end
		if not player.valid then return end
		if player.rsp_crosshair == nil
		or player.rsp_crosshair_alt == nil
		or player.rsp_crosshair_scale == nil
		or player.rsp_crosshair_color == nil
		or player.rsp_autojump == nil
		or player.rsp_instashield_button == nil
		or player.rsp_hud == nil
		or player.rsp_bghud == nil
		or player.rsp_menu_button == nil
		or player.rsp_hud_speed == nil
		or player.rsp_hud_ammo == nil
		or player.rsp_hud_buttons == nil
		or player.rsp_autofire == nil
			player.dcrestart = true
			rsp_defaultconfig(player)
		end
		if player.rsp_menu == true
			if not player.rsp_mcam
				hud.disable("textspectator")
				player.rsp_mcam = {
					aiming = player.aiming,
					angle = player.realmo.angle,
					cmd_angleturn = player.cmd.angleturn,
					cmd_aiming = player.cmd.aiming
				}
			end
			if not player.rsp_navmenu
				player.rsp_navmenu = {
					cat = 0,
					nav = 0,
					pressed = false,
					delay = 35,
					scrolldelay = 0,
					lastnav = 2,
					page = 0
				}
			end
			//player.aiming = player.rsp_mcam.aiming
			//player.realmo.angle = player.rsp_mcam.angle
			//if player.powers[pw_nocontrol] != 2
				//player.powers[pw_nocontrol] = 2
			//end
			if player.rsp_navmenu.cat == 2
				if player.rsp_navmenu.nav >= 18
					player.rsp_navmenu.page = 2
				elseif player.rsp_navmenu.nav >= 14
					player.rsp_navmenu.page = 1
				elseif player.rsp_navmenu.nav < 14
					player.rsp_navmenu.page = 0
				end
			end
			if (player.cmd.buttons & BT_JUMP)
				if player.rsp_navmenu.pressed == false
					player.rsp_navmenu.pressed = true
					if player.rsp_navmenu.cat == 0
						if player.rsp_navmenu.nav == 0
							player.rsp_navmenu.cat = 1
							player.rsp_navmenu.nav = 0
							player.rsp_navmenu.lastnav = 13
							S_StartSound(nil, sfx_tink, player)
						elseif player.rsp_navmenu.nav == 1
							if IsPlayerAdmin(player) or player == server
								player.rsp_navmenu.cat = 2
								player.rsp_navmenu.nav = 0
								player.rsp_navmenu.lastnav = 25
								player.rsp_navmenu.page = 0
								S_StartSound(nil, sfx_tink, player)
							else
								S_StartSound(nil, sfx_s3kb2, player)
							end
						elseif player.rsp_navmenu.nav == 2
							player.rsp_menu = nil
							player.rsp_mcam = nil
							player.rsp_navmenu = nil
							hud.enable("textspectator")
						end
					end
				end
			elseif (player.cmd.buttons & BT_SPIN)
				if player.rsp_navmenu.pressed == false
					player.rsp_navmenu.pressed = true
					S_StartSound(nil, sfx_thok, player)
					if player.rsp_navmenu.cat == 0
						player.rsp_menu = nil
						player.rsp_mcam = nil
						player.rsp_navmenu = nil
						hud.enable("textspectator")
					elseif player.rsp_navmenu.cat == 1
						player.rsp_navmenu.cat = 0
						player.rsp_navmenu.nav = 0
						player.rsp_navmenu.lastnav = 2
						COM_BufInsertText(player, "rsp_saveplayerconfig")
					elseif player.rsp_navmenu.cat == 2
						player.rsp_navmenu.cat = 0
						player.rsp_navmenu.nav = 0
						player.rsp_navmenu.lastnav = 2
					end
				end
			elseif player.cmd.forwardmove > 25 //player.cmd.aiming > player.rsp_mcam.cmd_aiming
				if player.rsp_navmenu.delay != 0
					player.rsp_navmenu.delay = $ - 1
				end
				if player.rsp_navmenu.pressed == false or player.rsp_navmenu.delay == 0
					player.rsp_navmenu.pressed = true
					if player.rsp_navmenu.scrolldelay != 0
						player.rsp_navmenu.scrolldelay = $ - 1
					else
						player.rsp_navmenu.scrolldelay = 1
						if player.rsp_navmenu.nav == 0
							player.rsp_navmenu.nav = player.rsp_navmenu.lastnav
							S_StartSound(nil, sfx_menu1, player)
						else
							player.rsp_navmenu.nav = $ - 1
							S_StartSound(nil, sfx_menu1, player)
						end
					end
				end
			elseif player.cmd.forwardmove < -25 //player.cmd.aiming < player.rsp_mcam.cmd_aiming
				if player.rsp_navmenu.delay != 0
					player.rsp_navmenu.delay = $ - 1
				end
				if player.rsp_navmenu.pressed == false or player.rsp_navmenu.delay == 0
					player.rsp_navmenu.pressed = true
					if player.rsp_navmenu.scrolldelay != 0
						player.rsp_navmenu.scrolldelay = $ - 1
					else
						player.rsp_navmenu.scrolldelay = 1
						if player.rsp_navmenu.nav == player.rsp_navmenu.lastnav
							player.rsp_navmenu.nav = 0
							S_StartSound(nil, sfx_menu1, player)
						else
							player.rsp_navmenu.nav = $ + 1
							S_StartSound(nil, sfx_menu1, player)
						end
					end
				end
			elseif player.cmd.sidemove > 25 //player.cmd.angleturn < player.rsp_mcam.cmd_angleturn
				if player.rsp_navmenu.delay != 0
					player.rsp_navmenu.delay = $ - 1
				end
				if player.rsp_navmenu.pressed == false or player.rsp_navmenu.delay == 0
					player.rsp_navmenu.pressed = true
					if player.rsp_navmenu.scrolldelay != 0
						player.rsp_navmenu.scrolldelay = $ - 1
					else
						player.rsp_navmenu.scrolldelay = 1
						if player.rsp_navmenu.cat == 1
							if player.rsp_navmenu.nav == 0
								if tonumber(player.rsp_crosshair) or player.rsp_crosshair == 0
									if player.rsp_crosshair < 66
										player.rsp_crosshair = $ + 1
									elseif player.rsp_crosshair == 66
										player.rsp_crosshair = "a"
									end
								elseif player.rsp_crosshair  == "a"
									player.rsp_crosshair = "b"
								elseif player.rsp_crosshair == "b"
									player.rsp_crosshair = "c"
								elseif player.rsp_crosshair == "c"
									player.rsp_crosshair = 0
								end
								S_StartSound(nil, sfx_menu1, player)
							elseif player.rsp_navmenu.nav == 1
								if tonumber(player.rsp_crosshair_alt) or player.rsp_crosshair_alt == 0
									if player.rsp_crosshair_alt < 66
										player.rsp_crosshair_alt = $ + 1
									elseif player.rsp_crosshair_alt == 66
										player.rsp_crosshair_alt = "a"
									end
								elseif player.rsp_crosshair_alt  == "a"
									player.rsp_crosshair_alt = "b"
								elseif player.rsp_crosshair_alt == "b"
									player.rsp_crosshair_alt = "c"
								elseif player.rsp_crosshair_alt == "c"
									player.rsp_crosshair_alt = 0
								end
								S_StartSound(nil, sfx_menu1, player)
							elseif player.rsp_navmenu.nav == 2
								if player.rsp_crosshair_color < #skincolors-1
									player.rsp_crosshair_color = $ + 1
								else
									player.rsp_crosshair_color = 0
								end
								S_StartSound(nil, sfx_menu1, player)
							elseif player.rsp_navmenu.nav == 3
								if player.rsp_crosshair_scale < 10
									player.rsp_crosshair_scale = $ + 1
								else
									player.rsp_crosshair_scale = 1
								end
								S_StartSound(nil, sfx_menu1, player)
							elseif player.rsp_navmenu.nav == 4
								if player.rsp_hud < #RSP.hud
									player.rsp_hud = $ + 1
								else
									player.rsp_hud = 0
								end
								if RSP.hud[player.rsp_hud].v_score == true
									hud.enable("score")
								else
									hud.disable("score")
								end
								if RSP.hud[player.rsp_hud].v_time == true
									hud.enable("time")
								else
									hud.disable("time")
								end
								if RSP.hud[player.rsp_hud].v_rings == true
									hud.enable("rings")
								else
									hud.disable("rings")
								end
								if RSP.hud[player.rsp_hud].v_lives == true
									hud.enable("lives")
								else
									hud.disable("lives")
								end
								if RSP.hud[player.rsp_hud].v_teamscores == true
									hud.enable("teamscores")
								else
									hud.disable("teamscores")
								end
								if RSP.hud[player.rsp_hud].v_powerstones == true
									hud.enable("powerstones")
								else
									hud.disable("powerstones")
								end
								S_StartSound(nil, sfx_menu1, player)
							elseif player.rsp_navmenu.nav == 5
								if player.rsp_bghud == 1
									player.rsp_bghud = 0
								else
									player.rsp_bghud = 1
								end
								S_StartSound(nil, sfx_menu1, player)
							elseif player.rsp_navmenu.nav == 6
								if player.rsp_hud_ammo < 3
									player.rsp_hud_ammo = $ + 1
								else
									player.rsp_hud_ammo = 0
								end
								S_StartSound(nil, sfx_menu1, player)
							elseif player.rsp_navmenu.nav == 7
								if player.rsp_hud_speed < 2
									player.rsp_hud_speed = $ + 1
								else
									player.rsp_hud_speed = 0
								end
								S_StartSound(nil, sfx_menu1, player)
							elseif player.rsp_navmenu.nav == 8
								if cv_rspspawnpoint.value == 1
									COM_BufInsertText(player, "rsp_spawnpoint 0")
								else
									COM_BufInsertText(player, "rsp_spawnpoint 1")
								end
								S_StartSound(nil, sfx_menu1, player)
							elseif player.rsp_navmenu.nav == 9
								if player.rsp_autojump == "1"
									player.rsp_autojump = "0"
								else
									player.rsp_autojump = "1"
								end
								S_StartSound(nil, sfx_menu1, player)
							elseif player.rsp_navmenu.nav == 10
								if player.rsp_autofire == 1
									player.rsp_autofire = 0
								else
									player.rsp_autofire = 1
								end
								S_StartSound(nil, sfx_menu1, player)
							elseif player.rsp_navmenu.nav == 11
								if player.rsp_hud_buttons == 1
									player.rsp_hud_buttons = 0
								else
									player.rsp_hud_buttons = 1
								end
								S_StartSound(nil, sfx_menu1, player)
							elseif player.rsp_navmenu.nav == 12
								if player.rsp_instashield_button == "firenormal"
									player.rsp_instashield_button = "tossflag"
								elseif player.rsp_instashield_button == "tossflag"
									player.rsp_instashield_button = "custom1"
								elseif player.rsp_instashield_button == "custom1"
									player.rsp_instashield_button = "custom2"
								elseif player.rsp_instashield_button == "custom2"
									player.rsp_instashield_button = "custom3"
								elseif player.rsp_instashield_button == "custom3"
									player.rsp_instashield_button = "nextweapon"
								elseif player.rsp_instashield_button == "nextweapon"
									player.rsp_instashield_button = "prevweapon"
								elseif player.rsp_instashield_button == "prevweapon"
									player.rsp_instashield_button = "none"
								elseif player.rsp_instashield_button == "none"
									player.rsp_instashield_button = "firenormal"
								end
								S_StartSound(nil, sfx_menu1, player)
							elseif player.rsp_navmenu.nav == 13
								if player.rsp_menu_button == "firenormal"
									player.rsp_menu_button = "tossflag"
								elseif player.rsp_menu_button == "tossflag"
									player.rsp_menu_button = "custom1"
								elseif player.rsp_menu_button == "custom1"
									player.rsp_menu_button = "custom2"
								elseif player.rsp_menu_button == "custom2"
									player.rsp_menu_button = "custom3"
								elseif player.rsp_menu_button == "custom3"
									player.rsp_menu_button = "nextweapon"
								elseif player.rsp_menu_button == "nextweapon"
									player.rsp_menu_button = "prevweapon"
								elseif player.rsp_menu_button == "prevweapon"
									player.rsp_menu_button = "none"
								elseif player.rsp_menu_button == "none"
									player.rsp_menu_button = "firenormal"
								end
								S_StartSound(nil, sfx_menu1, player)
							end
						elseif player.rsp_navmenu.cat == 2
							if player.rsp_navmenu.page == 0
								if player.rsp_navmenu.nav == 0
									if cv_rjenabled.value == 1
										COM_BufInsertText(player, "rsp_rocketjump 0")
									else
										COM_BufInsertText(player, "rsp_rocketjump 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 1
									if rocketjump_power.value < 99
										COM_BufInsertText(player, "rsp_rjpower "..rocketjump_power.value + 1)
									else
										COM_BufInsertText(player, "rsp_rjpower 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 2
									if cv_rspsuddendeath.value == 1
										COM_BufInsertText(player, "rsp_suddendeath 0")
									else
										COM_BufInsertText(player, "rsp_suddendeath 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 3
									if cv_autojump.value == 1
										COM_BufInsertText(player, "rsp_allowautojump 0")
									else
										COM_BufInsertText(player, "rsp_allowautojump 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 4
									if cv_allowshield.value == 1
										COM_BufInsertText(player, "rsp_allowshield 0")
									else
										COM_BufInsertText(player, "rsp_allowshield 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 5
									if cv_keepweapons.value == 1
										COM_BufInsertText(player, "rsp_keepweapons 0")
									else
										COM_BufInsertText(player, "rsp_keepweapons 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 6
									if cv_timerexplosion.value < 210
										COM_BufInsertText(player, "rsp_timerexplosion "..cv_timerexplosion.value + 1)
									else
										COM_BufInsertText(player, "rsp_timerexplosion 0")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 7
									if cv_rsptimelimit.value < 60
										COM_BufInsertText(player, "rsp_timelimit "..cv_rsptimelimit.value + 1)
									else
										COM_BufInsertText(player, "rsp_timelimit 0")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 8
									if cv_rspgetready.value < 60
										COM_BufInsertText(player, "rsp_getreadytimer "..cv_rspgetready.value + 1)
									else
										COM_BufInsertText(player, "rsp_getreadytimer 0")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 9
									if cv_rspwfp.value < 32
										COM_BufInsertText(player, "rsp_waitforplayers "..cv_rspwfp.value + 1)
									else
										COM_BufInsertText(player, "rsp_waitforplayers 0")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 10
									if cv_allowability.value == 1
										COM_BufInsertText(player, "rsp_allowability 0")
									else
										COM_BufInsertText(player, "rsp_allowability 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 11
									if cv_allowability2.value < 2
										COM_BufInsertText(player, "rsp_allowability2 "..cv_allowability2.value + 1)
									else
										COM_BufInsertText(player, "rsp_allowability2 0")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 12
									if cv_grenadeoptimization.value == 1
										COM_BufInsertText(player, "rsp_antilag_grenade 0")
									else
										COM_BufInsertText(player, "rsp_antilag_grenade 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 13
									if cv_quickswitching.value == 1
										COM_BufInsertText(player, "rsp_quickswitching 0")
									else
										COM_BufInsertText(player, "rsp_quickswitching 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								end
							elseif player.rsp_navmenu.page == 1
								if player.rsp_navmenu.nav == 14
									if cv_walljump.value == 1
										COM_BufInsertText(player, "rsp_walljump 0")
									else
										COM_BufInsertText(player, "rsp_walljump 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 15
									if cv_blowdamage.value < 50
										COM_BufInsertText(player, "rsp_blowdamage "..cv_blowdamage.value + 1)
									else
										COM_BufInsertText(player, "rsp_blowdamage 0")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 16
									if cv_autofire.value == 1
										COM_BufInsertText(player, "rsp_allowautofire 0")
									else
										COM_BufInsertText(player, "rsp_allowautofire 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 17
									if cv_aarj.value == 1
										COM_BufInsertText(player, "rsp_abilityafterrocketjump 0")
									else
										COM_BufInsertText(player, "rsp_abilityafterrocketjump 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								end
							elseif player.rsp_navmenu.page == 2
								if player.rsp_navmenu.nav == 18
									if cv_instagib.value == 1
										COM_BufInsertText(player, "rsp_instagib_mode 0")
									else
										COM_BufInsertText(player, "rsp_instagib_mode 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 19
									if cv_rbenabled.value == 1
										COM_BufInsertText(player, "rsp_railboost 0")
									else
										COM_BufInsertText(player, "rsp_railboost 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 20
									if railboost_power.value < 99
										COM_BufInsertText(player, "rsp_rbpower "..railboost_power.value + 1)
									else
										COM_BufInsertText(player, "rsp_rbpower 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 21
									if cv_instashield.value == 1
										COM_BufInsertText(player, "rsp_instashield 0")
									else
										COM_BufInsertText(player, "rsp_instashield 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 22
									if cv_rsplimitpa.value < 5000
										COM_BufInsertText(player, "rsp_arena_limitpoint "..cv_rsplimitpa.value + 1)
									else
										COM_BufInsertText(player, "rsp_arena_limitpoint 0")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 23
									if cv_rsplimitta.value < 20
										COM_BufInsertText(player, "rsp_arena_limittime "..cv_rsplimitta.value + 1)
									else
										COM_BufInsertText(player, "rsp_arena_limittime 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 24
									if ffastarterammo.value < 10
										COM_BufInsertText(player, "rsp_ammoffa "..ffastarterammo.value + 1)
									else
										COM_BufInsertText(player, "rsp_ammoffa 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 25
									if cv_explodeplayertimer.value < 60
										COM_BufInsertText(player, "rsp_killplayertimer "..cv_explodeplayertimer.value + 1)
									else
										COM_BufInsertText(player, "rsp_killplayertimer 5")
									end
									S_StartSound(nil, sfx_menu1, player)
								end
							end
						end
					end
				end
			elseif player.cmd.sidemove < -25 //player.cmd.angleturn > player.rsp_mcam.cmd_angleturn
				if player.rsp_navmenu.delay != 0
					player.rsp_navmenu.delay = $ - 1
				end
				if player.rsp_navmenu.pressed == false or player.rsp_navmenu.delay == 0
					player.rsp_navmenu.pressed = true
					if player.rsp_navmenu.scrolldelay != 0
						player.rsp_navmenu.scrolldelay = $ - 1
					else
						player.rsp_navmenu.scrolldelay = 1
						if player.rsp_navmenu.cat == 1
							if player.rsp_navmenu.nav == 0
								if tonumber(player.rsp_crosshair) or player.rsp_crosshair == 0
									if player.rsp_crosshair > 0
										player.rsp_crosshair = $ - 1
									elseif player.rsp_crosshair == 0
										player.rsp_crosshair = "c"
									end
								elseif player.rsp_crosshair  == "a"
									player.rsp_crosshair = 66
								elseif player.rsp_crosshair == "b"
									player.rsp_crosshair = "a"
								elseif player.rsp_crosshair == "c"
									player.rsp_crosshair = "b"
								end
								S_StartSound(nil, sfx_menu1, player)
							elseif player.rsp_navmenu.nav == 1
								if tonumber(player.rsp_crosshair_alt) or player.rsp_crosshair_alt == 0
									if player.rsp_crosshair_alt > 0
										player.rsp_crosshair_alt = $ - 1
									elseif player.rsp_crosshair_alt == 0
										player.rsp_crosshair_alt = "c"
									end
								elseif player.rsp_crosshair_alt  == "a"
									player.rsp_crosshair_alt = 66
								elseif player.rsp_crosshair_alt == "b"
									player.rsp_crosshair_alt = "a"
								elseif player.rsp_crosshair_alt == "c"
									player.rsp_crosshair_alt = "b"
								end
								S_StartSound(nil, sfx_menu1, player)
							elseif player.rsp_navmenu.nav == 2
								if player.rsp_crosshair_color > 0
									player.rsp_crosshair_color = $ - 1
								else
									player.rsp_crosshair_color = #skincolors-1
								end
								S_StartSound(nil, sfx_menu1, player)
							elseif player.rsp_navmenu.nav == 3
								if player.rsp_crosshair_scale > 1
									player.rsp_crosshair_scale = $ - 1
								else
									player.rsp_crosshair_scale = 10
								end
								S_StartSound(nil, sfx_menu1, player)
							elseif player.rsp_navmenu.nav == 4
								if player.rsp_hud > 0
									player.rsp_hud = $ - 1
								else
									player.rsp_hud = #RSP.hud
								end
								if RSP.hud[player.rsp_hud].v_score == true
									hud.enable("score")
								else
									hud.disable("score")
								end
								if RSP.hud[player.rsp_hud].v_time == true
									hud.enable("time")
								else
									hud.disable("time")
								end
								if RSP.hud[player.rsp_hud].v_rings == true
									hud.enable("rings")
								else
									hud.disable("rings")
								end
								if RSP.hud[player.rsp_hud].v_lives == true
									hud.enable("lives")
								else
									hud.disable("lives")
								end
								if RSP.hud[player.rsp_hud].v_teamscores == true
									hud.enable("teamscores")
								else
									hud.disable("teamscores")
								end
								if RSP.hud[player.rsp_hud].v_powerstones == true
									hud.enable("powerstones")
								else
									hud.disable("powerstones")
								end
								S_StartSound(nil, sfx_menu1, player)
							elseif player.rsp_navmenu.nav == 5
								if player.rsp_bghud == 1
									player.rsp_bghud = 0
								else
									player.rsp_bghud = 1
								end
								S_StartSound(nil, sfx_menu1, player)
							elseif player.rsp_navmenu.nav == 6
								if player.rsp_hud_ammo > 0
									player.rsp_hud_ammo = $ - 1
								else
									player.rsp_hud_ammo = 3
								end
								S_StartSound(nil, sfx_menu1, player)
							elseif player.rsp_navmenu.nav == 7
								if player.rsp_hud_speed > 0
									player.rsp_hud_speed = $ - 1
								else
									player.rsp_hud_speed = 2
								end
								S_StartSound(nil, sfx_menu1, player)
							elseif player.rsp_navmenu.nav == 8
								if cv_rspspawnpoint.value == 1
									COM_BufInsertText(player, "rsp_spawnpoint 0")
								else
									COM_BufInsertText(player, "rsp_spawnpoint 1")
								end
								S_StartSound(nil, sfx_menu1, player)
							elseif player.rsp_navmenu.nav == 9
								if player.rsp_autojump == "1"
									player.rsp_autojump = "0"
								else
									player.rsp_autojump = "1"
								end
								S_StartSound(nil, sfx_menu1, player)
							elseif player.rsp_navmenu.nav == 10
								if player.rsp_autofire == 1
									player.rsp_autofire = 0
								else
									player.rsp_autofire = 1
								end
								S_StartSound(nil, sfx_menu1, player)
							elseif player.rsp_navmenu.nav == 11
								if player.rsp_hud_buttons == 1
									player.rsp_hud_buttons = 0
								else
									player.rsp_hud_buttons = 1
								end
								S_StartSound(nil, sfx_menu1, player)
							elseif player.rsp_navmenu.nav == 12
								if player.rsp_instashield_button == "firenormal"
									player.rsp_instashield_button = "none"
								elseif player.rsp_instashield_button == "tossflag"
									player.rsp_instashield_button = "firenormal"
								elseif player.rsp_instashield_button == "custom1"
									player.rsp_instashield_button = "tossflag"
								elseif player.rsp_instashield_button == "custom2"
									player.rsp_instashield_button = "custom1"
								elseif player.rsp_instashield_button == "custom3"
									player.rsp_instashield_button = "custom2"
								elseif player.rsp_instashield_button == "nextweapon"
									player.rsp_instashield_button = "custom3"
								elseif player.rsp_instashield_button == "prevweapon"
									player.rsp_instashield_button = "nextweapon"
								elseif player.rsp_instashield_button == "none"
									player.rsp_instashield_button = "prevweapon"
								end
								S_StartSound(nil, sfx_menu1, player)
							elseif player.rsp_navmenu.nav == 13
								if player.rsp_menu_button == "firenormal"
									player.rsp_menu_button = "none"
								elseif player.rsp_menu_button == "tossflag"
									player.rsp_menu_button = "firenormal"
								elseif player.rsp_menu_button == "custom1"
									player.rsp_menu_button = "tossflag"
								elseif player.rsp_menu_button == "custom2"
									player.rsp_menu_button = "custom1"
								elseif player.rsp_menu_button == "custom3"
									player.rsp_menu_button = "custom2"
								elseif player.rsp_menu_button == "nextweapon"
									player.rsp_menu_button = "custom3"
								elseif player.rsp_menu_button == "prevweapon"
									player.rsp_menu_button = "nextweapon"
								elseif player.rsp_menu_button == "none"
									player.rsp_menu_button = "prevweapon"
								end
								S_StartSound(nil, sfx_menu1, player)
							end
						elseif player.rsp_navmenu.cat == 2
							if player.rsp_navmenu.page == 0
								if player.rsp_navmenu.nav == 0
									if cv_rjenabled.value == 1
										COM_BufInsertText(player, "rsp_rocketjump 0")
									else
										COM_BufInsertText(player, "rsp_rocketjump 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 1
									if rocketjump_power.value != 1
										COM_BufInsertText(player, "rsp_rjpower "..rocketjump_power.value - 1)
									else
										COM_BufInsertText(player, "rsp_rjpower 99")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 2
									if cv_rspsuddendeath.value == 1
										COM_BufInsertText(player, "rsp_suddendeath 0")
									else
										COM_BufInsertText(player, "rsp_suddendeath 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 3
									if cv_autojump.value == 1
										COM_BufInsertText(player, "rsp_allowautojump 0")
									else
										COM_BufInsertText(player, "rsp_allowautojump 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 4
									if cv_allowshield.value == 1
										COM_BufInsertText(player, "rsp_allowshield 0")
									else
										COM_BufInsertText(player, "rsp_allowshield 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 5
									if cv_keepweapons.value == 1
										COM_BufInsertText(player, "rsp_keepweapons 0")
									else
										COM_BufInsertText(player, "rsp_keepweapons 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 6
									if cv_timerexplosion.value != 0
										COM_BufInsertText(player, "rsp_timerexplosion "..cv_timerexplosion.value - 1)
									else
										COM_BufInsertText(player, "rsp_timerexplosion 210")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 7
									if cv_rsptimelimit.value != 0
										COM_BufInsertText(player, "rsp_timelimit "..cv_rsptimelimit.value - 1)
									else
										COM_BufInsertText(player, "rsp_timelimit 60")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 8
									if cv_rspgetready.value != 0
										COM_BufInsertText(player, "rsp_getreadytimer "..cv_rspgetready.value - 1)
									else
										COM_BufInsertText(player, "rsp_getreadytimer 60")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 9
									if cv_rspwfp.value != 1
										COM_BufInsertText(player, "rsp_waitforplayers "..cv_rspwfp.value - 1)
									else
										COM_BufInsertText(player, "rsp_waitforplayers 32")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 10
									if cv_allowability.value == 1
										COM_BufInsertText(player, "rsp_allowability 0")
									else
										COM_BufInsertText(player, "rsp_allowability 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 11
									if cv_allowability2.value != 0
										COM_BufInsertText(player, "rsp_allowability2 "..cv_allowability2.value - 1)
									else
										COM_BufInsertText(player, "rsp_allowability2 2")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 12
									if cv_grenadeoptimization.value == 1
										COM_BufInsertText(player, "rsp_antilag_grenade 0")
									else
										COM_BufInsertText(player, "rsp_antilag_grenade 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 13
									if cv_quickswitching.value == 1
										COM_BufInsertText(player, "rsp_quickswitching 0")
									else
										COM_BufInsertText(player, "rsp_quickswitching 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								end
							elseif player.rsp_navmenu.page == 1
								if player.rsp_navmenu.nav == 14
									if cv_walljump.value == 1
										COM_BufInsertText(player, "rsp_walljump 0")
									else
										COM_BufInsertText(player, "rsp_walljump 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 15
									if cv_blowdamage.value > 0
										COM_BufInsertText(player, "rsp_blowdamage "..cv_blowdamage.value - 1)
									else
										COM_BufInsertText(player, "rsp_blowdamage 50")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 16
									if cv_autofire.value == 1
										COM_BufInsertText(player, "rsp_allowautofire 0")
									else
										COM_BufInsertText(player, "rsp_allowautofire 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 17
									if cv_aarj.value == 1
										COM_BufInsertText(player, "rsp_abilityafterrocketjump 0")
									else
										COM_BufInsertText(player, "rsp_abilityafterrocketjump 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								end
							elseif player.rsp_navmenu.page == 2
								if player.rsp_navmenu.nav == 18
									if cv_instagib.value == 1
										COM_BufInsertText(player, "rsp_instagib_mode 0")
									else
										COM_BufInsertText(player, "rsp_instagib_mode 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 19
									if cv_rbenabled.value == 1
										COM_BufInsertText(player, "rsp_railboost 0")
									else
										COM_BufInsertText(player, "rsp_railboost 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 20
									if railboost_power.value != 1
										COM_BufInsertText(player, "rsp_rbpower "..railboost_power.value - 1)
									else
										COM_BufInsertText(player, "rsp_rbpower 99")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 21
									if cv_instashield.value == 1
										COM_BufInsertText(player, "rsp_instashield 0")
									else
										COM_BufInsertText(player, "rsp_instashield 1")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 22
									if cv_rsplimitpa.value != 0
										COM_BufInsertText(player, "rsp_arena_limitpoint "..cv_rsplimitpa.value - 1)
									else
										COM_BufInsertText(player, "rsp_arena_limitpoint 5000")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 23
									if cv_rsplimitta.value != 1
										COM_BufInsertText(player, "rsp_arena_limittime "..cv_rsplimitta.value - 1)
									else
										COM_BufInsertText(player, "rsp_arena_limittime 20")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 24
									if ffastarterammo.value != 1
										COM_BufInsertText(player, "rsp_ammoffa "..ffastarterammo.value - 1)
									else
										COM_BufInsertText(player, "rsp_ammoffa 10")
									end
									S_StartSound(nil, sfx_menu1, player)
								elseif player.rsp_navmenu.nav == 25
									if cv_explodeplayertimer.value != 5
										COM_BufInsertText(player, "rsp_killplayertimer "..cv_explodeplayertimer.value - 1)
									else
										COM_BufInsertText(player, "rsp_killplayertimer 60")
									end
									S_StartSound(nil, sfx_menu1, player)
								end
							end
						end
					end
				end
			else
				if player.rsp_navmenu
					player.rsp_navmenu.delay = 35
					player.rsp_navmenu.scrolldelay = 0
					player.rsp_navmenu.pressed = false
				end
			end
			player.cmd.forwardmove = 0
			player.cmd.sidemove = 0
			player.cmd.buttons = 0
		else
			if player.rsp_menu_button != "none"
				if (player.cmd.buttons & RSP.buttons[player.rsp_menu_button].button) and not (player.cmd.buttons & BT_SPIN)
					if gamestate == GS_LEVEL
						if player.rsp_menu != true
							player.rsp_menu = true
						end
					end
				end
			end
		end
	end
end)

local rsp_menu = function(v, player, mo, cam)
	if gamestate == GS_LEVEL
		if player.rsp_menu and player.rsp_navmenu
			v.fadeScreen(31, 5)
			if player.rsp_navmenu.cat == 0
				v.drawScaledNameTag(160*FRACUNIT, 15*FRACUNIT, "RingSlinger Plus", V_ALLOWLOWERCASE|V_SNAPTOTOP, FRACUNIT, SKINCOLOR_YELLOW, SKINCOLOR_BLACK)
				if player.rsp_navmenu.nav == 0
					v.drawString(160, 80, (tostring("\x82".."Player settings")), V_SNAPTOTOP, "center")
				else
					v.drawString(160, 80, (tostring("Player settings")), V_SNAPTOTOP, "center")
				end
				if player.rsp_navmenu.nav == 1
					if IsPlayerAdmin(player) or player == server
						v.drawString(160, 90, (tostring("\x82".."Server settings")), V_SNAPTOTOP, "center")
					else
						v.drawString(160, 90, (tostring("Server settings")), V_REDMAP|V_SNAPTOTOP, "center")
					end
				else
					if IsPlayerAdmin(player) or player == server
						v.drawString(160, 90, (tostring("Server settings")), V_SNAPTOTOP, "center")
					else
						v.drawString(160, 90, (tostring("Server settings")), V_GRAYMAP|V_SNAPTOTOP, "center")
					end
				end
				if player.rsp_navmenu.nav == 2
					v.drawString(160, 110, (tostring("\x82".."Exit the menu")), V_SNAPTOTOP, "center")
				else
					v.drawString(160, 110, (tostring("Exit the menu")), V_SNAPTOTOP, "center")
				end
			elseif player.rsp_navmenu.cat == 1
				v.drawFill(260, 54, 40, 40, 31|V_SNAPTOTOP)
				v.drawFill(260, 54, 41, 41, 15|V_SNAPTOTOP)
				if player.rsp_crosshair and player.rsp_crosshair_scale
					if player.rsp_crosshair != 0 and player.rsp_crosshair != "a" and player.rsp_crosshair != "b" and player.rsp_crosshair != "c"
						if player.rsp_crosshair_color == 0 or player.rsp_crosshair_color == nil
							v.drawScaled((281*FRACUNIT)-32768, 62*FRACUNIT, (player.rsp_crosshair_scale*8192), v.cachePatch("RSPCSH"..player.rsp_crosshair), V_SUBTRACT, v.getColormap(nil, SKINCOLOR_WHITE))
						else
							v.drawScaled((281*FRACUNIT)-32768, 62*FRACUNIT, (player.rsp_crosshair_scale*8192), v.cachePatch("RSPCSH"..player.rsp_crosshair), 0, v.getColormap(nil, player.rsp_crosshair_color))
						end
					elseif player.rsp_crosshair == "a" or player.rsp_crosshair == "b" or player.rsp_crosshair == "c"
						v.drawScaled((281*FRACUNIT)-32768, 62*FRACUNIT, FRACUNIT, v.cachePatch("SRBVHAI"..player.rsp_crosshair), V_30TRANS, v.getColormap(nil, SKINCOLOR_GREEN))
					end
				end
				if player.rsp_crosshair_alt and player.rsp_crosshair_scale
					if player.rsp_crosshair_alt != 0 and player.rsp_crosshair_alt != "a" and player.rsp_crosshair_alt != "b" and player.rsp_crosshair_alt != "c"
						if player.rsp_crosshair_color == 0 or player.rsp_crosshair_color == nil
							v.drawScaled((281*FRACUNIT)-32768, 62*FRACUNIT, (player.rsp_crosshair_scale*8192), v.cachePatch("RSPCSH"..player.rsp_crosshair_alt), V_SUBTRACT, v.getColormap(nil, SKINCOLOR_WHITE))
						else
							v.drawScaled((281*FRACUNIT)-32768, 62*FRACUNIT, (player.rsp_crosshair_scale*8192), v.cachePatch("RSPCSH"..player.rsp_crosshair_alt), 0, v.getColormap(nil, player.rsp_crosshair_color))
						end
					elseif player.rsp_crosshair_alt == "a" or player.rsp_crosshair_alt == "b" or player.rsp_crosshair_alt == "c"
						v.drawScaled((281*FRACUNIT)-32768, 62*FRACUNIT, FRACUNIT, v.cachePatch("SRBVHAI"..player.rsp_crosshair_alt), V_30TRANS, v.getColormap(nil, SKINCOLOR_GREEN))
					end
				end
				v.drawScaledNameTag(160*FRACUNIT, 15*FRACUNIT, "Player settings", V_ALLOWLOWERCASE|V_SNAPTOTOP, FRACUNIT, SKINCOLOR_YELLOW, SKINCOLOR_BLACK)
				v.drawString(20, 42, (tostring("\x82".."HUD SETTINGS")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				v.drawFill(20, 51, 281, 2, 31|V_SNAPTOTOP)
				v.drawFill(20, 51, 280, 1, 74|V_SNAPTOTOP)
				v.drawString(20, 132, (tostring("\x82".."OTHER SETTINGS")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				v.drawFill(20, 141, 281, 2, 31|V_SNAPTOTOP)
				v.drawFill(20, 141, 280, 1, 74|V_SNAPTOTOP)
				if player.rsp_navmenu.nav == 0
					if player.rsp_crosshair == "a"
						v.drawString(255, 54, (tostring("\x82".."< CROSS".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					elseif player.rsp_crosshair == "b"
						v.drawString(255, 54, (tostring("\x82".."< ANGLE".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					elseif player.rsp_crosshair == "c"
						v.drawString(255, 54, (tostring("\x82".."< POINT".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					else
						v.drawString(255, 54, (tostring("\x82 < "..player.rsp_crosshair.." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					end
					v.drawString(30, 54, (tostring("\x82".."CROSSHAIR TYPE")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				else
					if player.rsp_crosshair == "a"
						v.drawString(255, 54, (tostring("\x82".."CROSS")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					elseif player.rsp_crosshair == "b"
						v.drawString(255, 54, (tostring("\x82".."ANGLE")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					elseif player.rsp_crosshair == "c"
						v.drawString(255, 54, (tostring("\x82".."POINT")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					else
						v.drawString(255, 54, (tostring("\x82"..player.rsp_crosshair)), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					end
					v.drawString(30, 54, (tostring("CROSSHAIR TYPE")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				end
				if player.rsp_navmenu.nav == 1
					if player.rsp_crosshair_alt == "a"
						v.drawString(255, 64, (tostring("\x82".."< CROSS".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					elseif player.rsp_crosshair_alt == "b"
						v.drawString(255, 64, (tostring("\x82".."< ANGLE".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					elseif player.rsp_crosshair_alt == "c"
						v.drawString(255, 64, (tostring("\x82".."< POINT".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					else
						v.drawString(255, 64, (tostring("\x82 < "..player.rsp_crosshair_alt.." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					end
					v.drawString(30, 64, (tostring("\x82".."CROSSHAIR TYPE")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				else
					if player.rsp_crosshair_alt == "a"
						v.drawString(255, 64, (tostring("\x82".."CROSS")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					elseif player.rsp_crosshair_alt == "b"
						v.drawString(255, 64, (tostring("\x82".."ANGLE")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					elseif player.rsp_crosshair_alt == "c"
						v.drawString(255, 64, (tostring("\x82".."POINT")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					else
						v.drawString(255, 64, (tostring("\x82"..player.rsp_crosshair_alt)), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					end
					v.drawString(30, 64, (tostring("CROSSHAIR ALT TYPE")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				end
				if player.rsp_navmenu.nav == 2
					if player.rsp_crosshair_color != 0
						v.drawString(255, 74, (tostring("\x82".."< "..string.upper(skincolors[player.rsp_crosshair_color].name).." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					else
						v.drawString(255, 74, (tostring("\x82".."< ".."SUBTRACT".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					end
					v.drawString(30, 74, (tostring("\x82".."CROSSHAIR COLOR")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				else
					if player.rsp_crosshair_color != 0
						v.drawString(255, 74, (tostring("\x82"..string.upper(skincolors[player.rsp_crosshair_color].name))), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					else
						v.drawString(255, 74, (tostring("\x82".."SUBTRACT")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					end
					v.drawString(30, 74, (tostring("CROSSHAIR COLOR")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				end
				if player.rsp_navmenu.nav == 3
					v.drawString(255, 84, (tostring("\x82".."< "..player.rsp_crosshair_scale.." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					v.drawString(30, 84, (tostring("\x82".."CROSSHAIR SCALE")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				else
					v.drawString(255, 84, (tostring("\x82"..player.rsp_crosshair_scale)), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					v.drawString(30, 84, (tostring("CROSSHAIR SCALE")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				end
				if player.rsp_navmenu.nav == 4
					v.drawString(255, 94, (tostring("\x82".."< "..string.upper(RSP.hud[player.rsp_hud].name.." >"))), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					v.drawString(30, 94, (tostring("\x82".."HUD TYPE")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				else
					v.drawString(255, 94, (tostring("\x82"..string.upper(RSP.hud[player.rsp_hud].name))), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					v.drawString(30, 94, (tostring("HUD TYPE")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				end
				if player.rsp_navmenu.nav == 5
					if player.rsp_bghud == 1
						v.drawString(255, 104, (tostring("\x82".."< ENABLED >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					else
						v.drawString(255, 104, (tostring("\x82".."< DISABLED >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					end
					v.drawString(30, 104, (tostring("\x82".."HUD BACKGROUND")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				else
					if player.rsp_bghud == 1
						v.drawString(255, 104, (tostring("\x82".."ENABLED")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					else
						v.drawString(255, 104, (tostring("\x82".."DISABLED")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					end
					v.drawString(30, 104, (tostring("HUD BACKGROUND")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				end
				if player.rsp_navmenu.nav == 6
					if player.rsp_hud_ammo == 1
						v.drawString(255, 114, (tostring("\x82".."< ONLY RINGS >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					elseif player.rsp_hud_ammo == 2
						v.drawString(255, 114, (tostring("\x82".."< ONLY AMMO >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					elseif player.rsp_hud_ammo == 3
						v.drawString(255, 114, (tostring("\x82".."< AMMO AND RINGS >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					else
						v.drawString(255, 114, (tostring("\x82".."< DISABLED >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					end
					v.drawString(30, 114, (tostring("\x82".."HUD AMMO")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				else
					if player.rsp_hud_ammo == 1
						v.drawString(255, 114, (tostring("\x82".."ONLY RINGS")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					elseif player.rsp_hud_ammo == 2
						v.drawString(255, 114, (tostring("\x82".."ONLY AMMO")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					elseif player.rsp_hud_ammo == 3
						v.drawString(255, 114, (tostring("\x82".."AMMO AND RINGS")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					else
						v.drawString(255, 114, (tostring("\x82".."DISABLED")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					end
					v.drawString(30, 114, (tostring("HUD AMMO")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				end
				if player.rsp_navmenu.nav == 7
					if player.rsp_hud_speed == 1
						v.drawString(255, 124, (tostring("\x82".."< LEFT ON SCREEN >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					elseif player.rsp_hud_speed == 2
						v.drawString(255, 124, (tostring("\x82".."< NEAR CROSSHAIR >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					else
						v.drawString(255, 124, (tostring("\x82".."< DISABLED >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					end
					v.drawString(30, 124, (tostring("\x82".."HUD SPEED")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				else
					if player.rsp_hud_speed == 1
						v.drawString(255, 124, (tostring("\x82".."LEFT ON SCREEN")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					elseif player.rsp_hud_speed == 2
						v.drawString(255, 124, (tostring("\x82".."NEAR CROSSHAIR")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					else
						v.drawString(255, 124, (tostring("\x82".."DISABLED")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					end
					v.drawString(30, 124, (tostring("HUD SPEED")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				end
				if player.rsp_navmenu.nav == 8
					if cv_rspspawnpoint.value == 1
						v.drawString(290, 144, (tostring("\x82".."< YES >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					else
						v.drawString(290, 144, (tostring("\x82".."< NO >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					end
					v.drawString(30, 144, (tostring("\x82".."SHOW SPAWNPOINT")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				else
					if cv_rspspawnpoint.value == 1
						v.drawString(290, 144, (tostring("\x82".."YES")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					else
						v.drawString(290, 144, (tostring("\x82".."NO")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					end
					v.drawString(30, 144, (tostring("SHOW SPAWNPOINT")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				end
				if player.rsp_navmenu.nav == 9
					if player.rsp_autojump == "1"
						v.drawString(290, 154, (tostring("\x82".."< YES >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					else
						v.drawString(290, 154, (tostring("\x82".."< NO >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					end
					v.drawString(30, 154, (tostring("\x82".."AUTOJUMP")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				else
					if player.rsp_autojump == "1"
						v.drawString(290, 154, (tostring("\x82".."YES")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					else
						v.drawString(290, 154, (tostring("\x82".."NO")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					end
					v.drawString(30, 154, (tostring("AUTOJUMP")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				end
				if player.rsp_navmenu.nav == 10
					if player.rsp_autofire == 1
						v.drawString(290, 164, (tostring("\x82".."< YES >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					else
						v.drawString(290, 164, (tostring("\x82".."< NO >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					end
					v.drawString(30, 164, (tostring("\x82".."AUTOFIRE")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				else
					if player.rsp_autofire == 1
						v.drawString(290, 164, (tostring("\x82".."YES")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					else
						v.drawString(290, 164, (tostring("\x82".."NO")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					end
					v.drawString(30, 164, (tostring("AUTOFIRE")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				end
				if player.rsp_navmenu.nav == 11
					if player.rsp_hud_buttons == 1
						v.drawString(290, 174, (tostring("\x82".."< YES >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					else
						v.drawString(290, 174, (tostring("\x82".."< NO >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					end
					v.drawString(30, 174, (tostring("\x82".."HUD BUTTONS")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				else
					if player.rsp_hud_buttons == 1
						v.drawString(290, 174, (tostring("\x82".."YES")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					else
						v.drawString(290, 174, (tostring("\x82".."NO")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					end
					v.drawString(30, 174, (tostring("HUD BUTTONS")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				end
				if player.rsp_navmenu.nav == 12
					v.drawString(290, 184, (tostring("\x82".."< "..string.upper(player.rsp_instashield_button).." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					v.drawString(30, 184, (tostring("\x82".."INSTASHIELD BUTTON")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				else
					v.drawString(290, 184, (tostring("\x82"..string.upper(player.rsp_instashield_button))), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					v.drawString(30, 184, (tostring("INSTASHIELD BUTTON")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				end
				if player.rsp_navmenu.nav == 13
					v.drawString(290, 194, (tostring("\x82".."< "..string.upper(player.rsp_menu_button).." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					v.drawString(30, 194, (tostring("\x82".."OPEN MENU BUTTON")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				else
					v.drawString(290, 194, (tostring("\x82"..string.upper(player.rsp_menu_button))), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
					v.drawString(30, 194, (tostring("OPEN MENU BUTTON")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
				end
			elseif player.rsp_navmenu.cat == 2
				v.drawScaledNameTag(160*FRACUNIT, 15*FRACUNIT, "Server settings", V_ALLOWLOWERCASE|V_SNAPTOTOP, FRACUNIT, SKINCOLOR_YELLOW, SKINCOLOR_BLACK)
				if player.rsp_navmenu.page == 0
					v.drawString(20, 42, (tostring("\x82".."RSP SETTINGS")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					v.drawFill(20, 51, 281, 2, 31|V_SNAPTOTOP)
					v.drawFill(20, 51, 280, 1, 74|V_SNAPTOTOP)
					if player.rsp_navmenu.nav == 0
						if cv_rjenabled.value == 1
							v.drawString(290, 54, (tostring("\x82".."< ".."ENABLED".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 54, (tostring("\x82".."< ".."DISABLED".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 54, (tostring("\x82".."ROCKETJUMP")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					else
						if cv_rjenabled.value == 1
							v.drawString(290, 54, (tostring("\x82".."ENABLED")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 54, (tostring("\x82".."DISABLED")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 54, (tostring("ROCKETJUMP")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					end
					if player.rsp_navmenu.nav == 1
						v.drawString(290, 64, (tostring("\x82".."< "..rocketjump_power.value.." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						v.drawString(30, 64, (tostring("\x82".."ROCKETJUMP POWER")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					else
						v.drawString(290, 64, (tostring("\x82"..rocketjump_power.value)), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						v.drawString(30, 64, (tostring("ROCKETJUMP POWER")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					end
					if player.rsp_navmenu.nav == 2
						if cv_rspsuddendeath.value == 1
							v.drawString(290, 74, (tostring("\x82".."< ".."YES".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 74, (tostring("\x82".."< ".."NO".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 74, (tostring("\x82".."SUDDEN DEATH")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					else
						if cv_rspsuddendeath.value == 1
							v.drawString(290, 74, (tostring("\x82".."YES")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 74, (tostring("\x82".."NO")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 74, (tostring("SUDDEN DEATH")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					end
					if player.rsp_navmenu.nav == 3
						if cv_autojump.value == 1
							v.drawString(290, 84, (tostring("\x82".."< ".."YES".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 84, (tostring("\x82".."< ".."NO".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 84, (tostring("\x82".."ALLOW AUTOJUMP")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					else
						if cv_autojump.value == 1
							v.drawString(290, 84, (tostring("\x82".."YES")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 84, (tostring("\x82".."NO")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 84, (tostring("ALLOW AUTOJUMP")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					end
					if player.rsp_navmenu.nav == 4
						if cv_allowshield.value == 1
							v.drawString(290, 94, (tostring("\x82".."< ".."YES".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 94, (tostring("\x82".."< ".."NO".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 94, (tostring("\x82".."ALLOW SHIELD")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					else
						if cv_allowshield.value == 1
							v.drawString(290, 94, (tostring("\x82".."YES")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 94, (tostring("\x82".."NO")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 94, (tostring("ALLOW SHIELD")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					end
					if player.rsp_navmenu.nav == 5
						if cv_keepweapons.value == 1
							v.drawString(290, 104, (tostring("\x82".."< ".."YES".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 104, (tostring("\x82".."< ".."NO".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 104, (tostring("\x82".."KEEPWEAPONS")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					else
						if cv_keepweapons.value == 1
							v.drawString(290, 104, (tostring("\x82".."YES")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 104, (tostring("\x82".."NO")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 104, (tostring("KEEPWEAPONS")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					end
					if player.rsp_navmenu.nav == 6
						v.drawString(290, 114, (tostring("\x82".."< "..cv_timerexplosion.value.." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						v.drawString(30, 114, (tostring("\x82".."GRENADE TIMER")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					else
						v.drawString(290, 114, (tostring("\x82"..cv_timerexplosion.value)), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						v.drawString(30, 114, (tostring("GRENADE TIMER")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					end
					if player.rsp_navmenu.nav == 7
						v.drawString(290, 124, (tostring("\x82".."< "..cv_rsptimelimit.value.." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						v.drawString(30, 124, (tostring("\x82".."TIME LIMIT")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					else
						v.drawString(290, 124, (tostring("\x82"..cv_rsptimelimit.value)), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						v.drawString(30, 124, (tostring("TIME LIMIT")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					end
					if player.rsp_navmenu.nav == 8
						v.drawString(290, 134, (tostring("\x82".."< "..cv_rspgetready.value.." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						v.drawString(30, 134, (tostring("\x82".."GET READY TIMER")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					else
						v.drawString(290, 134, (tostring("\x82"..cv_rspgetready.value)), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						v.drawString(30, 134, (tostring("GET READY TIMER")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					end
					if player.rsp_navmenu.nav == 9
						v.drawString(290, 144, (tostring("\x82".."< "..cv_rspwfp.value.." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						v.drawString(30, 144, (tostring("\x82".."WAIT FOR PLAYERS")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					else
						v.drawString(290, 144, (tostring("\x82"..cv_rspwfp.value)), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						v.drawString(30, 144, (tostring("WAIT FOR PLAYERS")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					end
					if player.rsp_navmenu.nav == 10
						if cv_allowability.value == 1
							v.drawString(290, 154, (tostring("\x82".."< ".."YES".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 154, (tostring("\x82".."< ".."NO".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 154, (tostring("\x82".."ALLOWABILITY (JUMP)")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					else
						if cv_allowability.value == 1
							v.drawString(290, 154, (tostring("\x82".."YES")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 154, (tostring("\x82".."NO")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 154, (tostring("ALLOWABILITY (JUMP)")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					end
					if player.rsp_navmenu.nav == 11
						if cv_allowability2.value == 1
							v.drawString(290, 164, (tostring("\x82".."< ".."YES".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						elseif cv_allowability2.value == 0
							v.drawString(290, 164, (tostring("\x82".."< ".."NO".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						elseif cv_allowability2.value == 2
							v.drawString(290, 164, (tostring("\x82".."< ".."DASH".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 164, (tostring("\x82".."ALLOWABILITY (SPIN)")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					else
						if cv_allowability2.value == 1
							v.drawString(290, 164, (tostring("\x82".."YES")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						elseif cv_allowability2.value == 0
							v.drawString(290, 164, (tostring("\x82".."NO")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						elseif cv_allowability2.value == 2
							v.drawString(290, 164, (tostring("\x82".."DASH")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 164, (tostring("ALLOWABILITY (SPIN)")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					end
					if player.rsp_navmenu.nav == 12
						if cv_grenadeoptimization.value == 1
							v.drawString(290, 174, (tostring("\x82".."< ".."YES".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 174, (tostring("\x82".."< ".."NO".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 174, (tostring("\x82".."CHANGE EXPLOSION(ANTILAG)")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					else
						if cv_grenadeoptimization.value == 1
							v.drawString(290, 174, (tostring("\x82".."YES")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 174, (tostring("\x82".."NO")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 174, (tostring("CHANGE EXPLOSION(ANTILAG)")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					end
					if player.rsp_navmenu.nav == 13
						if cv_quickswitching.value == 1
							v.drawString(290, 184, (tostring("\x82".."< ".."YES".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 184, (tostring("\x82".."< ".."NO".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 184, (tostring("\x82".."QUICKSWITCHING")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					else
						if cv_quickswitching.value == 1
							v.drawString(290, 184, (tostring("\x82".."YES")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 184, (tostring("\x82".."NO")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 184, (tostring("QUICKSWITCHING")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					end
					v.drawString(290, 194, (tostring("\x82".."PAGE 1/3")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
				elseif player.rsp_navmenu.page == 1
					v.drawString(20, 42, (tostring("\x82".."RSP SETTINGS")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					v.drawFill(20, 51, 281, 2, 31|V_SNAPTOTOP)
					v.drawFill(20, 51, 280, 1, 74|V_SNAPTOTOP)
					if player.rsp_navmenu.nav == 14
						if cv_walljump.value == 1
							v.drawString(290, 54, (tostring("\x82".."< ".."ENABLED".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 54, (tostring("\x82".."< ".."DISABLED".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 54, (tostring("\x82".."WALLJUMP")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					else
						if cv_walljump.value == 1
							v.drawString(290, 54, (tostring("\x82".."ENABLED")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 54, (tostring("\x82".."DISABLED")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 54, (tostring("WALLJUMP")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					end
					if player.rsp_navmenu.nav == 15
						v.drawString(290, 64, (tostring("\x82".."< "..cv_blowdamage.value.." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						v.drawString(30, 64, (tostring("\x82".."BLOW DAMAGE")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					else
						v.drawString(290, 64, (tostring("\x82"..cv_blowdamage.value)), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						v.drawString(30, 64, (tostring("BLOW DAMAGE")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					end
					if player.rsp_navmenu.nav == 16
						if cv_autofire.value == 1
							v.drawString(290, 74, (tostring("\x82".."< ".."YES".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 74, (tostring("\x82".."< ".."NO".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 74, (tostring("\x82".."ALLOW AUTOFIRE")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					else
						if cv_autofire.value == 1
							v.drawString(290, 74, (tostring("\x82".."YES")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 74, (tostring("\x82".."NO")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 74, (tostring("ALLOW AUTOFIRE")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					end
					if player.rsp_navmenu.nav == 17
						if cv_aarj.value == 1
							v.drawString(290, 84, (tostring("\x82".."< ".."YES".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 84, (tostring("\x82".."< ".."NO".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 84, (tostring("\x82".."CHARABILITY AFTER BLOW")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					else
						if cv_aarj.value == 1
							v.drawString(290, 84, (tostring("\x82".."YES")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 84, (tostring("\x82".."NO")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 84, (tostring("CHARABILITY AFTER BLOW")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					end
					v.drawString(290, 194, (tostring("\x82".."PAGE 2/3")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
				elseif player.rsp_navmenu.page == 2
					v.drawString(20, 42, (tostring("\x82".."INSTAGIB")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					v.drawFill(20, 51, 281, 2, 31|V_SNAPTOTOP)
					v.drawFill(20, 51, 280, 1, 74|V_SNAPTOTOP)
					if player.rsp_navmenu.nav == 18
						if cv_instagib.value == 1
						v.drawString(290, 54, (tostring("\x82".."< ".."ENABLED".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 54, (tostring("\x82".."< ".."DISABLED".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 54, (tostring("\x82".."INSTAGIB MODE")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					else
						if cv_instagib.value == 1
							v.drawString(290, 54, (tostring("\x82".."ENABLED")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 54, (tostring("\x82".."DISABLED")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 54, (tostring("INSTAGIB MODE")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					end
					if player.rsp_navmenu.nav == 19
						if cv_rbenabled.value == 1
							v.drawString(290, 64, (tostring("\x82".."< ".."ENABLED".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 64, (tostring("\x82".."< ".."DISABLED".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 64, (tostring("\x82".."RAIL BOOST")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					else
						if cv_rbenabled.value == 1
							v.drawString(290, 64, (tostring("\x82".."ENABLED")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 64, (tostring("\x82".."DISABLED")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 64, (tostring("RAIL BOOST")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					end
					if player.rsp_navmenu.nav == 20
						v.drawString(290, 74, (tostring("\x82".."< "..railboost_power.value.." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						v.drawString(30, 74, (tostring("\x82".."RAIL BOOST POWER")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					else
						v.drawString(290, 74, (tostring("\x82"..railboost_power.value)), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						v.drawString(30, 74, (tostring("RAIL BOOST POWER")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					end
					if player.rsp_navmenu.nav == 21
						if cv_instashield.value == 1
							v.drawString(290, 84, (tostring("\x82".."< ".."ENABLED".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 84, (tostring("\x82".."< ".."DISABLED".." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 84, (tostring("\x82".."ALLOW INSTASHIELD")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					else
						if cv_instashield.value == 1
							v.drawString(290, 84, (tostring("\x82".."ENABLED")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						else
							v.drawString(290, 84, (tostring("\x82".."DISABLED")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						end
						v.drawString(30, 84, (tostring("ALLOW INSTASHIELD")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					end
					v.drawString(20, 102, (tostring("\x82".."DUEL ARENA")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					v.drawFill(20, 111, 281, 2, 31|V_SNAPTOTOP)
					v.drawFill(20, 111, 280, 1, 74|V_SNAPTOTOP)
					if player.rsp_navmenu.nav == 22
						v.drawString(290, 114, (tostring("\x82".."< "..cv_rsplimitpa.value.." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						v.drawString(30, 114, (tostring("\x82".."LIMIT POINT")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					else
						v.drawString(290, 114, (tostring("\x82"..cv_rsplimitpa.value)), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						v.drawString(30, 114, (tostring("LIMIT POINT")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					end
					if player.rsp_navmenu.nav == 23
						v.drawString(290, 124, (tostring("\x82".."< "..cv_rsplimitta.value.." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						v.drawString(30, 124, (tostring("\x82".."TIME LIMIT")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					else
						v.drawString(290, 124, (tostring("\x82"..cv_rsplimitta.value)), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						v.drawString(30, 124, (tostring("TIME LIMIT")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					end
					v.drawString(20, 142, (tostring("\x82".."FREE FOR ALL")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					v.drawFill(20, 151, 281, 2, 31|V_SNAPTOTOP)
					v.drawFill(20, 151, 280, 1, 74|V_SNAPTOTOP)
					if player.rsp_navmenu.nav == 24
						v.drawString(290, 154, (tostring("\x82".."< "..ffastarterammo.value.." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						v.drawString(30, 154, (tostring("\x82".."START AMMO")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					else
						v.drawString(290, 154, (tostring("\x82"..ffastarterammo.value)), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						v.drawString(30, 154, (tostring("START AMMO")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					end
					v.drawString(20, 172, (tostring("\x82".."HOT POTATO")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					v.drawFill(20, 181, 281, 2, 31|V_SNAPTOTOP)
					v.drawFill(20, 181, 280, 1, 74|V_SNAPTOTOP)
					if player.rsp_navmenu.nav == 25
						v.drawString(290, 184, (tostring("\x82".."< "..cv_explodeplayertimer.value.." >")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						v.drawString(30, 184, (tostring("\x82".."DETONATION TIME")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					else
						v.drawString(290, 184, (tostring("\x82"..cv_explodeplayertimer.value)), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
						v.drawString(30, 184, (tostring("DETONATION TIME")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "left")
					end
					v.drawString(290, 194, (tostring("\x82".."PAGE 3/3")), V_ALLOWLOWERCASE|V_SNAPTOTOP, "right")
				end
			end
		end
	end
end
hud.add(rsp_menu)