 -- RingSlingerPlus
 -- 1-RSP_FFA.lua
 -- 12.07.2023
 -- Sirexer

//Works only on FFA gametypes.
addHook("PlayerThink", function(player)
	if G_IsFFAGametype()
		if player.mo
		and player.mo.valid
		and player.playerstate == PST_LIVE
			player.rsp_infinity = player.powers[pw_infinityring]
			player.rsp_automatic = player.powers[pw_automaticring]
			player.rsp_bounce = player.powers[pw_bouncering]
			player.rsp_scatter = player.powers[pw_scatterring]
			player.rsp_grenade = player.powers[pw_grenadering]
			player.rsp_explosion = player.powers[pw_explosionring]
			player.rsp_rail = player.powers[pw_railring]
			//If a player loses a weapon, it's okay, we'll return it.
			if player.ringweapons != 63
				player.ringweapons = 63
				return true
			end
			//If the player has more ammo, we will reduce to the limit.
			if player.powers[pw_infinityring] >= 401
				player.powers[pw_infinityring] = 400
			end
			if player.powers[pw_automaticring] >= 401
				player.powers[pw_automaticring] = 400
			end
			if player.powers[pw_bouncering] >= 101
				player.powers[pw_bouncering] = 100
			end
			if player.powers[pw_scatterring] >= 51
				player.powers[pw_scatterring] = 50
			end
			if player.powers[pw_grenadering] >= 101
				player.powers[pw_grenadering] = 100
			end
			if player.powers[pw_explosionring] >= 51
				player.powers[pw_explosionring] = 50
			end
			if player.powers[pw_railring] >= 51
				player.powers[pw_railring] = 50
			end
		end
	end
end, MT_PLAYER)

//Getting a weapon upon spawn in game.
addHook("PlayerSpawn", function(player)
	if G_IsFFAGametype()
		if player.mo
		and player.mo.valid
		and player.playerstate == PST_LIVE
			player.rings = 20 * ffastarterammo.value
			player.powers[pw_shield] = SH_PITY
			P_SpawnShieldOrb(player)
			player.powers[pw_infinityring] = 40  * ffastarterammo.value
			player.powers[pw_automaticring] = 40 * ffastarterammo.value
			player.powers[pw_bouncering] = 10 * ffastarterammo.value
			player.powers[pw_scatterring] = 5 * ffastarterammo.value
			player.powers[pw_grenadering] = 10 * ffastarterammo.value
			player.powers[pw_explosionring] = 5 * ffastarterammo.value
			player.powers[pw_railring] = 5 * ffastarterammo.value
		end
	end
end)

//Ammo drops from the player when he dies.
addHook("MobjDeath", function(pmo, mo)
	if gamestate != GS_LEVEL
		return
	end
	if G_IsFFAGametype()
		local mo = P_SpawnMobj(pmo.x, pmo.y, pmo.z + 32*FRACUNIT, MT_PICKUPAMMO)
		mo.rsp_infinity = pmo.player.rsp_infinity
		mo.rsp_automatic = pmo.player.rsp_automatic
		mo.rsp_bounce = pmo.player.rsp_bounce
		mo.rsp_scatter = pmo.player.rsp_scatter
		mo.rsp_grenade = pmo.player.rsp_grenade
		mo.rsp_explosion = pmo.player.rsp_explosion
		mo.rsp_rail = pmo.player.rsp_rail
	end
end, MT_PLAYER)

//Deleting lost panels.
local function FFA_RemLostPanels(mo)
    if G_IsFFAGametype()
		if mo.valid
			if (mo.fuse > 0)
				P_RemoveMobj(mo)
			end
		end
    end
end

addHook("MobjThinker", FFA_RemLostPanels, MT_AUTOPICKUP)
addHook("MobjThinker", FFA_RemLostPanels, MT_BOUNCEPICKUP)
addHook("MobjThinker", FFA_RemLostPanels, MT_SCATTERPICKUP)
addHook("MobjThinker", FFA_RemLostPanels, MT_GRENADEPICKUP)
addHook("MobjThinker", FFA_RemLostPanels, MT_EXPLODEPICKUP)
addHook("MobjThinker", FFA_RemLostPanels, MT_RAILPICKUP)

//XВАТАЙ БЕСПЛАТНО!
addHook("TouchSpecial", function(mo, pmo)
	pmo.player.powers[pw_infinityring] = $ + mo.rsp_infinity
	pmo.player.powers[pw_automaticring] = $ + mo.rsp_automatic
	pmo.player.powers[pw_bouncering] = $ + mo.rsp_bounce
	pmo.player.powers[pw_scatterring] = $ + mo.rsp_scatter
	pmo.player.powers[pw_grenadering] = $ + mo.rsp_grenade
	pmo.player.powers[pw_explosionring] = $ + mo.rsp_explosion
	pmo.player.powers[pw_railring] = $ + mo.rsp_rail
end, MT_PICKUPAMMO)
