 -- RingSlingerPlus
 -- 3-RSP_HeadHunt.lua
 -- 12.07.2023
 -- Sirexer
 
rawset(_G, "player_rspheadhunt", false)
rawset(_G, "rsphh", false)
local time_choosehh = 1*TICRATE
local showplayerhh_text = 0
local headhunt_score = 0
//Choose player and make him HH.
local function RandomPlayerHHChoose()
	if player_rspheadhunt == false
		if time_choosehh > 0
			time_choosehh = $1 - 1
		elseif time_choosehh <= 0
		local prandom = P_RandomRange(1, #RSP.DATA.playertablelive)
			if RSP.DATA.playertablelive[prandom]
			and RSP.DATA.playertablelive[prandom].valid
				player_rspheadhunt = RSP.DATA.playertablelive[prandom].player
				time_choosehh = 1*TICRATE
				showplayerhh_text = 2*TICRATE
			end
		end
	end
end
//Giving score for HeadHunt.
local function GiveScoreForHeadHunt(player)
	for player in players.iterate
		if player.mo
		and player.mo.valid
		and player.playerstate == PST_LIVE
		and player == player_rspheadhunt
			if (leveltime % 35) == 15
				player.headhunt_score = $ + 1
			end
		end
	end
end
//Target for HH.
local function GiveTargetForHeadHunt(player)
	for player in players.iterate
		if rsphh == false
		and player == player_rspheadhunt
			rsphh = P_SpawnMobj(player_rspheadhunt.mo.x, player_rspheadhunt.mo.y, player_rspheadhunt.mo.z + player_rspheadhunt.mo.height + 24*player_rspheadhunt.mo.scale, MT_RSPHEADHUNT)
			rsphh = 1
		end
	end
end

local function HHRemovePlayerHH(player)
	if player_rspheadhunt != false
	and not player_rspheadhunt.valid
		player_rspheadhunt = false
	end
end

//Rules of Damage
addHook("MobjDamage", function(target, inflictor, source, mo, player)
	if not target.player then
		return false
	end
	if inflictor then
		source = inflictor.target
	end
	if gametype == GT_HEADHUNT
	and RSP.DATA.round_ready == true
		if source and source.player
			//The player takes away his status from HeadHunt.
			if target.player == player_rspheadhunt
				player_rspheadhunt = source.player
				for mobj in mobjs.iterate()
					if mobj.type == MT_RSPHEADHUNT
						P_RemoveMobj(mobj)
					end
				end
				rsphh = false
				showplayerhh_text = 2*TICRATE
				source.player.headhunt_score = $ + 5
				/*
				//Damaging the player, if he has rings or shield.
				if target.player.powers[pw_shield] != SH_NONE
					P_DoPlayerPain(target.player, source, inf)
					S_StartSound(target.player.mo, sfx_altdi1)
					target.player.powers[pw_shield] = SH_NONE
					return true
				end
				if target.player.rings != 0
				and target.player.powers[pw_shield] == SH_NONE
					local trings = target.player.rings
					P_DoPlayerPain(target.player, source, inf)
					S_StartSound(target.player.mo, sfx_altow1)
					P_PlayerRingBurst(target.player, trings)
					target.player.rings = 0
				else
					P_KillMobj(target, source, inf)
				end
				return true
				*/
			end
			if source.player == player_rspheadhunt
			and target.player != player_rspheadhunt
				source.player.headhunt_score = $ + 5
				/*
				//Damaging the player, if he has rings or shield.
				if target.player.powers[pw_shield] != SH_NONE
					P_DoPlayerPain(target.player, source, inf)
					S_StartSound(target.player.mo, sfx_altdi1)
					target.player.powers[pw_shield] = SH_NONE
					return true
				end
				if target.player.rings != 0
				and target.player.powers[pw_shield] == SH_NONE
					local trings = target.player.rings
					P_DoPlayerPain(target.player, source, inf)
					S_StartSound(target.player.mo, sfx_altow1)
					P_PlayerRingBurst(target.player, trings)
					target.player.rings = 0
				else
					P_KillMobj(target, source, inf)
				end
				return true
				*/
			end
			//Steal socre from the player, if he hit not on HeadHunt.
			if target.player != player_rspheadhunt
			and source.player != player_rspheadhunt
				P_DoPlayerPain(target.player)
				S_StartSound(target.player.mo, sfx_altdi1)
				CONS_Printf(source.player, "This is not a HeadHunt!")
				S_StartSound(nil, sfx_s3kb2, source.player)
				if source.player.headhunt_score >= 10
					source.player.headhunt_score = $ - 10
				else
					source.player.headhunt_score = 0
				end
				return true
			end
		end
	end
end, MT_PLAYER)
//For HeadHunt
addHook("ThinkFrame", function()
	if gametype == GT_HEADHUNT
	and RSP.DATA.round_ready == true
		//Local functions
		GiveScoreForHeadHunt(player)
		RandomPlayerHHChoose()
		GiveTargetForHeadHunt(player)
		HHRemovePlayerHH(player)
		if showplayerhh_text > 0
			showplayerhh_text = $ - 1
		end
	end
end)

addHook("PlayerThink", function(player, mo)
	if gametype == GT_HEADHUNT
		//Other system of scores.
		if player.headhunt_score == nil
			player.headhunt_score = 0
		end
		if player.headhunt_score != nil
			player.score = player.headhunt_score
		end
		//If player is dead, Take him a HeadHunt.
		if player.mo
		and player.mo.valid
		and player.playerstate == PST_DEAD
			if player == player_rspheadhunt
				player_rspheadhunt = false
			end
		end
		//If player is HeadHunt, HH shoots faster.
		if player.mo
		and player.mo.valid
		and player.playerstate == PST_LIVE
			if player == player_rspheadhunt
				if player.weapondelay != 0
					player.weapondelay = $ - 1
				end
			end
		end
	end
end)
//Teleport target to HH.
addHook("MobjThinker", function(mo)
	if rsphh != false
	and player_rspheadhunt == false
		P_RemoveMobj(mo)
		rsphh = false
	end
	if rsphh != false
	and player_rspheadhunt != false
	and player_rspheadhunt.valid
		for player in players.iterate
			if player.mo
			and player.mo.valid
			and player.playerstate == PST_LIVE
				local z = player_rspheadhunt.mo.z + player_rspheadhunt.mo.height + 16*FRACUNIT
				P_SetOrigin(mo, player_rspheadhunt.mo.x, player_rspheadhunt.mo.y, z)
				return true
			end
		end
	end
end, MT_RSPHEADHUNT)

//The HeadHunt can't jump and spin.
local function RSPHEADHUNT()
	if gametype == GT_HEADHUNT
		for player in players.iterate
			if player.mo
			and player.mo.valid
			and player.playerstate == PST_LIVE
				if player == player_rspheadhunt
					player.pflags = $ | PF_THOKKED
				end
			end
		end
	end
end

addHook("JumpSpecial", RSPHEADHUNT, MT_PLAYER)

local function HeadHuntRSP(v, player, cam)
	if gametype == GT_HEADHUNT
		if showplayerhh_text > 0
			if player == player_rspheadhunt
			and player_rspheadhunt.valid
				v.drawString(RSP.hud[player.rsp_hud].gt_message_x, RSP.hud[player.rsp_hud].gt_message_y, "You're HeadHunt, Watch out!", V_OFFSET, "thin-center")
			end
			if player_rspheadhunt != false
			and player != player_rspheadhunt
			and player_rspheadhunt.valid
				v.drawString(RSP.hud[player.rsp_hud].gt_message_x, RSP.hud[player.rsp_hud].gt_message_y, player_rspheadhunt.name.." is HeadHunt, catch HeadHunt!", V_OFFSET, "thin-center")
			end
		end
	end
end
hud.add(HeadHuntRSP, "game")

local function HeadHuntHHRSP(v, player, cam)
	if gametype == GT_HEADHUNT
		if player_rspheadhunt != false
		and player_rspheadhunt.valid
			v.drawString(160, 184, player_rspheadhunt.name.." is HeadHunt", V_OFFSET, "thin-center")
		end
	end
end
hud.add(HeadHuntHHRSP, "scores")

addHook("MapLoad", function()
	player_rspheadhunt = false
	rsphh = false
	time_choosehh = 1*TICRATE
	showplayerhh_text = 0
	for player in players.iterate do
		player.headhunt_score = 0
	end
end)

addHook("NetVars", function(net)
	player_rspheadhunt = net($)
	rsphh = net($)
	time_choosehh = net($)
	showplayerhh_text = net($)
	headhunt_score = net($)
end)
